c--------------------------------------------------------------------
c phaseMoles
c
c Compute total moles of each phase.
c
c INPUT:
c
c nvec(nSpecies)            Composition vector
c pi                        Total number of phases
c nSpecies                  Total number of species
c phaseIdentity(nSpecies)   Species phase-identity
c
c OUTPUT:
c
c nTot(pi)                  Total number of moles in each phase
c                           (including single-species phases)
c
c--------------------------------------------------------------------

      subroutine phaseMoles(nTot,nvec,pi,nSpecies,phaseIdentity)

      IMPLICIT NONE
      integer nSpecies,pi,phaseIdentity(nSpecies),i,phase
      real*8 nTot(pi),nvec(nSpecies)

      do i = 1,pi
         nTot(i) = 0.0d0
      enddo
      
      do i = 1,nSpecies
         phase = phaseIdentity(i)
         nTot(phase) = nTot(phase) + nvec(i)
      enddo

      return
      end
