      
      subroutine jac(matrix,x,z,g,nSpecies,nComp,nRxn,nMin,
     $     aa,bb,mu0,minList,minIndex,ionprod)

      IMPLICIT NONE
      INTRINSIC exp

      integer n,me,mi,neq,niparam,nrparam
      common /nips_sizes/n,me,mi,neq,niparam,nrparam 

      integer i,j,k,nComp,nSpecies,nRxn,nMin,rowInd,
     $     minList(nRxn),minIndex(nMin)

      real*8 matrix(neq,neq),x(n),g(*),z(*),mu0(nSpecies),bigExp,
     $     smallExp,aa(nComp,nSpecies),bb(nComp),ionprod(nRxn),
     $     sum,zero,one

      parameter (zero = 0.0d0, one = 1.0d0, 
     $     bigExp = 50.0, smallExp = -500.0)


c     Evaluate the secondary unknowns (ionprod)

      call massAction(ionprod,x,aa,mu0,minList,nSpecies,nComp,nRxn)

c ---------------------------------------------------------------
c     (NCOMP) ROWS CORRESPONDING TO MASS-BALANCE
c     THIS PART OF THE JACOBIAN IS SYMMETRIC.
c ---------------------------------------------------------------

c     Derivatives w.r.t. first (nComp) variables

      do i = 1,nComp
         do j = i,nComp
            sum = zero
            do k = 1,nRxn
               if (minList(k).ne.1) then
                  sum = sum + aa(i,nComp+k)*aa(j,nComp+k)*ionprod(k)
               endif
            enddo
            matrix(i,j) = sum
         enddo
      enddo

      do i = 1,nComp
         matrix(i,i) = matrix(i,i) + 
     $        exp(dmin1(bigExp, dmax1(x(i),smallExp)))
      enddo

      do i = 2,nComp
         do j = 1,i-1
            matrix(i,j) = matrix(j,i)
         enddo
      enddo


c     If this is the unconstrained case we are done

      if (mi.eq.0) RETURN


c     Derivatives w.r.t. second set of (nMin) variables

      do i = 1,nComp
         do j = 1,nMin
            matrix(i,nComp+j) = aa(i,nComp+minIndex(j))
         enddo
      enddo

c     Derivatives w.r.t. third set of (nMin) variables

      do i = 1,nComp
         do j = 1,nMin
            matrix(i,nComp+nMin+j) = zero
         enddo
      enddo

c ---------------------------------------------------------------
c     (NMIN) ROWS CORRESPONDING TO THE OPTIMALITY OF MINERALS 
c ---------------------------------------------------------------

      rowInd = nComp

c     Derivatives w.r.t. first (nComp) variables

      do i = 1,nMin
         do j = 1,nComp
            matrix(rowInd+i,j) = aa(j,nComp+minIndex(i))
         enddo
      enddo

c     Derivatives w.r.t. second set of (nMin) variables

      do i = 1,nMin
         do j = 1,nMin
            matrix(rowInd+i,nComp+j) = zero
         enddo
      enddo

c     Derivatives w.r.t. third set of (nMin) variables

      do i = 1,nMin
         do j = 1,nMin
            if (i.eq.j) then
               matrix(rowInd+i,nComp+nMin+j) = one
            else
               matrix(rowInd+i,nComp+nMin+j) = zero
            endif
         enddo
      enddo


c ---------------------------------------------------------------
c     (NMIN) ROWS CORRESPONDING TO COMPLEMENTARITY FOR MINERALS 
c ---------------------------------------------------------------

      rowInd = nComp + nMin

c     Derivatives w.r.t. first (nComp) variables

      do i = 1,nMin
         do j = 1,nComp
            matrix(rowInd+i,j) = zero
         enddo
      enddo

c     Derivatives w.r.t. second set of (nMin) variables

      do i = 1,nMin
         do j = 1,nMin
            if (i.eq.j) then
               matrix(rowInd+i,nComp+j) =  z(i)
            else
               matrix(rowInd+i,nComp+j) =  zero
            endif

         enddo
      enddo

c     Derivatives w.r.t. third set of (nMin) variables

      do i = 1,nMin
         do j = 1,nMin
            if (i.eq.j) then
               matrix(rowInd+i,nComp+nMin+j) = g(i)
            else
               matrix(rowInd+i,nComp+nMin+j) = zero
            endif
         enddo
      enddo


      return
      end	

