      
      subroutine res(residual,x,g,z,mu,nSpecies,nComp,nRxn,nMin,
     $     aa,bb,mu0,minList,minIndex,ionprod)

      IMPLICIT NONE
      INTRINSIC exp

      integer n,me,mi,neq,niparam,nrparam
      common /nips_sizes/n,me,mi,neq,niparam,nrparam 

      integer i,j,nComp,nSpecies,nRxn,nMin,minList(nRxn),
     $     minIndex(nMin),ind

      real*8 residual(neq),x(n),g(*),z(*),mu,mu0(nSpecies),
     $     aa(nComp,nSpecies),bb(nComp),ionprod(nRxn),sum,
     $     bigExp,smallExp

      parameter (bigExp = 50.0, smallExp = -500.0)

c     Evaluate the secondary unknowns (ionprod)

      call massAction(ionprod,x,aa,mu0,minList,nSpecies,nComp,nRxn)

c ---------------------------------------------------------------
c     MASS-BALANCES (NCOMP FIRST ENTRIES)
c ---------------------------------------------------------------

      do j = 1,nComp
         sum = -bb(j) + exp(dmin1(bigExp,dmax1(x(j),smallExp)))
         ind = 0
         do i = 1, nRxn
            if (minList(i).eq.1) then
               ind = ind + 1
               sum = sum + x(nComp+ind)*aa(j,nComp + i)
            else
               sum = sum + ionprod(i)*aa(j,nComp + i)
            endif
         enddo
         residual(j) = sum
      enddo

c ---------------------------------------------------------------
c     OPTIMALITY CONDITIONS FOR MINERALS (nMin ENTRIES)
c ---------------------------------------------------------------

      do i = 1,nMin
         residual(nComp+i) = ionprod(minIndex(i)) + z(i)
      enddo

c ---------------------------------------------------------------
c     COMPLEMENTARITY CONDITIONS FOR MINERALS (nMin ENTRIES)
c ---------------------------------------------------------------

      do i = 1,nMin
         residual(nComp+nMin+i) = g(i)*z(i) - mu
      enddo

c ---------------------------------------------------------------
c     REVERSE THE SIGN OF THE RESIDUAL FOR THE NEWTON STEP
c ---------------------------------------------------------------

      do i = 1,neq
         residual(i) = -residual(i)
      enddo

      return
      end	

