      
      subroutine stopTest(x,nSpecies,nComp,nRxn,nMin,aa,bb,mu0,minList,
     $     minIndex,ionprod,epsConc,tol,converged,constraints)

      IMPLICIT NONE
      INTRINSIC sqrt , exp

      integer n,me,mi,neq,niparam,nrparam
      common /nips_sizes/n,me,mi,neq,niparam,nrparam 

      integer i,j,nComp,nSpecies,nRxn,nMin,minList(nRxn),
     $     minIndex(nMin),ind

      real*8 x(n),mu0(nSpecies),aa(nComp,nSpecies),bb(nComp),
     $     ionprod(nRxn),massj,epsConc,tol,error,zero,pSI,
     $     bigExp,smallExp,low,high

      logical converged,constraints

      parameter (zero = 0.0d0, bigExp = 50.0, smallExp = -500.0)

c
c     Evaluate the secondary unknowns (ionprod)
c

      call massAction(ionprod,x,aa,mu0,minList,nSpecies,nComp,nRxn)

c ---------------------------------------------------------------
c     COMPUTE L2-ERROR OF MASS-BALANCES
c ---------------------------------------------------------------

      error = zero

      do j = 1,nComp
         massj = exp(dmin1(bigExp,dmax1(x(j),smallExp)))
         ind = 0
         do i = 1, nRxn
            if (minList(i).eq.1) then
               ind = ind + 1
               massj = massj + x(nComp+ind)*aa(j,nComp + i)
            else
               massj = massj + ionprod(i)*aa(j,nComp + i)
            endif
         enddo
         error = error + (massj - bb(j))**2
      enddo

      error = sqrt(error)

      converged = (error.le.tol)

c
c     If mass-balance is NOT met, or if this is the only
c     test to be performed, return here.
c      

      if ((.not.converged).or.(.not.constraints)) RETURN

c ---------------------------------------------------------------
c     CHECK OPTIMALITY CONDITIONS FOR MINERALS
c     A mineral is considered at equilibrium if it holds that:
c
c     pSI < tol       (Otherwise, it would be oversaturated)
c
c     and
c
c     pSI > -tol*(1 + 1/(mineral concentration))
c
c      This is essentially saying that a mineral which 
c      is PRESENT, i.e., mineral concentration >> tol must 
c      have a solubility product whose logarithm satisfies
c     
c       -tol =< pSI =< tol
c
c      On the other hand, for a mineral which is ABSENT (<< tol),
c      the approximate inequality 
c
c      -tol/epsConc =< pSI =< tol
c  
c      holds. 
c
c
c     The above inequalities are guaranteed to hold at a solution 
c     that satisfies the user-specified tolerance on the residuals.
c
c     We allow a slightly wider margin as specified by the 
c     multiplicative constants below.
c      
c ---------------------------------------------------------------

      do i = 1,nMin

         pSI  =  ionprod(minIndex(i))
         low  = -1.001*tol*(1.0 + 1.0/x(nComp+i))
         high =  1.001*tol

         converged = converged.and.(low.le.pSI.and.pSI.le.high)

      enddo


      return
      end	

