# 1 "funceval.F"
c--------------------------------------------------------------------
c funceval_RNSF.f 
c
c "Standard interface for function evaluation"
c -------------------------------------------------------------------- 
c
c INPUT 
c
c x                      Independent variables
c iparam                 Integer parameters
c rparam                 Real parameters
c
c OUTPUT:
c 
c f, h, g            Objective function, constraints
c
c
c DESCRIPTION:
c 
c This routine serves the following purposes:
c
c (1) UNPACK integer (iparam) and real (rparam) parameters
c     needed in function evaluation
c 
c (2) Possibly ALLOCATE WORKSPACE for function evaluations
c
c (3) CALL user-supplied routine with the appropriate arguments
c
c ---------------------------------------------------------------

      subroutine funceval(f,h,g,x,iparam,rparam,rwk,dimrwk,iwk,dimiwk)

      IMPLICIT NONE

c     COMMON AREAS FOR NIPS 

      integer n,me,mi,neq,niparam,nrparam
      common /nips_sizes/n,me,mi,neq,niparam,nrparam

c     PROBLEM-INDEPENDENT DECLARATIONS

      integer dimiwk,dimrwk,iparam(niparam),iwk(dimiwk)
      real*8 f,h(*),g(mi),x(n),rparam(nrparam),rwk(dimrwk)

c     OTHER DECLARATIONS

# 60 "funceval.F"

c ---------------------------------------------------------------
c     UNPACK PARAMETERS
c ---------------------------------------------------------------

# 111 "funceval.F"

c ---------------------------------------------------------------
c     CALL SPECIFIC FUNCTION EVALUATION
c ---------------------------------------------------------------

# 127 "funceval.F"
      

      return
      end

