# 1 "gradeval.F"
c--------------------------------------------------------------------
c  gradeval_RNSF.f
c
c "Standard interface for gradient evaluation"
c --------------------------------------------------------------------
c INPUT 
c
c x                      Independent variables
c iparam                 Integer parameters
c rparam                 Real parameters
c
c OUTPUT:
c 
c gradf, gradh, gradg    Gradients of objective function, constraints.
c
c
c DESCRIPTION:
c 
c This routine serves the following purposes:
c
c (1) UNPACK integer (iparam) and real (rparam) parameters
c     needed in gradient evaluation
c 
c (2) Possibly ALLOCATE WORKSPACE for gradient evaluations
c
c (3) CALL user-supplied routine with the appropriate arguments
c
c ---------------------------------------------------------------
      subroutine gradeval(gradf,gradh,gradg,x,iparam,rparam,
     $     rwk,dimrwk,iwk,dimiwk)

      IMPLICIT NONE

c     COMMON AREAS FOR NIPS 

      integer n,me,mi,neq,niparam,nrparam
      common /nips_sizes/n,me,mi,neq,niparam,nrparam

c     PROBLEM-INDEPENDENT DECLARATIONS

      integer dimiwk,dimrwk,iparam(niparam),iwk(dimiwk)
      real*8 gradf(n),gradh(n,*),gradg(n,mi),x(n),
     $     rparam(nrparam),rwk(dimrwk)
      
c     OTHER DECLARATIONS

# 60 "gradeval.F"

c ---------------------------------------------------------------
c     UNPACK PARAMETERS
c ---------------------------------------------------------------
# 110 "gradeval.F"
 
c ---------------------------------------------------------------
c     CALL SPECIFIC GRADIENT EVALUATION
c ---------------------------------------------------------------
# 124 "gradeval.F"

      return
      end

