# 1 "hleval.F"
c--------------------------------------------------------------------
c hleval_RNSF.f
c
c Standard interface for analytic evaluation of the Hessian
c of the Lagrangian.
c -------------------------------------------------------------------- 
c
c INPUT 
c
c x                      Independent variables
c y,z                    Lagrange Multipliers
c iparam                 Integer parameters
c rparam                 Real parameters
c
c OUTPUT:
c 
c hessl
c
c DESCRIPTION:
c 
c This routine serves the following purposes:
c
c (1) UNPACK integer (iparam) and real (rparam) parameters
c     needed in Hessian evaluation
c 
c (2) Possibly ALLOCATE WORKSPACE for Hessian evaluation
c
c (3) CALL user-supplied routine with the appropriate arguments
c
c ---------------------------------------------------------------
      subroutine hleval(hessl,x,y,z,iparam,rparam,rwk,dimrwk,iwk,dimiwk)

      IMPLICIT NONE

c     COMMON AREAS FOR NIPS 

      integer n,me,mi,neq,niparam,nrparam
      common /nips_sizes/n,me,mi,neq,niparam,nrparam

c     PROBLEM-INDEPENDENT DECLARATIONS

      integer dimiwk,dimrwk,iparam(niparam),iwk(dimiwk)
      real*8 hessl(n,n),x(n),y(*),z(mi),rparam(nrparam),rwk(dimrwk)

c     OTHER DECLARATIONS
# 58 "hleval.F"

c ---------------------------------------------------------------
c     UNPACK PARAMETERS 
c ---------------------------------------------------------------
# 121 "hleval.F"

c ---------------------------------------------------------------
c     CALL SPECIFIC HESSIAN EVALUATION ROUTINE
c ---------------------------------------------------------------

# 136 "hleval.F"

      return
      end

