c--------------------------------------------------------------------
c conversion
c
c transform from a global array of molar concentrations into the
c corresponding mole numbers (or from moles to molar conc.)
c Used before/after equilibration of IC. 
c     
c INPUTS/OUTPUT
c
c globalMolar(*,*,*,nSpecies)
c globalMoles(n1,n2,n3,nSpecies)
c
c EXTERNAL ROUTINES:
c
c evalRxnVolInt
c
c-----------------------------------------------------------------------
c     
      subroutine conversion(globalMoles,globalMolar,x1,x2,x3,n1,n2,n3,
     $     pad1,pad2,pad3,nSpecies,time,jobNr)

      IMPLICIT NONE

      integer i1,i2,i3,k,n1,n2,n3,pad1,pad2,pad3,nSpecies,jobNr
      real*8 x1(n1+1),x2(n2+1),x3(n3+1),globalMoles(n1,n2,n3,nSpecies),
     $     time,volWater
      real*4 globalMolar(-pad1:n1+pad1+1,-pad2:n2+pad2+1,
     $     -pad3:n3+pad3+1,nSpecies)
      real*8 evalRxnVolInt

      if (jobNr.eq.0) then
         do i1 = 1,n1
            do i2 = 1,n2
               do i3 = 1,n3
                  volWater = evalRxnVolInt(x1(i1),x2(i2),x3(i3),time)
                  do k = 1,nSpecies
                     globalMoles(i1,i2,i3,k) = 
     $                    volWater*dble(globalMolar(i1,i2,i3,k))
                  enddo
               enddo
            enddo
         enddo
      else
         do i1 = 1,n1
            do i2 = 1,n2
               do i3 = 1,n3
                  volWater = evalRxnVolInt(x1(i1),x2(i2),x3(i3),time)
                  do k = 1,nSpecies
                     globalMolar(i1,i2,i3,k) = 
     $                    real(globalMoles(i1,i2,i3,k))/volWater
                  enddo
               enddo
            enddo
         enddo
      endif


      return
      end
