#ifndef _REACTION_H
#define _REACTION_H

#include "../../Main/driverGlobals.h"
#include "../../Transport/transport.h"
#include "../../Transport/transportGlobals.h"

#define max_(a,b) ( (a) > (b) ) ? (a) : (b)

double dclockX ();

void EqStep( double* _moles, double* _InitGuess, double* EpsConc,
             int* multiphases, int* purephases,int* _nRQ, int* nR,
             int* numphases, int* _nSpecies, int* _nComp, int* Phase_Id, 
             int* _reactionType, int* _iParmEq,
             double* _chemAmatrix, double* _chemVmatrix,
             double* _mu0, double* _compCharge, double* _rParmEq,
             double* _dwk, int* _dimDwk,
             int* _iwk, int* _dimIwk, int* _idebugEQ, int* _debugunit,
             int* iter, int* Error,char* _cRxnpar); 

void OdeDriver( double* _moles, double* _InitGuess, double* newmoles,
                int* _odeAlgType, double* _rates, double* _avgrate,
                double* _refrate, double* EpsConc, double* _time,
                double* _deltat, int* _ntReact, int* switchflag,
                int* multiphases, int* purephases, 
                int* _nRQ, int* _nRK,int* _nR,
                int* _numphases, int* _nSpecies, int* _nComp, int* Phase_Id,
                int* _reactionType, int* reactionTypeSave, int* _iParmEq,
                double* _chemAmatrix, double* _chemVmatrix, double* _mu0,
                double* _kval, double* _ratepow, double* _HalfSatConst,
                double* _compCharge, double* _rParmEq, 
                double* _dwk, int* _dimDwk, int* _iwk, int* _dimIwk,
                int* idebugEQ, int* idebug, int* debugunit, int* ntTaken,
                int* _peakIter, int* _cumIter, int* ierror, char* _cRxnpar);

int reactOneCell( double dt, double* cellmoles, double* cellInitGuess,
                  int* Iter, int* ntTaken, 
                  int debugEq, int debugOde,
                  int kinetic_mode, int equilibrium_mode,
                  int initial_conditions);

int loads( int* nmsg);
 
#endif
