      subroutine orderTensmat(p1,p2,p3,a,b,m1,m2,m3,m)
      implicit none
      integer p1,p2,p3,m1,m2,m3,m
      real*8 a(p1,p2,p3,19),b(*)
c
c     Controls reordering for minimal bandwidth
c
      if (p1*(p2+1)+1.eq.m) then
         m1 = p1
         m2 = p2
         m3 = p3
cta 17 July 2002
c         call WCOPY(p1*p2*p3*19,a,1,b,1)
         call dcopy(p1*p2*p3*19,a,1,b,1)
      else if (p1*(p3+1)+1.eq.m) then
         m1 = p1
         m2 = p3
         m3 = p2
         call swapTensx2x3mat(p1,p2,p3,a,p1,p3,p2,b)
      else if (p2*(p1+1)+1.eq.m) then
         m1 = p2
         m2 = p1
         m3 = p3
         call swapTensx1x2mat(p1,p2,p3,a,p2,p1,p3,b)
      else if (p3*(p2+1)+1.eq.m) then
         m1 = p3
         m2 = p2
         m3 = p1
         call swapTensx1x3mat(p1,p2,p3,a,p3,p2,p1,b)
      else if (p2*(p3+1)+1.eq.m) then
         m1 = p2
         m2 = p3
         m3 = p1
         call swapTensx2x3x1mat(p1,p2,p3,a,p2,p3,p1,b)
      else
         m1 = p3
         m2 = p1
         m3 = p2
         call swapTensx3x1x2mat(p1,p2,p3,a,p3,p1,p2,b) 
      endif
c
      return
      end

      subroutine swapTensx2x3mat(p1,p2,p3,a,m1,m2,m3,b)
      implicit none
      integer p1,p2,p3,m1,m2,m3
      real*8 a(p1,p2,p3,-9:9),b(m1,m2,m3,-9:9)
      integer i1,i2,i3
c
c .... assert(m1=p1,m2=p3,m3=p2)
c
      do i3 = 1,p3
         do i2 = 1,p2
            do i1 = 1,p1
               b(i1,i3,i2,-9) = a(i1,i2,i3,-9)
               b(i1,i3,i2,-8) = a(i1,i2,i3,-4)
               b(i1,i3,i2,-7) = a(i1,i2,i3,-3)
               b(i1,i3,i2,-6) = a(i1,i2,i3,-2)
               b(i1,i3,i2,-5) = a(i1,i2,i3,5)
               b(i1,i3,i2,-4) = a(i1,i2,i3,-8)
               b(i1,i3,i2,-3) = a(i1,i2,i3,-7)
               b(i1,i3,i2,-2) = a(i1,i2,i3,-6)
               b(i1,i3,i2,-1) = a(i1,i2,i3,-1)
               b(i1,i3,i2,0) = a(i1,i2,i3,0)
               b(i1,i3,i2,1) = a(i1,i2,i3,1)
               b(i1,i3,i2,2) = a(i1,i2,i3,6)
               b(i1,i3,i2,3) = a(i1,i2,i3,7)
               b(i1,i3,i2,4) = a(i1,i2,i3,8)
               b(i1,i3,i2,5) = a(i1,i2,i3,-5)
               b(i1,i3,i2,6) = a(i1,i2,i3,2)
               b(i1,i3,i2,7) = a(i1,i2,i3,3)
               b(i1,i3,i2,8) = a(i1,i2,i3,4)
               b(i1,i3,i2,9) = a(i1,i2,i3,9)
            enddo
         enddo
      enddo
      end

      subroutine swapTensx1x2mat(p1,p2,p3,a,m1,m2,m3,b)
      implicit none
      integer p1,p2,p3,m1,m2,m3
      real*8 a(p1,p2,p3,-9:9),b(m1,m2,m3,-9:9)
      integer i1,i2,i3
c
c .... assert(m1=p2,m2=p1,m3=p3)
c
      do i3 = 1,p3
         do i2 = 1,p2
            do i1 = 1,p1
               b(i2,i1,i3,-9) = a(i1,i2,i3,-8)
               b(i2,i1,i3,-8) = a(i1,i2,i3,-9)
               b(i2,i1,i3,-7) = a(i1,i2,i3,-7)
               b(i2,i1,i3,-6) = a(i1,i2,i3,-5)
               b(i2,i1,i3,-5) = a(i1,i2,i3,-6)
               b(i2,i1,i3,-4) = a(i1,i2,i3,-4)
               b(i2,i1,i3,-3) = a(i1,i2,i3,-1)
               b(i2,i1,i3,-2) = a(i1,i2,i3,2)
               b(i2,i1,i3,-1) = a(i1,i2,i3,-3)
               b(i2,i1,i3,0) = a(i1,i2,i3,0)
               b(i2,i1,i3,1) = a(i1,i2,i3,3)
               b(i2,i1,i3,2) = a(i1,i2,i3,-2)
               b(i2,i1,i3,3) = a(i1,i2,i3,1)
               b(i2,i1,i3,4) = a(i1,i2,i3,4)
               b(i2,i1,i3,5) = a(i1,i2,i3,6)
               b(i2,i1,i3,6) = a(i1,i2,i3,5)
               b(i2,i1,i3,7) = a(i1,i2,i3,7)
               b(i2,i1,i3,8) = a(i1,i2,i3,9)
               b(i2,i1,i3,9) = a(i1,i2,i3,8)
            enddo
         enddo
      enddo
      return
      end


      subroutine swapTensx1x3mat(p1,p2,p3,a,m1,m2,m3,b)
      implicit none
      integer p1,p2,p3,m1,m2,m3
      real*8 a(p1,p2,p3,-9:9),b(m1,m2,m3,-9:9)
      integer i1,i2,i3
c
c .... assert(m1=p3,m2=p2,m3=p1)
c
      do i3 = 1,p3
         do i2 = 1,p2
            do i1 = 1,p1
               b(i3,i2,i1,-9) = a(i1,i2,i3,-4)
               b(i3,i2,i1,-8) = a(i1,i2,i3,-8)
               b(i3,i2,i1,-7) = a(i1,i2,i3,-1)
               b(i3,i2,i1,-6) = a(i1,i2,i3,6)
               b(i3,i2,i1,-5) = a(i1,i2,i3,2)
               b(i3,i2,i1,-4) = a(i1,i2,i3,-9)
               b(i3,i2,i1,-3) = a(i1,i2,i3,-3)
               b(i3,i2,i1,-2) = a(i1,i2,i3,5)
               b(i3,i2,i1,-1) = a(i1,i2,i3,-7)
               b(i3,i2,i1,0) = a(i1,i2,i3,0)
               b(i3,i2,i1,1) = a(i1,i2,i3,7)
               b(i3,i2,i1,2) = a(i1,i2,i3,-5)
               b(i3,i2,i1,3) = a(i1,i2,i3,3)
               b(i3,i2,i1,4) = a(i1,i2,i3,9)
               b(i3,i2,i1,5) = a(i1,i2,i3,-2)
               b(i3,i2,i1,6) = a(i1,i2,i3,-6)
               b(i3,i2,i1,7) = a(i1,i2,i3,1)
               b(i3,i2,i1,8) = a(i1,i2,i3,8)
               b(i3,i2,i1,9) = a(i1,i2,i3,4)
            enddo
         enddo
      enddo
      return
      end
c
c
      subroutine swapTensx2x3x1mat(p1,p2,p3,a,m1,m2,m3,b)
      implicit none
      integer p1,p2,p3,m1,m2,m3
      real*8 a(p1,p2,p3,-9:9),b(m1,m2,m3,-9:9)
      integer i1,i2,i3
c
c .... assert(m1=p2,m2=p3,m3=p1)
c
      do i3 = 1,p3
         do i2 = 1,p2
            do i1 = 1,p1
               b(i2,i3,i1,-9) = a(i1,i2,i3,-8)
               b(i2,i3,i1,-8) = a(i1,i2,i3,-4)
               b(i2,i3,i1,-7) = a(i1,i2,i3,-1)
               b(i2,i3,i1,-6) = a(i1,i2,i3,2)
               b(i2,i3,i1,-5) = a(i1,i2,i3,6)
               b(i2,i3,i1,-4) = a(i1,i2,i3,-9)
               b(i2,i3,i1,-3) = a(i1,i2,i3,-7)
               b(i2,i3,i1,-2) = a(i1,i2,i3,-5)
               b(i2,i3,i1,-1) = a(i1,i2,i3,-3)
               b(i2,i3,i1,0) = a(i1,i2,i3,0)
               b(i2,i3,i1,1) = a(i1,i2,i3,3)
               b(i2,i3,i1,2) = a(i1,i2,i3,5)
               b(i2,i3,i1,3) = a(i1,i2,i3,7)
               b(i2,i3,i1,4) = a(i1,i2,i3,9)
               b(i2,i3,i1,5) = a(i1,i2,i3,-6)
               b(i2,i3,i1,6) = a(i1,i2,i3,-2)
               b(i2,i3,i1,7) = a(i1,i2,i3,1)
               b(i2,i3,i1,8) = a(i1,i2,i3,4)
               b(i2,i3,i1,9) = a(i1,i2,i3,8)
            enddo
         enddo
      enddo
      return
      end
c
c
      subroutine swapTensx3x1x2mat(p1,p2,p3,a,m1,m2,m3,b)
      implicit none
      integer p1,p2,p3,m1,m2,m3
      real*8 a(p1,p2,p3,-9:9),b(m1,m2,m3,-9:9)
      integer i1,i2,i3
c
c .... assert(m1=p3,m2=p1,m3=p2)
c
      do i3 = 1,p3
         do i2 = 1,p2
            do i1 = 1,p1
               b(i3,i1,i2,-9) = a(i1,i2,i3,-4)
               b(i3,i1,i2,-8) = a(i1,i2,i3,-9)
               b(i3,i1,i2,-7) = a(i1,i2,i3,-3)
               b(i3,i1,i2,-6) = a(i1,i2,i3,5)
               b(i3,i1,i2,-5) = a(i1,i2,i3,-2)
               b(i3,i1,i2,-4) = a(i1,i2,i3,-8)
               b(i3,i1,i2,-3) = a(i1,i2,i3,-1)
               b(i3,i1,i2,-2) = a(i1,i2,i3,6)
               b(i3,i1,i2,-1) = a(i1,i2,i3,-7)
               b(i3,i1,i2,0) = a(i1,i2,i3,0)
               b(i3,i1,i2,1) = a(i1,i2,i3,7)
               b(i3,i1,i2,2) = a(i1,i2,i3,-6)
               b(i3,i1,i2,3) = a(i1,i2,i3,1)
               b(i3,i1,i2,4) = a(i1,i2,i3,8)
               b(i3,i1,i2,5) = a(i1,i2,i3,2)
               b(i3,i1,i2,6) = a(i1,i2,i3,-5)
               b(i3,i1,i2,7) = a(i1,i2,i3,3)
               b(i3,i1,i2,8) = a(i1,i2,i3,9)
               b(i3,i1,i2,9) = a(i1,i2,i3,4)
            enddo
         enddo
      enddo
c
      return
      end

      subroutine copyTensBands(p1,p2,p3,n,m,A,ABD,sing)
      implicit none
      integer p1,p2,p3,n,m
      real*8 A(n,-9:9)
      real*8 ABD(m,n)
      integer sing
c
      integer i,nn
c
cta 17 July 2002
c      call WCOPY(n*m,0.0d0,0,ABD,1)
      call dcopy(n*m,0.0d0,0,ABD,1)
      do i = 1,n
         ABD(m,i)      = A(i,0)
         ABD(m-1,i)    = A(i,-1)
         ABD(m-p1+1,i) = A(i,-2)
         ABD(m-p1,i)   = A(i,-3)
         ABD(m-p1-1,i) = A(i,-4)
         ABD(2*p1+1,i) = A(i,-5)
         ABD(p1+2,i)   = A(i,-6)
         ABD(p1+1,i)   = A(i,-7)
         ABD(p1,i)     = A(i,-8)
         ABD(1,i)      = A(i,-9)
      enddo
      if (sing .eq. 1) then
         nn = n - (p1*p2 + p1 + 1)
         do i = 1,m-1
            ABD(i,nn) = 0.
         enddo
         do i = nn+1,nn+m-1
            ABD(m-i+nn ,i) = 0.
         enddo
         ABD(m,nn) = 1.
      endif
c
      end

