      subroutine orderTensVec(p1,p2,p3,a,b,m1,m2,m3,m)
      implicit none
      integer p1,p2,p3,m1,m2,m3,m
      real*8 a(p1,p2,p3),b(*)
c
c     Controls reordering of right hand side to correspond with reordering
c     of matrix for minimal bandwidth
c
      if (p1*(p2+1)+1.eq.m) then
         m1 = p1
         m2 = p2
         m3 = p3
cta 17 July 2002
c         call WCOPY(p1*p2*p3,a,1,b,1)
         call dcopy(p1*p2*p3,a,1,b,1)
      else if (p1*(p3+1)+1.eq.m) then
         m1 = p1
         m2 = p3
         m3 = p2
         call swapTensx2x3vec(p1,p2,p3,a,p1,p3,p2,b)
      else if (p2*(p1+1)+1.eq.m) then
         m1 = p2
         m2 = p1
         m3 = p3
         call swapTensx1x2vec(p1,p2,p3,a,p2,p1,p3,b)
      else if (p3*(p2+1)+1.eq.m) then
         m1 = p3
         m2 = p2
         m3 = p1
         call swapTensx1x3vec(p1,p2,p3,a,p3,p2,p1,b)
      else if (p2*(p3+1)+1.eq.m) then
         m1 = p2
         m2 = p3
         m3 = p1
         call swapTensx2x3x1vec(p1,p2,p3,a,p2,p3,p1,b)
      else
         m1 = p3
         m2 = p1
         m3 = p2
         call swapTensx3x1x2vec(p1,p2,p3,a,p3,p1,p2,b) 
      endif
      return
      end


      subroutine swapTensx2x3vec(p1,p2,p3,a,m1,m2,m3,b)
      implicit none
      integer p1,p2,p3,m1,m2,m3
      real*8 a(p1,p2,p3),b(m1,m2,m3)
      integer i1,i2,i3
c
c .... assert(m1=p1,m2=p3,m3=p2)
c
      do i3 = 1,p3
         do i2 = 1,p2
            do i1 = 1,p1
               b(i1,i3,i2) = a(i1,i2,i3)
            enddo
         enddo
      enddo
      end

      subroutine swapTensx1x2vec(p1,p2,p3,a,m1,m2,m3,b)
      implicit none
      integer p1,p2,p3,m1,m2,m3
      real*8 a(p1,p2,p3),b(m1,m2,m3)
      integer i1,i2,i3
c
c .... assert(m1=p2,m2=p1,m3=p3)
c
      do i3 = 1,p3
         do i2 = 1,p2
            do i1 = 1,p1
               b(i2,i1,i3) = a(i1,i2,i3)
            enddo
         enddo
      enddo
      end

      subroutine swapTensx1x3vec(p1,p2,p3,a,m1,m2,m3,b)
      implicit none
      integer p1,p2,p3,m1,m2,m3
      real*8 a(p1,p2,p3),b(m1,m2,m3)
      integer i1,i2,i3
c
c .... assert(m1=p3,m2=p2,m3=p1)
c
      do i3 = 1,p3
         do i2 = 1,p2
            do i1 = 1,p1
               b(i3,i2,i1) = a(i1,i2,i3)
            enddo
         enddo
      enddo
      end

      subroutine swapTensx2x3x1vec(p1,p2,p3,a,m1,m2,m3,b)
      implicit none
      integer p1,p2,p3,m1,m2,m3
      real*8 a(p1,p2,p3),b(m1,m2,m3)
      integer i1,i2,i3
c
c .... assert(m1=p2,m2=p3,m3=p1)
c
      do i3 = 1,p3
         do i2 = 1,p2
            do i1 = 1,p1
               b(i2,i3,i1) = a(i1,i2,i3)
            enddo
         enddo
      enddo
      end

      subroutine swapTensx3x1x2vec(p1,p2,p3,a,m1,m2,m3,b)
      implicit none
      integer p1,p2,p3,m1,m2,m3
      real*8 a(p1,p2,p3),b(m1,m2,m3)
      integer i1,i2,i3
c
c .... assert(m1=p3,m2=p1,m3=p2)
c
      do i3 = 1,p3
         do i2 = 1,p2
            do i1 = 1,p1
               b(i3,i1,i2) = a(i1,i2,i3)
            enddo
         enddo
      enddo
      end
c
      subroutine reorderTensVec(n1,n2,n3,a,b,c,m,df1,df2,df3)
      implicit none
      integer n1,n2,n3,m
      real*8 a(n1,n2,n3),b(*),c(*),df1(n2,n3,2),df2(n1,n3,2),
     m       df3(n1,n2,2)
      integer m1,m2,m3,p1,p2,p3
      integer i
c
c     Controls reordering solution back to original
c
      p1 = n1+2
      p2 = n2+2
      p3 = n3+2
c
      if (p1*(p2+1)+1.eq.m) then
         m1 = p1
         m2 = p2
         m3 = p3
cta 17 July 2002
c         call WCOPY(p1*p2*p3,c,1,b,1)
         call dcopy(p1*p2*p3,c,1,b,1)
         call cutVec(n1,n2,n3,b,a,df1,df2,df3)
      else if (p1*(p3+1)+1.eq.m) then
         m1 = p1
         m2 = p3
         m3 = p2
         call swapTensx2x3vec(m1,m2,m3,c,p1,p2,p3,b)
         call cutVec(n1,n2,n3,b,a,df1,df2,df3)
      else if (p2*(p1+1)+1.eq.m) then
         m1 = p2
         m2 = p1
         m3 = p3
         call swapTensx1x2vec(m1,m2,m3,c,p1,p2,p3,b)
         call cutVec(n1,n2,n3,b,a,df1,df2,df3)
      else if (p3*(p2+1)+1.eq.m) then
         m1 = p3
         m2 = p2
         m3 = p1
         call swapTensx1x3vec(m1,m2,m3,c,p1,p2,p3,b)
         call cutVec(n1,n2,n3,b,a,df1,df2,df3)
      else if (p2*(p3+1)+1.eq.m) then
         m1 = p2
         m2 = p3
         m3 = p1
         call swapTensx3x1x2vec(m1,m2,m3,c,p1,p2,p3,b)
         call cutVec(n1,n2,n3,b,a,df1,df2,df3)
      else
         m1 = p3
         m2 = p1
         m3 = p2
         call swapTensx2x3x1vec(m1,m2,m3,c,p1,p2,p3,b) 
         call cutVec(n1,n2,n3,b,a,df1,df2,df3)
      endif
c
      return
      end
c
c-----------------------------------------------------------------------
c
      subroutine cutVec(n1,n2,n3,b,a,df1,df2,df3)
      implicit none
      integer n1,n2,n3
      real*8 a(n1,n2,n3),b(0:n1+1,0:n2+1,0:n3+1)
      real*8 df1(n2,n3,2),df2(n1,n3,2),df3(n1,n2,2)
      integer i,j,k
c
c     Removes boundary values from solution and stores them in auxiliary 
c     arrays df?
c
      do k = 1,n3
         do j = 1,n2
            do i = 1,n1
               a(i,j,k) = b(i,j,k)
            enddo
         enddo
      enddo
c
      do j = 1,n2
         do i = 1,n1
            df3(i,j,1) = b(i,j,0)
            df3(i,j,2) = b(i,j,n3+1)
         enddo
      enddo
c
      do k = 1,n3
         do i = 1,n1
            df2(i,k,1) = b(i,0,k)
            df2(i,k,2) = b(i,n2+1,k)
         enddo
      enddo
c
      do k = 1, n3
         do j = 1, n2
            df1(j,k,1) = b(0,j,k)
            df1(j,k,2) = b(n1+1,j,k)
         enddo
      enddo
c
      return
      end
