c ...
c ...   Title:  Debugging routines
c ...
c ...   Description:  
c ...   
c ...   Created:        Thu May 28 11:12:43 1992
c ...   Author:         Lawrence Cowsar
c ...           <cowsar@masc28.rice.edu>
c ...   
c ...   LastEditDate:   "Thu May 28 11:12:43 1992"
C     
C ...  $Author: jeaton $
C ...  $Id: debug.f,v 1.1.1.1 1997-02-19 15:12:02-06 jeaton Exp $
C ...  $RCSfile: debug.f,v $
C ...  $Source: /usr/public/SOURCE/pss/Flow/Parcel/debug.f,v $
C  
c
c ... Version $Id: debug.f,v 1.1.1.1 1997-02-19 15:12:02-06 jeaton Exp $
c
c ... Routine: checkOB
c
c ... File:  debug.f
c
c ... Main function:
c     Check Outer Boundary Conditions.
c     Make sure that Outerboundary conditions are 0, which is the case for
c     all boundary type variables in the residual formulation
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     MYNOD :    processor id
c     mynbr :    processor ids of neighbor subdomains, -1 if bdry edge
c     n?    :    number of grid points in each direction
c     l?    :    A variable holding boundary information in which the 
c                outer boundary values should be 0
c     str   :    A string identifying l?
c
c ... Out: 
c     none
c
c ... Interal Variables of note:
c     n(i,j) :  norms of face i,j
c
c ... Comments:
c
      subroutine checkOB(mynod,mynbr,n1,n2,n3,l1,l2,l3,str)
      implicit none
      integer mynod,mynbr(3,2),n1,n2,n3
      real*8 l1(n2,n3,2),l2(n1,n3,2),l3(n1,n2,2)
      character str*(*)
c
      integer i1,i2,i3,i,j
      real*8  n(3,2)
c
      n(1,1) = 0.0d0
      n(1,2) = 0.0d0
      n(2,1) = 0.0d0
      n(2,2) = 0.0d0
      n(3,1) = 0.0d0
      n(3,2) = 0.0d0
      do 10 i3=1,n3
         do 11 i2=1,n2
            n(1,1) = n(1,1) + l1(i2,i3,1)**2
            n(1,2) = n(1,2) + l1(i2,i3,2)**2
 11      continue
 10   continue
c
      do 20 i3=1,n3
         do 21 i1=1,n1
            n(2,1) = n(2,1) + l2(i1,i3,1)**2
            n(2,2) = n(2,2) + l2(i1,i3,2)**2
 21      continue
 20   continue
c      
      do 30 i2=1,n2
         do 31 i1=1,n1
            n(3,1) = n(3,1) + l3(i1,i2,1)**2
            n(3,2) = n(3,2) + l3(i1,i2,2)**2
 31      continue
 30   continue
c
      do 40 i = 1,3
         do 41 j = 1,2
            if ((mynbr(i,j).eq.-1).and.(n(i,j).gt.0.0d0)) then
               write(*,*) 'Check failed: ',str,mynod,i,j,n(i,j),n1,n2,n3
            endif
 41      continue
 40   continue
      return
      end
c

