#define COMMENT(x)

COMMENT(THE CENTER FOR SUBSURFACE MODELING)
COMMENT(PARALLEL SUBSURFACE SIMULATOR (PARSSIM))

COMMENT(This file is generated by a template)

#include <stdio.h>

#include "driverGlobals.h"

COMMENT(Title: dumpDriverGlobals)
COMMENT(Description: Print out the driver input data.)
COMMENT(Inputs:)
COMMENT(file Boolean as to whether to write to the debug files or the screen.)
COMMENT(flag Flag to specify a set of variables to dump.)

void dumpDriverGlobals(int file, int flag) {
  int i;

  if(flag == 1) debugInt(file,"nProcs",&nProcs,1);
  if(flag == 1) debugInt(file,"myProc",&myProc,1);

  if(flag == 1) debugInt(file,"nDom",nDom,3);
  if(flag == 1) debugInt(file,"myDom",myDom,3);
  if(flag == 1) debugInt(file,"myNbr",myNbr,27);

  if(flag == 1) debugInt(file,"computeFlow",&computeFlow,1);
  if(flag == 1) debugInt(file,"steadyFlow",&steadyFlow,1);
  if(flag == 1) debugInt(file,"callTransport",&callTransport,1);
  if(flag == 1) debugInt(file,"computeTransport",&computeTransport,1);
  if(flag == 1) debugInt(file,"computeChemistry",&computeChemistry,1);
  if(flag == 1) debugInt(file,"computeRND",&computeRND,1);
  if(flag == 1) debugInt(file,"computeRXN",&computeRXN,1);

  if(flag == 1) debugDouble(file,"tInitial",&tInitial,1);
  if(flag == 1) debugDouble(file,"tFinal",&tFinal,1);
  if(flag == 1) debugDouble(file,"time_f",&time_f,1);
  if(flag == 1) debugDouble(file,"time_t",&time_t,1);
  if(flag == 1) debugInt(file,"step_f",&step_f,1);
  if(flag == 1) debugInt(file,"step_t",&step_t,1);
  if(flag == 1) debugInt(file,"nStepsMax_f",&nStepsMax_f,1);
  if(flag == 1) debugInt(file,"nStepsMax_t",&nStepsMax_t,1);
  if(flag == 1) debugInt(file,"nStepsMax_t_per_f",&nStepsMax_t_per_f,1);
  if(flag == 1) debugInt(file,"ndtMax_f",&ndtMax_f,1);
  if(flag == 1) debugInt(file,"ndtMax_t",&ndtMax_t,1);
  if(flag == 1) debugDouble(file,"tdtMax_f",tdtMax_f,ndtMax_f);
  if(flag == 1) debugDouble(file,"tdtMax_t",tdtMax_t,ndtMax_t);
  if(flag == 1) debugDouble(file,"dtMax_f",dtMax_f,ndtMax_f);
  if(flag == 1) debugDouble(file,"dtMax_t",dtMax_t,ndtMax_t);

  if(flag == 1) debugInt(file,"runNumber",&runNumber,1);
  if(flag == 1) debugString(file,"runDescription",runDescription);
  if(flag == 1) debugString(file,"outDir",outDir);
  if(flag == 1) debugInt(file,"outFormat3D",&outFormat3D,1);
  if(flag == 1) debugInt(file,"nSpeciesPerOutfile",&nSpeciesPerOutfile,1);
  if(flag == 1) debugInt(file,"initialOut",&initialOut,1);
  if(flag == 1) debugInt(file,"dStepOut_pres",&dStepOut_pres,1);
  if(flag == 1) debugInt(file,"dStepOut_vel",&dStepOut_vel,1);
  if(flag == 1) debugInt(file,"dStepOut_conc",&dStepOut_conc,1);
  if(flag == 1) debugDouble(file,"dtOut_pres",&dtOut_pres,1);
  if(flag == 1) debugDouble(file,"dtOut_vel",&dtOut_vel,1);
  if(flag == 1) debugDouble(file,"dtOut_conc",&dtOut_conc,1);
  if(flag == 1) debugInt(file,"presType_out",&presType_out,1);
  if(flag == 1) debugInt(file,"outFormat1D",&outFormat1D,1);
  if(flag == 1) debugInt(file,"nHistories_t",&nHistories_t,1);
  if(flag == 1) debugInt(file,"histType_t",histType_t,nHistories_t);
  if(flag == 1) debugInt(file,"histIndexLo_t",histIndexLo_t,3*nHistories_t);
  if(flag == 1) debugInt(file,"histIndexHi_t",histIndexHi_t,3*nHistories_t);
  if(flag == 1) debugDouble(file,"histVolFactor_t",histVolFactor_t,nHistories_t);
  if(flag == 1) debugInt(file,"nHistSpecies_t",nHistSpecies_t,nHistories_t);
  if(flag == 1) { int i; for(i=0; i<nHistories_t; i++) debugInt(file,"histSpecie_t",histSpecie_t[i],nHistSpecies_t[i]); }
  if(flag == 1) debugInt(file,"dStepOut_hist_t",dStepOut_hist_t,nHistories_t);
  if(flag == 1) debugDouble(file,"dtOut_hist_t",dtOut_hist_t,nHistories_t);
  if(flag == 1) debugInt(file,"verbosity",&verbosity,1);
  if(flag == 1) debugInt(file,"debug",&debug,1);
  if(flag == 1) debugInt(file,"outFlags_f",outFlags_f,SIZE_OUTFLAGS_F);
  if(flag == 1) debugInt(file,"outFlags_t",outFlags_t,SIZE_OUTFLAGS_T);

  if(flag == 1) debugInt(file,"nx_g",&nx_g,1);
  if(flag == 1) debugInt(file,"ny_g",&ny_g,1);
  if(flag == 1) debugInt(file,"nz_g",&nz_g,1);
  if(flag == 1) debugInt(file,"nx",&nx,1);
  if(flag == 1) debugInt(file,"ny",&ny,1);
  if(flag == 1) debugInt(file,"nz",&nz,1);
  if(flag == 1) debugInt(file,"xOffset_g",xOffset_g,4);
  if(flag == 1) debugInt(file,"yOffset_g",yOffset_g,4);
  if(flag == 1) debugInt(file,"zOffset_g",zOffset_g,4);
  if(flag == 1) debugInt(file,"periodicBC",periodicBC,3);
  if(flag == 1) debugInt(file,"identityMap",&identityMap,1);
  if(flag == 1) debugInt(file,"zIsDepth",&zIsDepth,1);
  if(flag == 1) debugDouble(file,"xp",xp,(nx+1)*(ny+1)*(nz+1));
  if(flag == 1) debugDouble(file,"yp",yp,(nx+1)*(ny+1)*(nz+1));
  if(flag == 1) debugDouble(file,"zp",zp,(nx+1)*(ny+1)*(nz+1));

  if(flag == 1) debugInt(file,"uniformDispersion",&uniformDispersion,1);
  if(uniformDispersion) {
  if(flag == 1) debugDouble(file,"molDiff",&molDiff,1);
  if(flag == 1) debugDouble(file,"longDisp",&longDisp,1);
  if(flag == 1) debugDouble(file,"transDisp",&transDisp,1);
  } else {
  if(flag == 1) debugDouble(file,"molDiffAry",molDiffAry,nx*ny*nz);
  if(flag == 1) debugDouble(file,"longDispAry",longDispAry,nx*ny*nz);
  if(flag == 1) debugDouble(file,"transDispAry",transDispAry,nx*ny*nz);
  }

  if(flag == 1) debugInt(file,"nSpecies",&nSpecies,1);
  if(flag == 1) for(i=0; i<nSpecies; i++) debugString(file,"specieName",specieName[i]);
  if(flag == 1) debugDouble(file,"molecularWeight",molecularWeight,nSpecies);
  if(flag == 1) debugInt(file,"primaryPhase",primaryPhase,nSpecies);
  if(flag == 0) debugDouble(file,"phaseDist",phaseDist,(N_FLOWING_PHASES+1)*nSpecies);
  if(flag == 1 && phaseDist != NULL) for(i=0; i<nSpecies; i++)
    debugDouble(file,"phaseDist",&phaseDist_(0,i),N_FLOWING_PHASES+1);
  if(flag == 1) debugFloat(file,"conc",conc,(nx+2*padx+2)*(ny+2*pady+2)*(nz+2*padz+2)*nSpecies);

  if(flag == 1) debugInt(file,"modelMiscDisp",&modelMiscDisp,1);
  if(flag == 1) debugDouble(file,"viscosityRatio",viscosityRatio,nSpecies);

  if(flag == 1) debugInt(file,"niParmRND",&niParmRND,1);
  if(flag == 1) debugInt(file,"iParmRND",iParmRND,niParmRND);
  if(flag == 1) debugInt(file,"nrParmRND",&nrParmRND,1);
  if(flag == 1) debugDouble(file,"rParmRND",rParmRND,nrParmRND);

  if(flag == 1) debugInt(file,"rxn_nComps",&rxn_nComps,1);
  if(flag == 1) debugInt(file,"rxn_comp",rxn_comp,rxn_nComps);
  if(flag == 1) debugInt(file,"rxn_nMicroSteps",&rxn_nMicroSteps,1);
  if(flag == 1) debugDouble(file,"rxn_tolerance",&rxn_tolerance,1);
  if(flag == 1) debugInt(file,"rxn_nIParams",&rxn_nIParams,1);
  if(flag == 1) debugInt(file,"rxn_iParam",rxn_iParam,rxn_nIParams);
  if(flag == 1) debugInt(file,"rxn_nDParams",&rxn_nDParams,1);
  if(flag == 1) debugDouble(file,"rxn_dParam",rxn_dParam,rxn_nDParams);

  if(flag == 1) debugInt(file,"nBCRegions",&nBCRegions,1);
  if(flag == 0) debugInt(file,"bcRegion1",bcRegion1,2*ny*nz);
  if(flag == 0) debugInt(file,"bcRegion2",bcRegion2,2*nx*nz);
  if(flag == 0) debugInt(file,"bcRegion3",bcRegion3,2*nx*ny);
  if(flag == 1) debugInt(file,"bcRegion1-1",bcRegion1,ny*nz);
  if(flag == 1 && bcRegion1 != NULL) debugInt(file,"bcRegion1-2",&bcRegion1[ny*nz],ny*nz);
  if(flag == 1) debugInt(file,"bcRegion2-1",bcRegion2,nx*nz);
  if(flag == 1 && bcRegion2 != NULL) debugInt(file,"bcRegion2-2",&bcRegion2[nx*nz],nx*nz);
  if(flag == 1) debugInt(file,"bcRegion3-1",bcRegion3,nx*ny);
  if(flag == 1 && bcRegion3 != NULL) debugInt(file,"bcRegion3-2",&bcRegion3[nx*ny],nx*ny);

  if(flag == 1) debugInt(file,"maxnBCInterp_f",&maxnBCInterp_f,1);
  if(flag == 1) debugInt(file,"bcType_f",bcType_f,nBCRegions);
  if(flag == 1) debugInt(file,"nBCInterp_f",nBCInterp_f,nBCRegions);
  if(flag == 1) debugFloat(file,"bc_f[2]",bc_f,2*maxnBCInterp_f*nBCRegions);
  if(flag == 1) debugInt(file,"bcPresType_in",bcPresType_in,nBCRegions);

  if(flag == 1) debugInt(file,"maxnBCInterp_t",&maxnBCInterp_t,1);
  if(flag == 1) debugInt(file,"bcType_t",bcType_t,nBCRegions+2);
  if(flag == 1) debugInt(file,"nBCInterp_t",nBCInterp_t,nSpecies*nBCRegions);
  if(flag == 1) debugFloat(file,"bc_t[2]",bc_t,2*maxnBCInterp_t*nSpecies*nBCRegions);

  if(flag == 1) debugInt(file,"maxIterIF_f",&maxIterIF_f,1);
  if(flag == 1) debugDouble(file,"relTolIF_f",&relTolIF_f,1);
  if(flag == 1) debugDouble(file,"absTolIF_f",&absTolIF_f,1);
  if(flag == 1) debugInt(file,"pcTypeIF_f",&pcTypeIF_f,1);
  if(flag == 1) debugInt(file,"dWorkspace_f",&dWorkspace_f,1);

  if(flag == 1) debugInt(file,"maxIter_t",&maxIter_t,1);
  if(flag == 1) debugDouble(file,"relTol_t",&relTol_t,1);
  if(flag == 1) debugInt(file,"dWorkspace_t",&dWorkspace_t,1);
  if(flag == 1) debugInt(file,"padx",&padx,1);
  if(flag == 1) debugInt(file,"pady",&pady,1);
  if(flag == 1) debugInt(file,"padz",&padz,1);
  if(flag == 1) debugInt(file,"volRefine_t",volRefine_t,3);
  if(flag == 1) debugDouble(file,"cflFactor_t",&cflFactor_t,1);
  if(flag == 1) debugInt(file,"ntCutMax_t",&ntCutMax_t,1);
  if(flag == 1) debugDouble(file,"volTol_t",&volTol_t,1);

  if(flag == 1) debugInt(file,"nSorpTypes",&nSorpTypes,1);
  if(flag == 1) debugInt(file,"sorpType",sorpType,nSpecies);
  if(flag == 1) debugDouble(file,"sorp",sorp,nx*ny*nz*nSorpTypes);

  if(flag == 1) debugDouble(file,"gravity",&gravity,1);
  if(flag == 1) debugDouble(file,"phaseViscosity",&phaseViscosity,1);
  if(flag == 1) debugDouble(file,"phaseDensity",&phaseDensity,1);

  if(flag == 1) debugDouble(file,"porosity",porosity,nx*ny*nz);
  if(flag == 1) debugDouble(file,"perm",perm,6*nx*ny*nz);
  if(flag == 1) debugDouble(file,"facePerm",facePerm,(nx+1)*ny*nz+nx*(ny+1)*nz+nx*ny*(nz+1));
  if(flag == 1) debugInt(file,"permType_in",&permType_in,1);
  if(flag == 1) debugInt(file,"permType",&permType,1);
  if(flag == 1) debugInt(file,"diagMapPerm",&diagMapPerm,1);

  if(flag == 1) debugDouble(file,"pressure",pressure,nx*ny*nz);
  if(flag == 1) debugDouble(file,"velX",velX,(nx+1)*ny*nz);
  if(flag == 1) debugDouble(file,"velY",velY,nx*(ny+1)*nz);
  if(flag == 1) debugDouble(file,"velZ",velZ,nx*ny*(nz+1));

  if(flag == 1) debugDouble(file,"lagrangePresX",lagrangePresX,2*ny*nz);
  if(flag == 1) debugDouble(file,"lagrangePresY",lagrangePresY,2*nx*nz);
  if(flag == 1) debugDouble(file,"lagrangePresZ",lagrangePresZ,2*nx*ny);

  if(flag == 1) debugInt(file,"nWells",&nWells,1);
  if(nWells) {
  if(flag == 1) debugInt(file,"wellType",wellType,nWells);
  if(flag == 1) debugInt(file,"hWellIndex[2]",hWellIndex,2*nWells);
  if(flag == 1) debugInt(file,"zWellIndexLo[2]",zWellIndexLo,2*nWells);
  if(flag == 1) debugInt(file,"zWellIndexHi[2]",zWellIndexHi,2*nWells);

  if(flag == 1) debugInt(file,"maxnWellInterp_f",&maxnWellInterp_f,1);
  if(flag == 1) debugInt(file,"nWellInterp_f",nWellInterp_f,nWells);
  if(flag == 1) debugFloat(file,"wellInj_f[2]",wellInj_f,2*maxnWellInterp_f*nWells);
  if(flag == 1) debugDouble(file,"wellRadius",wellRadius,nWells);
  if(flag == 1) debugDouble(file,"wellPres",wellPres,nWells);

  if(flag == 1) debugInt(file,"maxnWellInterp_t",&maxnWellInterp_t,1);
  if(flag == 1) debugInt(file,"nWellInterp_t",nWellInterp_t,nSpecies*nWells);
  if(flag == 1) debugFloat(file,"wellInj_t[2]",wellInj_t,2*maxnWellInterp_t*nSpecies*nWells);
  }

  if(flag == 1) debugInt(file,"nLeaks",&nLeaks,1);
  if(nLeaks) {
  if(flag == 1) debugInt(file,"leakIndexLo[3]",leakIndexLo,3*nLeaks);
  if(flag == 1) debugInt(file,"leakIndexHi[3]",leakIndexHi,3*nLeaks);

  if(flag == 1) debugInt(file,"maxnLeakInterp",&maxnLeakInterp,1);
  if(flag == 1) debugInt(file,"nLeakInterp",nLeakInterp,nSpecies*nLeaks);
  if(flag == 1) debugFloat(file,"leakRate[2]",leakRate,2*maxnLeakInterp*nSpecies*nLeaks);
  }

  if(flag == 2) debugInt(file,"dimDwk",&dimDwk,1);
  if(flag == 0) debugDouble(file,"dwk",dwk,dimDwk);
  if(flag == 2) debugInt(file,"dimIwk",&dimIwk,1);
  if(flag == 0) debugInt(file,"iwk",iwk,dimIwk);

  if(flag == 2) debugDouble(file,"xpComp",xpComp,nx+2*padx+3);
  if(flag == 2) debugDouble(file,"ypComp",ypComp,ny+2*pady+3);
  if(flag == 2) debugDouble(file,"zpComp",zpComp,nz+2*padz+3);

  if(flag == 2) debugFloat(file,"map",map,3*(nx+3)*(ny+3)*(nz+3));
  if(flag == 2) debugFloat(file,"dMap",dMap,9*(nx+1)*(ny+1)*(nz+1));
  if(flag == 2) debugDouble(file,"jacInv",jacInv,nx*ny*nz);
  if(flag == 2) debugFloat(file,"effIdentity",effIdentity,6*(nx+1)*(ny+1)*(nz+1));
  if(flag == 2) debugDouble(file,"effPorosity",effPorosity,nx*ny*nz);

  if(flag == 2) debugInt(file,"nTraceTypes",&nTraceTypes,1);
  if(flag == 2) debugInt(file,"traceTypes",traceType,nTraceTypes);
  if(flag == 2) debugFloat(file,"totCoef",totCoef,(nx+2*padx)*(ny+2*pady)*(nz+2*padz)*nTraceTypes);

  if(flag == 1) debugInt(file,"nComps",&nComps,1);
  if(flag == 1) debugInt(file,"nProducts",&nProducts,1);
  if(flag == 1) debugInt(file,"chmLoadBalFlag",&chmLoadBalFlag,1);
  if(flag == 1) debugInt(file,"chmMaxIter",&chmMaxIter,1);
  if(flag == 1) debugDouble(file,"chmAbsTol",&chmAbsTol,1);
  if(flag == 1) debugDouble(file,"chmEpsConc",&chmEpsConc,1);
  if(flag == 1) debugInt(file,"chmGuessType",&chmGuessType,1);
  if(flag == 1) debugInt(file,"chmScaleFlag",&chmScaleFlag,1);
  if(flag == 1) debugInt(file,"chmTestSolFlag",&chmTestSolFlag,1);
  if(flag == 1) debugInt(file,"chmInterpFlag",&chmInterpFlag,1);
  if(flag == 1) debugInt(file,"nViol",&nViol,1);
  if(flag == 1) debugDouble(file,"chmAlpha",&chmAlpha,1);
  if(flag == 1) debugInt(file,"hessFlag",&hessFlag,1);
  if(flag == 1) debugDouble(file,"tauMin",&tauMin,1);
  if(flag == 1) debugDouble(file,"chmRho",&chmRho,1);
  if(flag == 1) debugInt(file,"ntReact",&ntReact,1);
  if(flag == 1) debugInt(file,"odeAlgType",&odeAlgType,1);
  if(flag == 1) debugInt(file,"switchFlag",&switchFlag,1);
  if(flag == 1) debugDouble(file,"absTemp",&absTemp,1);
  if(flag == 1) debugDouble(file,"chemPres",&chemPres,1);
  if(flag == 1) debugInt(file,"ideal",&ideal,1);
  if(flag == 1) debugInt(file,"locH",&locH,1);
  if(flag == 1) debugInt(file,"locWater",&locWater,1);
  if(flag == 1) debugInt(file,"chemPhases",&chemPhases,1);
  if(flag == 1) debugDouble(file,"chmPhaseDensity",chmPhaseDensity,chemPhases);
  if(flag == 1) debugDouble(file,"compCharge",compCharge,nComps);
  if(flag == 1) debugString(file,"phaseNames",phaseNames);
  if(flag == 1) debugString(file,"chmSpecieName",chmSpecieName);
  if(flag == 1) debugInt(file,"chmPhaseIdentity",chmPhaseIdentity,nSpecies);
  if(flag == 1) debugDouble(file,"stoich",stoich,nProducts*nComps);
  if(flag == 1) debugInt(file,"reactionType",reactionType,nProducts);
  if(flag == 1) debugInt(file,"nRQ",&nRQ,1);
  if(flag == 1) debugInt(file,"nRK",&nRK,1);
  if(flag == 1) debugInt(file,"nSpeciesInPhase",nSpeciesInPhase,chemPhases);
  if(flag == 1) debugInt(file,"chemPhasePure",&chemPhasePure,1);
  if(flag == 1) debugInt(file,"chemPhaseMulti",&chemPhaseMulti,1);
  if(flag == 1) debugDouble(file,"peqk",peqk,nProducts);
  if(flag == 1) debugDouble(file,"pkf",pkf,nProducts);
  if(flag == 1) debugDouble(file,"pkb",pkb,nProducts);
  if(flag == 1) debugDouble(file,"stoichK",stoichK,nProducts*nComps);
  if(flag == 1) debugDouble(file,"halfSatConst",halfSatConst,nProducts*nComps);
  if(flag == 1) debugDouble(file,"peqkX",peqkX,nProducts);
  if(flag == 1) debugDouble(file,"mu0",mu0,nSpecies);
  if(flag == 1) debugInt(file,"iRxnparSZ",&iRxnparSZ,1);
  if(flag == 1) debugInt(file,"rRxnparSZ",&rRxnparSZ,1);
  if(flag == 1) debugInt(file,"cRxnparSZ",&cRxnparSZ,1);
  if(flag == 1) debugInt(file,"iRxnpar",iRxnpar,iRxnparSZ);
  if(flag == 1) debugDouble(file,"rRxnpar",rRxnpar,rRxnparSZ);
  if(flag == 1) debugString(file,"cRxnpar",cRxnpar);
  if(flag == 1) debugDouble(file,"chemAmatrix",chemAmatrix,nComps*nSpecies);
  if(flag == 1) debugDouble(file,"chemVmatrix",chemVmatrix,nProducts*nSpecies);
  if(flag == 1) debugDouble(file,"kval",kval,2*nProducts);
  if(flag == 1) debugDouble(file,"ratepow",ratepow,nComps*nProducts);
  if(flag == 1) debugInt(file,"dWorkspace_c",&dWorkspace_c,1);
  if(flag == 1) debugInt(file,"iWorkspace_c",&iWorkspace_c,1);
}
