#define COMMENT(x)

COMMENT(THE CENTER FOR SUBSURFACE MODELING)
COMMENT(PARALLEL SUBSURFACE SIMULATOR (PARSSIM))

COMMENT(This file is generated by a template)

#ifndef _DRIVERGLOBALS_H
#define _DRIVERGLOBALS_H

#include "pssGlobals.h"
#include "debug.h"

void dumpDriverGlobals(int file, int flag);

#define nProcs PSS.nProcs
#define myProc PSS.myProc

#define nDom PSS.nDom
#define myDom PSS.myDom
#define myNbr PSS.myNbr
#define myNbr_(i,j,k) myNbr[13 + i + 3*(j + 3*(k))] COMMENT((-1:1,-1:1,-1:1))

#define computeFlow PSS.computeFlow
#define steadyFlow PSS.steadyFlow
#define callTransport PSS.callTransport
#define computeTransport PSS.computeTransport
#define computeChemistry PSS.computeChemistry
#define computeRND PSS.computeRND
#define computeRXN PSS.computeRXN

#define tInitial PSS.tInitial
#define tFinal PSS.tFinal
#define time_f PSS.time_f
#define time_t PSS.time_t
#define step_f PSS.step_f
#define step_t PSS.step_t
#define nStepsMax_f PSS.nStepsMax_f
#define nStepsMax_t PSS.nStepsMax_t
#define nStepsMax_t_per_f PSS.nStepsMax_t_per_f
#define ndtMax_f PSS.ndtMax_f
#define ndtMax_t PSS.ndtMax_t
#define tdtMax_f PSS.tdtMax_f
#define tdtMax_t PSS.tdtMax_t
#define dtMax_f PSS.dtMax_f
#define dtMax_t PSS.dtMax_t

#define runNumber PSS.runNumber
#define runDescription PSS.runDescription
#define outDir PSS.outDir
#define outFormat3D PSS.outFormat3D
#define nSpeciesPerOutfile PSS.nSpeciesPerOutfile
#define initialOut PSS.initialOut
#define dStepOut_pres PSS.dStepOut_pres
#define dStepOut_vel PSS.dStepOut_vel
#define dStepOut_conc PSS.dStepOut_conc
#define dtOut_pres PSS.dtOut_pres
#define dtOut_vel PSS.dtOut_vel
#define dtOut_conc PSS.dtOut_conc
#define presType_out PSS.presType_out
#define outFormat1D PSS.outFormat1D
#define nHistories_t PSS.nHistories_t
#define histType_t PSS.histType_t
#define histIndexLo_t PSS.histIndexLo_t
#define histIndexLo_t_(i,hist) histIndexLo_t[i+3*(hist)] COMMENT((3:nHistories_t))
#define histIndexHi_t PSS.histIndexHi_t
#define histIndexHi_t_(i,hist) histIndexHi_t[i+3*(hist)] COMMENT((3:nHistories_t))
#define histVolFactor_t PSS.histVolFactor_t
#define nHistSpecies_t PSS.nHistSpecies_t
#define histSpecie_t PSS.histSpecie_t
#define histSpecie_t_(i,hist) histSpecie_t[hist][i]
#define dStepOut_hist_t PSS.dStepOut_hist_t
#define dtOut_hist_t PSS.dtOut_hist_t
#define verbosity PSS.verbosity
#define debug PSS.debug
#define outFlags_f PSS.outFlags_f
#define outFlags_t PSS.outFlags_t

#define nx_g PSS.nx_g
#define ny_g PSS.ny_g
#define nz_g PSS.nz_g
#define nx PSS.nx
#define ny PSS.ny
#define nz PSS.nz
#define xOffset_g PSS.xOffset_g
#define yOffset_g PSS.yOffset_g
#define zOffset_g PSS.zOffset_g
#define xOffset_g_(i) xOffset_g[i+1] COMMENT((-1:2))
#define yOffset_g_(j) yOffset_g[j+1] COMMENT((-1:2))
#define zOffset_g_(k) zOffset_g[k+1] COMMENT((-1:2))
#define periodicBC PSS.periodicBC
#define identityMap PSS.identityMap
#define zIsDepth PSS.zIsDepth
#define xp PSS.xp
#define yp PSS.yp
#define zp PSS.zp
#define xp_(i,j,k) xp[i + (nx+1)*(j + (ny+1)*(k))] COMMENT((0:nx,0:ny,0:nz))
#define yp_(i,j,k) yp[i + (nx+1)*(j + (ny+1)*(k))] COMMENT((0:nx,0:ny,0:nz))
#define zp_(i,j,k) zp[i + (nx+1)*(j + (ny+1)*(k))] COMMENT((0:nx,0:ny,0:nz))

#define uniformDispersion PSS.uniformDispersion
#define molDiff PSS.molDiff
#define longDisp PSS.longDisp
#define transDisp PSS.transDisp
#define molDiffAry PSS.molDiffAry
#define longDispAry PSS.longDispAry
#define transDispAry PSS.transDispAry

#define nSpecies PSS.nSpecies
#define specieName PSS.specieName
#define molecularWeight PSS.molecularWeight
#define primaryPhase PSS.primaryPhase
#define phaseDist PSS.phaseDist
#define phaseDist_(phase,specie) \
  phaseDist[phase + (N_FLOWING_PHASES+1)*(specie)]
    COMMENT((0:N_FLOWING_PHASES,nSpecies))
#define conc PSS.conc
#define conc_(i,j,k,specie) \
  conc[i+padx+1 + (nx+2*(padx+1))*(j+pady+1 + (ny+2*(pady+1))*(k+padz+1 + (nz+2*(padz+1))*(specie)))]
    COMMENT((-padx:nx+padx+1, -pady:ny+pady+1,-padz:nz+padz+1,nSpecies))
#define conc_array_(specie) \
  conc[(nx+2*(padx+1))*(ny+2*(pady+1))*(nz+2*(padz+1))*(specie)]

#define modelMiscDisp PSS.modelMiscDisp
#define viscosityRatio PSS.viscosityRatio

#define niParmRND PSS.niParmRND
#define iParmRND PSS.iParmRND
#define nrParmRND PSS.nrParmRND
#define rParmRND PSS.rParmRND

#define rxn_nComps PSS.rxn_nComps
#define rxn_comp PSS.rxn_comp
#define rxn_nMicroSteps PSS.rxn_nMicroSteps
#define rxn_tolerance PSS.rxn_tolerance
#define rxn_nIParams PSS.rxn_nIParams
#define rxn_iParam PSS.rxn_iParam
#define rxn_nDParams PSS.rxn_nDParams
#define rxn_dParam PSS.rxn_dParam

#define nBCRegions PSS.nBCRegions
#define bcRegion1 PSS.bcRegion1
#define bcRegion2 PSS.bcRegion2
#define bcRegion3 PSS.bcRegion3
#define bcRegion1_(j,k,m) bcRegion1[j + ny*(k + nz*(m))] COMMENT((ny,nz,2))
#define bcRegion2_(i,k,m) bcRegion2[i + nx*(k + nz*(m))] COMMENT((nx,nz,2))
#define bcRegion3_(i,j,m) bcRegion3[i + nx*(j + ny*(m))] COMMENT((nx,ny,2))

#define maxnBCInterp_f PSS.maxnBCInterp_f
#define bcType_f PSS.bcType_f
#define bcType_f_(region) bcType_f[(region)-1] COMMENT((1:nBCRegions))
#define nBCInterp_f PSS.nBCInterp_f
#define nBCInterp_f_(region) nBCInterp_f[(region)-1] COMMENT((1:nBCRegions))
#define bc_f PSS.bc_f
#define bc_f_(i,j,region) \
  bc_f[(i) + 2*((j) + maxnBCInterp_f*((region)-1))] COMMENT((2,maxnBCInterp_f,1:nBCRegions))
#define bcPresType_in PSS.bcPresType_in
#define bcPresType_in_(region) bcPresType_in[(region)-1] COMMENT((1:nBCRegions))

#define maxnBCInterp_t PSS.maxnBCInterp_t
#define bcType_t PSS.bcType_t
#define bcType_t_(region) bcType_t[region+1] COMMENT((-1:nBCRegions))
#define nBCInterp_t PSS.nBCInterp_t
#define nBCInterp_t_(specie,region) nBCInterp_t[(specie)+nSpecies*((region)-1)] COMMENT((nSpecies,1:nBCRegions))
#define bc_t PSS.bc_t
#define bc_t_(i,j,specie,region) \
  bc_t[(i) + 2*((j) + maxnBCInterp_t*((specie) + nSpecies*((region)-1)))]
    COMMENT((2,maxnBCInterp_t,nSpecies,nBCRegions))

#define maxIterIF_f PSS.maxIterIF_f
#define relTolIF_f PSS.relTolIF_f
#define absTolIF_f PSS.absTolIF_f
#define pcTypeIF_f PSS.pcTypeIF_f
#define dWorkspace_f PSS.dWorkspace_f

#define maxIter_t PSS.maxIter_t
#define relTol_t PSS.relTol_t
#define dWorkspace_t PSS.dWorkspace_t
#define padx PSS.padx
#define pady PSS.pady
#define padz PSS.padz
#define volRefine_t PSS.volRefine_t
#define cflFactor_t PSS.cflFactor_t
#define ntCutMax_t PSS.ntCutMax_t
#define volTol_t PSS.volTol_t

#define nSorpTypes PSS.nSorpTypes
#define sorpType PSS.sorpType
#define sorp PSS.sorp
#define sorp_(i,j,k,type) sorp[i+nx*(j+ny*(k+nz*(type)))] COMMENT((nx,ny,nz,nSorpTypes))

#define gravity PSS.gravity
#define phaseViscosity PSS.phaseViscosity
#define phaseDensity PSS.phaseDensity

#define porosity PSS.porosity
#define porosity_(i,j,k) porosity[i + nx*(j + ny*(k))] COMMENT((nx,ny,nz))
#define perm PSS.perm
#define perm_(e,i,j,k) perm[e + 6*(i + nx*(j + ny*(k)))] COMMENT((6,nx,ny,nz))
#define PERM_XX 0
#define PERM_XY 1
#define PERM_XZ 2
#define PERM_YY 3
#define PERM_YZ 4
#define PERM_ZZ 5
#define facePerm PSS.facePerm
#define facePermX_(i,j,k) facePerm[(i + (nx+1)*(j + ny*(k)))] COMMENT((nx+1,ny,nz))
#define facePermY_(i,j,k) facePerm[(nx+1)*ny*nz + (i + nx*(j + (ny+1)*(k)))] COMMENT((nx,ny+1,nz))
#define facePermZ_(i,j,k) facePerm[(nx+1)*ny*nz + nx*(ny+1)*nz + (i + nx*(j + ny*(k)))] COMMENT((nx,ny+1,nz))
#define permType_in PSS.permType_in
#define permType PSS.permType
#define diagMapPerm PSS.diagMapPerm

#define pressure PSS.pressure
#define pressure_(i,j,k) pressure[i + nx*(j + ny*(k))] COMMENT((nx,ny,nz))
#define velX PSS.velX
#define velY PSS.velY
#define velZ PSS.velZ
#define velX_(i,j,k) velX[i + (nx+1)*(j + ny*(k))] COMMENT(((nx+1),ny,nz))
#define velY_(i,j,k) velY[i + nx*(j + (ny+1)*(k))] COMMENT((nx,(ny+1),nz))
#define velZ_(i,j,k) velZ[i + nx*(j + ny*(k))] COMMENT((nx,ny,(nz+1)))

#define lagrangePresX PSS.lagrangePresX
#define lagrangePresY PSS.lagrangePresY
#define lagrangePresZ PSS.lagrangePresZ
#define lagrangePresX_(j,k,iside) lagrangePresX[(j) + ny*((k) + nz*(iside))] COMMENT((ny,nz,2))
#define lagrangePresY_(i,k,iside) lagrangePresY[(i) + nx*((k) + nz*(iside))] COMMENT((nx,nz,2))
#define lagrangePresZ_(i,j,iside) lagrangePresZ[(i) + nx*((j) + ny*(iside))] COMMENT((nx,ny,2))

#define nWells PSS.nWells
#define wellType PSS.wellType
#define hWellIndex PSS.hWellIndex
#define hWellIndex_(i,well) hWellIndex[(i) + 2*(well)] COMMENT((2,nWells))
#define zWellIndexLo PSS.zWellIndexLo
#define zWellIndexLo_(i,well) zWellIndexLo[(i) + 2*(well)] COMMENT((2,nWells))
#define zWellIndexHi PSS.zWellIndexHi
#define zWellIndexHi_(i,well) zWellIndexHi[(i) + 2*(well)] COMMENT((2,nWells))

#define maxnWellInterp_f PSS.maxnWellInterp_f
#define nWellInterp_f PSS.nWellInterp_f
#define wellInj_f PSS.wellInj_f
#define wellInj_f_(i,interp,well) \
  wellInj_f[i + 2*(interp + maxnWellInterp_f*(well))]
    COMMENT((2,maxnWellInterp_f,nWells))
#define wellRadius PSS.wellRadius
#define wellPres PSS.wellPres

#define maxnWellInterp_t PSS.maxnWellInterp_t
#define nWellInterp_t PSS.nWellInterp_t
#define nWellInterp_t_(specie,well) \
  nWellInterp_t[specie + nSpecies*(well)] COMMENT((nSpecies,nWells))
#define wellInj_t PSS.wellInj_t
#define wellInj_t_(i,interp,specie,well) \
  wellInj_t[i + 2*(interp + maxnWellInterp_t*(specie + nSpecies*(well)))]
    COMMENT((2,maxnWellInterp_t,nSpecies,nWells))

#define nLeaks PSS.nLeaks
#define leakIndexLo PSS.leakIndexLo
#define leakIndexLo_(i,leak) leakIndexLo[(i) + 3*(leak)] COMMENT((3,nLeaks))
#define leakIndexHi PSS.leakIndexHi
#define leakIndexHi_(i,leak) leakIndexHi[(i) + 3*(leak)] COMMENT((3,nLeaks))

#define maxnLeakInterp PSS.maxnLeakInterp
#define nLeakInterp PSS.nLeakInterp
#define nLeakInterp_(specie,leak) \
  nLeakInterp[specie + nSpecies*(leak)] COMMENT((nSpecies,nLeaks))
#define leakRate PSS.leakRate
#define leakRate_(i,interp,specie,leak) \
  leakRate[i + 2*(interp + maxnLeakInterp*(specie + nSpecies*(leak)))]
    COMMENT((2,maxnLeakInterp,nSpecies,nLeaks))

#define dimDwk PSS.dimDwk
#define dwk PSS.dwk
#define dimIwk PSS.dimIwk
#define iwk PSS.iwk

#define xpComp PSS.xpComp
#define ypComp PSS.ypComp
#define zpComp PSS.zpComp
#define xpComp_(i) xpComp[i+padx+1] COMMENT((-padx-1:nx+padx+1))
#define ypComp_(j) ypComp[j+pady+1] COMMENT((-pady-1:ny+pady+1))
#define zpComp_(k) zpComp[k+padz+1] COMMENT((-padz-1:nz+padz+1))

#define map PSS.map
#define dMap PSS.dMap
#define jacInv PSS.jacInv
#define effIdentity PSS.effIdentity
#define effPorosity PSS.effPorosity
#define map_(m,i,j,k) map[m + 3*(i+1 + (nx+3)*(j+1 + (ny+3)*(k+1)))] COMMENT((3,-1:nx+1,-1:ny+1,-1:nz+1))
#define dMap_(m,n,i,j,k) dMap[m + 3*(n + 3*(i + (nx+1)*(j + (ny+1)*(k))))] COMMENT((3,3,0:nx,0:ny,0:nz))
#define jacInv_(i,j,k) jacInv[i + nx*(j + ny*(k))] COMMENT((nx,ny,nz))
#define effIdentity_(m,i,j,k) effIdentity[m + 6*(i + (nx+1)*(j + (ny+1)*(k)))] COMMENT((6,0:nx,0:ny,0:nz))
#define effPorosity_(i,j,k) effPorosity[i + nx*(j + ny*(k))] COMMENT((nx,ny,nz))

#define nTraceTypes PSS.nTraceTypes
#define traceType PSS.traceType
#define totCoef PSS.totCoef
#define totCoef_(i,j,k,type) \
  totCoef[i+padx + (nx+2*padx)*(j+pady + (ny+2*pady)*(k+padz + (nz+2*padz)*(type)))]
    COMMENT((1-padx:nx+padx,1-pady:ny+pady,1-padz:nz+padz,nTraceTypes))
#define totCoef_array_(type) \
  totCoef[(nx+2*padx)*(ny+2*pady)*(nz+2*padz)*(type)]

#define nComps CHM.nComps
#define nProducts CHM.nProducts
#define chmLoadBalFlag CHM.chmLoadBalFlag
#define chmMaxIter CHM.chmMaxIter
#define chmAbsTol CHM.chmAbsTol
#define chmEpsConc CHM.chmEpsConc
#define chmGuessType CHM.chmGuessType
#define chmScaleFlag CHM.chmScaleFlag
#define chmTestSolFlag CHM.chmTestSolFlag
#define chmInterpFlag CHM.chmInterpFlag
#define nViol CHM.nViol
#define chmAlpha CHM.chmAlpha
#define hessFlag CHM.hessFlag
#define tauMin CHM.tauMin
#define chmRho CHM.chmRho
#define ntReact CHM.ntReact
#define odeAlgType CHM.odeAlgType
#define switchFlag CHM.switchFlag
#define absTemp CHM.absTemp
#define chemPres CHM.chemPres
#define ideal CHM.ideal
#define locH CHM.locH
#define locWater CHM.locWater
#define chemPhases CHM.chemPhases
#define chmPhaseDensity CHM.chmPhaseDensity
#define compCharge CHM.compCharge
#define phaseNames CHM.phaseNames
#define chmSpecieName CHM.chmSpecieName
#define cSIZE 15
#define PhaseNameSZ cSIZE
#define SpecieNameSZ cSIZE
#define phaseNames_(i,j) phaseNames [(i) + PhaseNameSZ*(j)]
#define chmSpecieName_(i,j) chmSpecieName [(i) + SpecieNameSZ*(j)]
#define chmPhaseIdentity CHM.chmPhaseIdentity
#define stoich CHM.stoich
#define stoich_(prod,comp) stoich[(prod) + nProducts*(comp)]
#define reactionType CHM.reactionType
#define nRQ CHM.nRQ
#define nRK CHM.nRK
#define nSpeciesInPhase CHM.nSpeciesInPhase
#define chemPhasePure CHM.chemPhasePure
#define chemPhaseMulti CHM.chemPhaseMulti
#define peqk CHM.peqk
#define pkf CHM.pkf
#define pkb CHM.pkb
#define stoichK CHM.stoichK
#define stoichK_(prod,comp) stoichK[(prod) + nProducts*(comp)]
#define halfSatConst CHM.halfSatConst
#define halfSatConst_(comp,prod) halfSatConst[(comp) + nComps*(prod)]
#define peqkX CHM.peqkX
#define mu0 CHM.mu0
#define iRxnparSZ CHM.iRxnparSZ
#define rRxnparSZ CHM.rRxnparSZ
#define cRxnparSZ CHM.cRxnparSZ
#define iRxnpar CHM.iRxnpar
#define rRxnpar CHM.rRxnpar
#define cRxnpar CHM.cRxnpar
#define cRxnpar_(i,j) cRxnpar[(i) + cSIZE*(j)]
#define chemAmatrix CHM.chemAmatrix
#define chemVmatrix CHM.chemVmatrix
#define kval CHM.kval
#define ratepow CHM.ratepow
#define dWorkspace_c CHM.dWorkspace_c
#define iWorkspace_c CHM.iWorkspace_c

#endif
