#ifndef _FTN_H
#define _FTN_H

#include "bool.h"
#include "float_types.h"

#if (defined(NO_TRAILING_UNDERSCORE))
#  define FORTRAN_NAME(UN,ln) ln
#else
#  define FORTRAN_NAME(UN,ln) ln##_
#endif

#define AdvanceCBar         FORTRAN_NAME(ADVANCECBAR,advancecbar)
void AdvanceCbar(double*,float*,int*,int*,int*,int*,int*,int*);
#define AllocFcnmem    	    FORTRAN_NAME(ALLOCFCNMEM,allocfcnmem)
#define AvgLeakRate         FORTRAN_NAME(AVGLEAKRATE,avgleakrate)
double AvgLeakRate(double*,double*,int*,int*);
#define BarytoNatural  	    FORTRAN_NAME(BARYTONATURAL,barytonatural)
void BarytoNatural(double bary[3], double* xPos, double* yPos, double* zPos);
#define CBCValue       	    FORTRAN_NAME(CBCVALUE,cbcvalue)
#define CGlobals       	    FORTRAN_NAME(CGLOBALS,cglobals)
#define CloseTransDebug     FORTRAN_NAME(CLOSETRANSDEBUG,closetransdebug)
void CloseTransDebug(int*);
#define CSetupMat           FORTRAN_NAME(CSETUPMAT,csetupmat)
void CSetupMat(double*,int*,int*,int*,double*,double*,double*,double*,double*,
	       double*,double*,double*,double*,double*,double*,double*,
	       double*,double*,double*,double*,double*,double*,double*,int*,
	       int*,int*,int*,int*,int*,int*);
#define CSetupRHS           FORTRAN_NAME(CSETUPRHS,csetuprhs)
void CSetupRHS(double*,int*,int*,int*,double*,double*,double*,double*,double*,
	       double*,double*,double*,double*,double*,double*,double*,float*,
	       int*,int*,int*,int*,int*,int*,int*,double*,float*,double*);
#define CWellValue          FORTRAN_NAME(CWELLVALUE,cwellvalue)
#define CflTimeStep         FORTRAN_NAME(CFLTIMESTEP,cfltimestep)
void CflTimeStep(double*,double*,double*,double*,int*,double*,double*,
		 double*,int*,int*,int*,int*,int*,int*);
#define Conversion          FORTRAN_NAME(CONVERSION,conversion)
#define Decay               FORTRAN_NAME(DECAY,decay)
void Decay(double*,double*,int*,double*,int*,int*,int*,double*);
#define DefineTotCoefInt    FORTRAN_NAME(DEFINETOTCOEFINT,definetotcoefint)
void DefineTotCoefInt(double*,double*,double*,double*,double*,double*,double*,
		      double*,int*,int*,int*,int*,int*,int*,int*,double*);
#define DefineTotCoefSimple FORTRAN_NAME(DEFINETOTCOEFSIMPLE,definetotcoefsimple)
void DefineTotCoefSimple(float*,double*,double*,double*,double*,int*,int*,int*,
			 int*,int*,int*,int*,int*,int*);
#define DefineTotConc       FORTRAN_NAME(DEFINETOTCONC,definetotconc)
void DefineTotConc(float*,float*,int*,int*,int*,int*,int*,int*,int*,int*,int*);
#define DefinePrimaryCBar   FORTRAN_NAME(DEFINEPRIMARYCBAR,defineprimarycbar)
void DefinePrimaryCBar(double*,float*,double*,double*,double*,
		       int*,int*,int*,int*,int*,int*,int*,int*);
#define DefineWaterContent  FORTRAN_NAME(DEFINEWATERCONTENT,definewatercontent)
#define Disp                FORTRAN_NAME(DISP,disp)
void  Disp(double*,double*,double*,double*,double*,double*,double*,double*,
	   double*,double*,double*,double*,double*,double*,int*,int*,float*,
	   double*,double*,double*,int*,int*,int*,int*,int*);
#define DispVarD            FORTRAN_NAME(DISPVARD,dispvard)
void  DispVarD(double*,double*,double*,double*,double*,double*,double*,double*,
	   double*,double*,double*,double*,double*,double*,int*,int*,float*,
	   double*,double*,double*,int*,int*,int*,int*,int*);
#define ElementVol          FORTRAN_NAME(ELEMENTVOL,elementvol)
double ElementVol(float*,float*,float*,float*,float*,float*,float*,float*);
#define EqStep              FORTRAN_NAME(EQSTEP,eqstep)
#define EvalCellFace        FORTRAN_NAME(EVALCELLFACE,evalcellface)
double EvalCellFace(double*,double*,double*,int*);
#define EvalCellSize        FORTRAN_NAME(EVALCELLSIZE,evalcellsize)
double EvalCellSize(double*,double*,double*);
#define EvalConc            FORTRAN_NAME(EVALCONC,evalconc)
#define EvalCornerVels 	    FORTRAN_NAME(EVALCORNERVELS,evalcornervels)
bool EvalCornerVels(double*,double*,double*,double*,double(*vel)[8][3]);
#define EvalDispVel         FORTRAN_NAME(EVALDISPVEL,evaldispvel)
#define EvalEffSpeed   	    FORTRAN_NAME(EVALEFFSPEED,evaleffspeed)
void EvalEffSpeed(double(*vel)[3],int*,int*,int*,double*);
#define EvalOneSorp         FORTRAN_NAME(EVALONESORP,evalonesorp)
double EvalOneSorp(double*,double*,double*,int*);
#define EvalOneSorpInt 	    FORTRAN_NAME(EVALONESORPINT,evalonesorpint)
double EvalOneSorpInt(double*,double*,double*,int*);
#define EvalPorSat     	    FORTRAN_NAME(EVALPORSAT,evalporsat)
bool EvalPorSat(double*,double*,double*,double*,double*);
#define EvalPorSatInt  	    FORTRAN_NAME(EVALPORSATINT,evalporsatint)
bool EvalPorSatInt(double*,double*,double*,double*,double*);
#define EvalPorosity   	    FORTRAN_NAME(EVALPOROSITY,evalporosity)
double EvalPorosity(double*,double*,double*);
#define EvalRXNVolInt       FORTRAN_NAME(EVALRXNVOLINT,evalrxnvolint)
#define EvalSorp       	    FORTRAN_NAME(EVALSORP,evalsorp)
bool EvalSorp(double*,double*,double*,double*);
#define EvalSorpInt    	    FORTRAN_NAME(EVALSORPINT,evalsorpint)
bool EvalSorpInt(double*,double*,double*,double*);
#define EvalTotCoef         FORTRAN_NAME(EVALTOTCOEF,evaltotcoef)
#define EvalTotCoefInt      FORTRAN_NAME(EVALTOTCOEFINT,evaltotcoefint)
#define EvalTraceCornerVels FORTRAN_NAME(EVALTRACECORNERVELS,evaltracecornervels)
#define EvalTraceVel        FORTRAN_NAME(EVALTRACEVEL,evaltracevel)
#define EvalVel        	    FORTRAN_NAME(EVALVEL,evalvel)
bool EvalVel(double*,double*,double*,double*,double(*vel)[3]);
#define FCentGrid      	    FORTRAN_NAME(FCENTGRID,fcentgrid)
#define FCentView      	    FORTRAN_NAME(FCENTVIEW,fcentview)
#define FillWellConc        FORTRAN_NAME(FILLWELLCONC,fillwellconc)
void FillWellConc(float*,double*,int*,int*,int*,int*,int*,int*,int*,int*,int*,
		  int*,int*,int*,int*);
#define FreeFcnmem     	    FORTRAN_NAME(FREEFCNMEM,freefcnmem)
#define FreeGrid       	    FORTRAN_NAME(FREEGRID,freegrid)
#define Hassink             FORTRAN_NAME(HASSINK,hassink)
#define Hog                 FORTRAN_NAME(HOG,hog)
void Hog(double*,float*,double*,double*,double*,double*,double*,double*,int*,
	 int*,int*,int*,int*,int*,double*,int*,int*,int*,int*,int*,int*,int*,
	 double*,int*,double*,double*,double*,int*,int*,int*,double*,double*,
	 double*,double*,double*,double*,double*,double*,double*,double*,
	 double*,int*,int*,int*);
#define MakeGrid       	    FORTRAN_NAME(MAKEGRID,makegrid)
#define MapVel       	    FORTRAN_NAME(MAPVEL,mapvel)
void MapVel(double*,double*,double*,float*,double*,double*,double*,
	    int*,int*,int*);
#define MSG_f_Gdmax  	    FORTRAN_NAME(MSG_F_GDMAX,msg_f_gdmax)
#define MSG_f_Gdmax1  	    FORTRAN_NAME(MSG_F_GDMAX1,msg_f_gdmax1)
#define MSG_f_Gdmax2  	    FORTRAN_NAME(MSG_F_GDMAX2,msg_f_gdmax2)
#define MSG_f_Gdmin  	    FORTRAN_NAME(MSG_F_GDMIN,msg_f_gdmin)
#define MSG_f_Gdmin1  	    FORTRAN_NAME(MSG_F_GDMIN1,msg_f_gdmin1)
#define MSG_f_Gdmin2  	    FORTRAN_NAME(MSG_F_GDMIN2,msg_f_gdmin2)
#define MSG_f_Gdsum  	    FORTRAN_NAME(MSG_F_GDSUM,msg_f_gdsum)
#define MSG_f_Gdsum1  	    FORTRAN_NAME(MSG_F_GDSUM1,msg_f_gdsum1)
#define MSG_f_Gdsum2  	    FORTRAN_NAME(MSG_F_GDSUM2,msg_f_gdsum2)
#define MSG_f_Gimax  	    FORTRAN_NAME(MSG_F_GIMAX,msg_f_gimax)
#define MSG_f_Gimax1  	    FORTRAN_NAME(MSG_F_GIMAX1,msg_f_gimax1)
#define MSG_f_Gimax2  	    FORTRAN_NAME(MSG_F_GIMAX2,msg_f_gimax2)
#define MSG_f_Gimin  	    FORTRAN_NAME(MSG_F_GIMIN,msg_f_gimin)
#define MSG_f_Gimin1  	    FORTRAN_NAME(MSG_F_GIMIN1,msg_f_gimin1)
#define MSG_f_Gimin2  	    FORTRAN_NAME(MSG_F_GIMIN2,msg_f_gimin2)
#define MSG_f_Gisum  	    FORTRAN_NAME(MSG_F_GISUM,msg_f_gisum)
#define MSG_f_Gisum1  	    FORTRAN_NAME(MSG_F_GISUM1,msg_f_gisum1)
#define MSG_f_Gisum2  	    FORTRAN_NAME(MSG_F_GISUM2,msg_f_gisum2)
#define MSG_f_Wtime  	    FORTRAN_NAME(MSG_F_WTIME,msg_f_wtime)
#define MyDebugOut          FORTRAN_NAME(MYDEBUGOUT,mydebugout)
void MyDebugOut(int*,int*,double*,int*,int*,int*,int*,int*,
                int*,int*,int*,int*,int*);
#define MyRDebugOut         FORTRAN_NAME(MYRDEBUGOUT,myrdebugout)
void MyRDebugOut(int*,int*,float*,int*,int*,int*,int*,int*,
                 int*,int*,int*,int*,int*);
#define OdeDriver           FORTRAN_NAME(ODEDRIVER,odedriver)
#define OpenTransDebug      FORTRAN_NAME(OPENTRANSDEBUG,opentransdebug)
void OpenTransDebug(int*,int*);
#define PBCValue       	    FORTRAN_NAME(PBCVALUE,pbcvalue)
#define PWellValue     	    FORTRAN_NAME(PWELLVALUE,pwellvalue)
#define PadArray            FORTRAN_NAME(PADARRAY,padarray)
#define PadinFlow           FORTRAN_NAME(PADINFLOW,padinflow)
void PadinFlow(float*,double*,int*,int*,int*,int*,int*,int*,int*,int*,int*,
	       int*,int*,int*);
#define PadStencil          FORTRAN_NAME(PADSTENCIL,padstencil)
#define PadVec              FORTRAN_NAME(PADVEC,padvec)
#define ParcelFlowInit      FORTRAN_NAME(PARCELFLOWINIT,parcelflowinit)
void ParcelFlowInit(int*,int*,int*,int*,int*,double*,double*,int*);
#define ParcelFlow          FORTRAN_NAME(PARCELFLOW,parcelflow)
void ParcelFlow(double*,double*,double*,double*,double*,float*,int*,int*,int*,
		double*,double*,double*,int*,int*,int*,int*,int*,double*,
		double*,double*,double*,double*,double*,int*,int*,int*,int*,
		int*,int*,int*,int*,int*,int*,double*,double*,double*,double*,
		double*,double*,double*,double*,double*,double*,double*,
		double*,int*,double*,double*,float*,int*,int*,int*,int*,
		double*,int*,int*,int*,int*,int*,int*);
#define Pcg                 FORTRAN_NAME(PCG,pcg)
void Pcg(double*,double*,double*,int*,int*,int*,double*,int*,double*,double*,
	 double*,double*,int*,int*,int*,int*);
#define RPadExtFace         FORTRAN_NAME(RPADEXTFACE,rpadextface)
void RPadExtFace(float*,int*,int*,int*,int*,int*,int*,int*,int*,int*,int*);
#define RPadStencil         FORTRAN_NAME(RPADSTENCIL,rpadstencil)
void RPadStencil(float*,int*,int*,int*,int*,int*,int*,int*,int*,int*,int*,
		 int*,int*,int*);
#define ReactionHeader      FORTRAN_NAME(REACTIONHEADER,reactionheader)
void ReactionHeader(int*,double*,double*,int*);

#define RxnReact            FORTRAN_NAME(RXNREACT,rxnreact)
void RxnReact(double*,double*,int*,double*,double*,
              int*,double*,int*,int*,int*);
#define RxnEquil            FORTRAN_NAME(RXNEQUIL,rxnequil)
void RxnEquil(double*,int*,double*,int*,double*,int*,int*,double*,int*);
#define SendPorosData  	    FORTRAN_NAME(SENDPOROSDATA,sendporosdata)
#define SendSorpData   	    FORTRAN_NAME(SENDSORPDATA,sendsorpdata)
#define SendVelPorSatData   FORTRAN_NAME(SENDVELPORSATDATA,sendvelporsatdata)
void SendVelPorSatData(double*,double*,double*,double*,double*);
#define SetCBar             FORTRAN_NAME(SETCBAR,setcbar)
void SetCBar(double*,float*,int*,int*,int*,int*,int*,int*,int*);
#define SetCell             FORTRAN_NAME(SETCELL,setcell)
bool SetCell(double*,double*,double*,double*,int*);
#define SetConc             FORTRAN_NAME(SETCONC,setconc)
void SetConc(float*,double*,int*,int*,int*,int*,int*,int*);
#define SetupBCFlux         FORTRAN_NAME(SETUPBCFLUX,setupbcflux)
void SetupBCFlux(double*,double*,double*,double*,double*,double*,int*,int*,
		 int*,int*,int*,int*,int*,int*,double*);
#define SetupCBCValue       FORTRAN_NAME(SETUPCBCVALUE,setupcbcvalue)
#define SetupCWellValue     FORTRAN_NAME(SETUPCWELLVALUE,setupcwellvalue)
#define SetupMapCoefs       FORTRAN_NAME(SETUPMAPCOEFS,setupmapcoefs)
void SetupMapCoefs(float*,double*,double*,float*,double*,double*,int*,double*,
		   double*,double*,double*,float*,int*,int*,int*,int*,int*);
#define SetupPBCValue       FORTRAN_NAME(SETUPPBCVALUE,setuppbcvalue)
#define SetupPWellValue     FORTRAN_NAME(SETUPPWELLVALUE,setuppwellvalue)
#define Smooth              FORTRAN_NAME(SMOOTH,smooth)
void Smooth(double*,int*,int*,int*);
#define TraceDraw           FORTRAN_NAME(TRACEDRAW,tracedraw)
void TraceDraw(float*,float*,int*,int*,int*,int*,int*,int*,int*,int*,int*);
#define TransportSetup      FORTRAN_NAME(TRANSPORTSETUP,transportsetup)
void TransportSetup(int*,int*,int*,int*,int*,int*,int*,int*,int*,int*,int*,
		    int*,int*,int*,int*,int*,int*,int*,int*,int*,int*,
		    double*,double*,double*,double*,double*,double*,
		    int*,float*,int*,int*,int*,double*,int*,double*,
		    int*,int*,double*,double*,double*,double*,double*);
#define Trilinear           FORTRAN_NAME(TRILINEAR,trilinear)
void Trilinear(conc_t*,double*,int*,int*,int*,int*);
#define UnDefineTotConc     FORTRAN_NAME(UNDEFINETOTCONC,undefinetotconc)
void UnDefineTotConc(float*,float*,int*,int*,int*,int*,int*,int*,
		     int*,int*,int*);
#define UpdateLeaks         FORTRAN_NAME(UPDATELEAKS,updateleaks)
void UpdateLeaks(float*,float*,double*,double*,int*,int*,int*,int*,int*,
		 double*,int*,int*,int*, int*,int*,int*,int*);
#define VtxView             FORTRAN_NAME(VTXVIEW,vtxview)

#endif
