c ROUTINES ASSOCIATED TO THE MAPPING

c=======================================================================
c compute the Jacobian matrix of the map (dMap)

      subroutine setupDMap(map,n1,n2,n3,x1,x2,x3,dMap,mynbr)

      implicit none
      integer n1,n2,n3,mynbr(-1:1,-1:1,-1:1)
      real*4  map(3,-1:n1+1,-1:n2+1,-1:n3+1),dMap(3,3,0:n1,0:n2,0:n3)
      real*8  x1(-1:n1+1),x2(-1:n2+1),x3(-1:n3+1)

      integer i,j,k,nn(3,2)
      real*8  alpha,dxi1,dxi2

      nn(1,1) = 0
      nn(2,1) = 0
      nn(3,1) = 0
      nn(1,2) = n1
      nn(2,2) = n2
      nn(3,2) = n3
      if(mynbr(-1,0,0).eq.-1) nn(1,1) = 1
      if(mynbr( 1,0,0).eq.-1) nn(1,2) = n1-1
      if(mynbr(0,-1,0).eq.-1) nn(2,1) = 1
      if(mynbr(0, 1,0).eq.-1) nn(2,2) = n2-1
      if(mynbr(0,0,-1).eq.-1) nn(3,1) = 1
      if(mynbr(0,0, 1).eq.-1) nn(3,2) = n3-1

      do 10 k = 0,n3
      do 10 j = 0,n2
      do 10 i = nn(1,1),nn(1,2)
         alpha = (x1(i) - x1(i-1)) / (x1(i+1) - x1(i-1))
         dxi2 = 1. / (x1(i+1) - x1(i))
         dxi1 = 1. / (x1(i) - x1(i-1))
         dMap(1,1,i,j,k) = alpha*(map(1,i+1,j,k) - map(1,i,j,k))*dxi2
     $        + (1. - alpha)*(map(1,i,j,k) - map(1,i-1,j,k))*dxi1
         dMap(2,1,i,j,k) = alpha*(map(2,i+1,j,k) - map(2,i,j,k))*dxi2
     $        + (1. - alpha)*(map(2,i,j,k) - map(2,i-1,j,k))*dxi1
         dMap(3,1,i,j,k) = alpha*(map(3,i+1,j,k) - map(3,i,j,k))*dxi2
     $        + (1. - alpha)*(map(3,i,j,k) - map(3,i-1,j,k))*dxi1
 10   continue

      do 20 k = 0,n3
      do 20 j = nn(2,1),nn(2,2)
      do 20 i = 0,n1
         alpha = (x2(j) - x2(j-1)) / (x2(j+1) - x2(j-1))
         dxi2 = 1. / (x2(j+1) - x2(j))
         dxi1 = 1. / (x2(j) - x2(j-1))
         dMap(1,2,i,j,k) = alpha*(map(1,i,j+1,k) - map(1,i,j,k))*dxi2
     $        + (1. - alpha)*(map(1,i,j,k) - map(1,i,j-1,k))*dxi1
         dMap(2,2,i,j,k) = alpha*(map(2,i,j+1,k) - map(2,i,j,k))*dxi2
     $        + (1. - alpha)*(map(2,i,j,k) - map(2,i,j-1,k))*dxi1
         dMap(3,2,i,j,k) = alpha*(map(3,i,j+1,k) - map(3,i,j,k))*dxi2
     $        + (1. - alpha)*(map(3,i,j,k) - map(3,i,j-1,k))*dxi1
 20   continue

      do 30 k = nn(3,1),nn(3,2)
      do 30 j = 0,n2
      do 30 i = 0,n1
         alpha = (x3(k) - x3(k-1)) / (x3(k+1) - x3(k-1))
         dxi2 = 1. / (x3(k+1) - x3(k))
         dxi1 = 1. / (x3(k) - x3(k-1))
         dMap(1,3,i,j,k) = alpha*(map(1,i,j,k+1) - map(1,i,j,k))*dxi2
     $        + (1. - alpha)*(map(1,i,j,k) - map(1,i,j,k-1))*dxi1
         dMap(2,3,i,j,k) = alpha*(map(2,i,j,k+1) - map(2,i,j,k))*dxi2
     $        + (1. - alpha)*(map(2,i,j,k) - map(2,i,j,k-1))*dxi1
         dMap(3,3,i,j,k) = alpha*(map(3,i,j,k+1) - map(3,i,j,k))*dxi2
     $        + (1. - alpha)*(map(3,i,j,k) - map(3,i,j,k-1))*dxi1
 30   continue

c-----------------------------------------------------------------------
c linear extrapolation on the true boundary faces

c left and right faces

      if( (nn(1,1).eq.1).and.(nn(1,2).eq.0) ) then
         do 95 k = 0,n3
         do 95 j = 0,n2
            dxi1 = 1. / (x1(1) - x1(0))
            dMap(1,1,0,j,k) = (map(1,1,j,k) - map(1,0,j,k))*dxi1
            dMap(2,1,0,j,k) = (map(2,1,j,k) - map(2,0,j,k))*dxi1
            dMap(3,1,0,j,k) = (map(3,1,j,k) - map(3,0,j,k))*dxi1
            dMap(1,1,1,j,k) = (map(1,1,j,k) - map(1,0,j,k))*dxi1
            dMap(2,1,1,j,k) = (map(2,1,j,k) - map(2,0,j,k))*dxi1
            dMap(3,1,1,j,k) = (map(3,1,j,k) - map(3,0,j,k))*dxi1
 95      continue
      else
         if (nn(1,1).eq.1) then
            do 100 k = 0,n3
            do 100 j = 0,n2
               alpha = (x1(0) - x1(1)) / (x1(2) - x1(0))
               dxi2 = 1. / (x1(2) - x1(1))
               dxi1 = 1. / (x1(1) - x1(0))
               dMap(1,1,0,j,k) = 
     $              alpha*(map(1,2,j,k) - map(1,1,j,k))*dxi2
     $              + (1. - alpha)*(map(1,1,j,k) - map(1,0,j,k))*dxi1
               dMap(2,1,0,j,k) = 
     $              alpha*(map(2,2,j,k) - map(2,1,j,k))*dxi2
     $              + (1. - alpha)*(map(2,1,j,k) - map(2,0,j,k))*dxi1
               dMap(3,1,0,j,k) = 
     $              alpha*(map(3,2,j,k) - map(3,1,j,k))*dxi2
     $              + (1. - alpha)*(map(3,1,j,k) - map(3,0,j,k))*dxi1
 100        continue
         endif
         if (nn(1,2).eq.n1-1) then
            do 110 k = 0,n3
            do 110 j = 0,n2
               alpha = (x1(n1-1) - x1(n1)) / (x1(n1) - x1(n1-2))
               dxi2 = 1. / (x1(n1) - x1(n1-1))
               dxi1 = 1. / (x1(n1-1) - x1(n1-2))
               dMap(1,1,n1,j,k) = 
     $              alpha*(map(1,n1-1,j,k)-map(1,n1-2,j,k))*dxi1
     $              + (1.-alpha)*(map(1,n1,j,k) - map(1,n1-1,j,k))*dxi2
               dMap(2,1,n1,j,k) = 
     $              alpha*(map(2,n1-1,j,k)-map(2,n1-2,j,k))*dxi1
     $              + (1.-alpha)*(map(2,n1,j,k) - map(2,n1-1,j,k))*dxi2
               dMap(3,1,n1,j,k) = 
     $              alpha*(map(3,n1-1,j,k)-map(3,n1-2,j,k))*dxi1
     $              + (1.-alpha)*(map(3,n1,j,k) - map(3,n1-1,j,k))*dxi2
 110        continue
         endif
      endif

c front and back faces

      if( (nn(2,1).eq.1).and.(nn(2,2).eq.0) ) then
         do 115 k = 0,n3
         do 115 i = 0,n1
            dxi1 = 1. / (x2(1) - x2(0))
            dMap(1,2,i,0,k) = (map(1,i,1,k) - map(1,i,0,k))*dxi1
            dMap(2,2,i,0,k) = (map(2,i,1,k) - map(2,i,0,k))*dxi1
            dMap(3,2,i,0,k) = (map(3,i,1,k) - map(3,i,0,k))*dxi1
            dMap(1,2,i,1,k) = (map(1,i,1,k) - map(1,i,0,k))*dxi1
            dMap(2,2,i,1,k) = (map(2,i,1,k) - map(2,i,0,k))*dxi1
            dMap(3,2,i,1,k) = (map(3,i,1,k) - map(3,i,0,k))*dxi1
 115     continue
      else
         if (nn(2,1).eq.1) then
            do 120 k = 0,n3
            do 120 i = 0,n1
               alpha = (x2(0) - x2(1)) / (x2(2) - x2(0))
               dxi2 = 1. / (x2(2) - x2(1))
               dxi1 = 1. / (x2(1) - x2(0))
               dMap(1,2,i,0,k) =
     $              alpha*(map(1,i,2,k) - map(1,i,1,k))*dxi2
     $              + (1.-alpha)*(map(1,i,1,k) - map(1,i,0,k))*dxi1
               dMap(2,2,i,0,k) = 
     $              alpha*(map(2,i,2,k) - map(2,i,1,k))*dxi2
     $              + (1.-alpha)*(map(2,i,1,k) - map(2,i,0,k))*dxi1
               dMap(3,2,i,0,k) = 
     $              alpha*(map(3,i,2,k) - map(3,i,1,k))*dxi2
     $              + (1.-alpha)*(map(3,i,1,k) - map(3,i,0,k))*dxi1
 120        continue
         endif
         if (nn(2,2).eq.n2-1) then
            do 130 k = 0,n3
            do 130 i = 0,n1
               alpha = (x2(n2-1) - x2(n2)) / (x2(n2) - x2(n2-2))
               dxi2 = 1. / (x2(n2) - x2(n2-1))
               dxi1 = 1. / (x2(n2-1) - x2(n2-2))
               dMap(1,2,i,n2,k) = 
     $              alpha*(map(1,i,n2-1,k)-map(1,i,n2-2,k))*dxi1
     $              + (1.-alpha)*(map(1,i,n2,k) - map(1,i,n2-1,k))*dxi2
               dMap(2,2,i,n2,k) = 
     $              alpha*(map(2,i,n2-1,k)-map(2,i,n2-2,k))*dxi1
     $              + (1.-alpha)*(map(2,i,n2,k) - map(2,i,n2-1,k))*dxi2
               dMap(3,2,i,n2,k) = 
     $              alpha*(map(3,i,n2-1,k)-map(3,i,n2-2,k))*dxi1
     $              + (1.-alpha)*(map(3,i,n2,k) - map(3,i,n2-1,k))*dxi2
 130        continue
         endif
      endif

c top and bottom faces

      if( (nn(3,1).eq.1).and.(nn(3,2).eq.0) ) then
         do 135 j = 0,n2
         do 135 i = 0,n1
            dxi1 = 1. / (x3(1) - x3(0))
            dMap(1,3,i,j,0) = (map(1,i,j,1) - map(1,i,j,0))*dxi1
            dMap(2,3,i,j,0) = (map(2,i,j,1) - map(2,i,j,0))*dxi1
            dMap(3,3,i,j,0) = (map(3,i,j,1) - map(3,i,j,0))*dxi1
            dMap(1,3,i,j,1) = (map(1,i,j,1) - map(1,i,j,0))*dxi1
            dMap(2,3,i,j,1) = (map(2,i,j,1) - map(2,i,j,0))*dxi1
            dMap(3,3,i,j,1) = (map(3,i,j,1) - map(3,i,j,0))*dxi1
 135     continue
      else
         if (nn(3,1).eq.1) then
            do 140 j = 0,n2
            do 140 i = 0,n1
               alpha = (x3(0) - x3(1))/(x3(2) - x3(0))
               dxi2 = 1. / (x3(2) - x3(1))
               dxi1 = 1. / (x3(1) - x3(0))
               dMap(1,3,i,j,0) = 
     $              alpha*(map(1,i,j,2) - map(1,i,j,1))*dxi2
     $              + (1. - alpha)*(map(1,i,j,1) - map(1,i,j,0))*dxi1
               dMap(2,3,i,j,0) = 
     $              alpha*(map(2,i,j,2) - map(2,i,j,1))*dxi2
     $              + (1. - alpha)*(map(2,i,j,1) - map(2,i,j,0))*dxi1
               dMap(3,3,i,j,0) = 
     $              alpha*(map(3,i,j,2) - map(3,i,j,1))*dxi2
     $              + (1. - alpha)*(map(3,i,j,1) - map(3,i,j,0))*dxi1
 140        continue
         endif
         if (nn(3,2).eq.n3-1) then
            do 150 j = 0,n2
            do 150 i = 0,n1
               alpha = (x3(n3-1) - x3(n3))/(x3(n3) - x3(n3-2))
               dxi2 = 1. / (x3(n3) - x3(n3-1))
               dxi1 = 1. / (x3(n3-1) - x3(n3-2))
               dMap(1,3,i,j,n3) = 
     $              alpha*(map(1,i,j,n3-1)-map(1,i,j,n3-2))*dxi1
     $              + (1.-alpha)*(map(1,i,j,n3) - map(1,i,j,n3-1))*dxi2
               dMap(2,3,i,j,n3) = 
     $              alpha*(map(2,i,j,n3-1)-map(2,i,j,n3-2))*dxi1
     $              + (1.-alpha)*(map(2,i,j,n3) - map(2,i,j,n3-1))*dxi2
               dMap(3,3,i,j,n3) = 
     $              alpha*(map(3,i,j,n3-1)-map(3,i,j,n3-2))*dxi1
     $              + (1.-alpha)*(map(3,i,j,n3) - map(3,i,j,n3-1))*dxi2
 150        continue
         endif
      endif

      return
      end
c=======================================================================
c Compute the determinant of the Jacobian matrix dMap

      subroutine computeJac(n1,n2,n3,map,x1,x2,x3,jac)

      implicit none
      integer n1,n2,n3
      real*4  map(3,-1:n1+1,-1:n2+1,-1:n3+1)
      real*8  x1(-1:n1+1),x2(-1:n2+1),x3(-1:n3+1)
      real*8  jac(n1,n2,n3)

      integer i,j,k
      real*8  elementVol
ccc:
c      real*8  aDet
c      integer m,n,p
c      aDet(m,n,p) = abs(
c     $       dMap(1,1,m,n,p)*dMap(2,2,m,n,p)*dMap(3,3,m,n,p)
c     $     + dMap(2,1,m,n,p)*dMap(3,2,m,n,p)*dMap(1,3,m,n,p)
c     $     + dMap(1,2,m,n,p)*dMap(2,3,m,n,p)*dMap(3,1,m,n,p)
c     $     - dMap(1,3,m,n,p)*dMap(2,2,m,n,p)*dMap(3,1,m,n,p)
c     $     - dMap(2,1,m,n,p)*dMap(1,2,m,n,p)*dMap(3,3,m,n,p)
c     $     - dMap(1,1,m,n,p)*dMap(2,3,m,n,p)*dMap(3,2,m,n,p) )
ccc.

c-----------------------------------------------------------------------
c Jacobian

      do 10 k = 1,n3
      do 10 j = 1,n2
      do 10 i = 1,n1
         jac(i,j,k) = elementVol(
     $        map(1,i-1,j-1,k-1),map(1,i,j-1,k-1),
     $        map(1,i,j,k-1),map(1,i-1,j,k-1),map(1,i-1,j-1,k),
     $        map(1,i,j-1,k),map(1,i,j,k),map(1,i-1,j,k) )
     $        / ((x1(i) - x1(i-1))*(x2(j) - x2(j-1))*(x3(k) - x3(k-1)))
ccc:
c         jac(i,j,k) = 0.125*
c     $        ( aDet(i-1,j-1,k-1) + aDet(i,j-1,k-1)
c     $        + aDet(i-1,j,k-1) + aDet(i,j,k-1)
c     $        + aDet(i-1,j-1,k) + aDet(i,j-1,k)
c     $        + aDet(i-1,j,k) + aDet(i,j,k) )
ccc.
 10   continue

      return
      end
c=======================================================================
c Modify porosity

      subroutine modifyPoros(n1,n2,n3,jac,porosity)

      implicit none
      integer n1,n2,n3
      real*8  jac(n1,n2,n3),porosity(n1,n2,n3)

      integer i,j,k

c mapPorosity = jac*porosity

      do 10 k = 1,n3
      do 10 j = 1,n2
      do 10 i = 1,n1
         porosity(i,j,k) = porosity(i,j,k)*jac(i,j,k)
 10   continue

      return
      end
c=======================================================================
c Reciprocate the determinant of the Jacobian matrix dMap

      subroutine computeJacInv(n1,n2,n3,jacInv)

      implicit none
      integer n1,n2,n3
      real*8  jacInv(n1,n2,n3)

      integer i,j,k

      do 20 k = 1,n3
      do 20 j = 1,n2
      do 20 i = 1,n1
         jacInv(i,j,k) = 1. / jacInv(i,j,k)
 20   continue

      return
      end
c=======================================================================
c Modify permeability

      subroutine modifyPerm(n1,n2,n3,dMap,jacInv,perm,pad1,pad2,pad3)

      implicit none
      integer n1,n2,n3,pad1,pad2,pad3
      real*4  dMap(3,3,0:n1,0:n2,0:n3)
      real*8  jacInv(n1,n2,n3),
     $        perm(6,1-pad1:n1+pad1,1-pad2:n2+pad2,1-pad3:n3+pad3)

      integer i,j,k,ipvt(2),m,n
      real*8  work1(3,3),work2(3,3),s,jac

c-----------------------------------------------------------------------
c modifying the permeability

c mapPerm = jac * dMap^{-1} K dMap^{-T}
c   1. solve   dMap D1 = K
c   2. solve   dMap D2 = D1^T
c   3. set     mapPerm = jac * D2

      do k = 1,n3
      do j = 1,n2
      do i = 1,n1
         do n = 1,3
         do m = 1,3
            work1(m,n) = 0.125*
     $           ( dMap(m,n,i-1,j-1,k-1) + dMap(m,n,i,j-1,k-1)
     $           + dMap(m,n,i-1,j,k-1) + dMap(m,n,i,j,k-1)
     $           + dMap(m,n,i-1,j-1,k) + dMap(m,n,i,j-1,k)
     $           + dMap(m,n,i-1,j,k) + dMap(m,n,i,j,k) )
         enddo
         enddo

         work2(1,1) = perm(1,i,j,k)
         work2(1,2) = perm(2,i,j,k)
         work2(1,3) = perm(3,i,j,k)
         work2(2,2) = perm(4,i,j,k)
         work2(2,3) = perm(5,i,j,k)
         work2(3,3) = perm(6,i,j,k)
         work2(2,1) = work2(1,2)
         work2(3,1) = work2(1,3)
         work2(3,2) = work2(2,3)

         call mapfactor(3,work1,ipvt)
         do m = 1,3
            call mapsolve(3,work1,work2(1,m),ipvt)
         enddo

         s = work2(1,2)
         work2(1,2) = work2(2,1)
         work2(2,1) = s

         s = work2(1,3)
         work2(1,3) = work2(3,1)
         work2(3,1) = s

         s = work2(2,3)
         work2(2,3) = work2(3,2)
         work2(3,2) = s

         do m = 1,3
            call mapsolve(3,work1,work2(1,m),ipvt)
         enddo

         jac = 1. / jacInv(i,j,k)
         perm(1,i,j,k) = work2(1,1)*jac
         perm(2,i,j,k) = .5*(work2(1,2)+work2(2,1))*jac
         perm(3,i,j,k) = .5*(work2(1,3)+work2(3,1))*jac
         perm(4,i,j,k) = work2(2,2)*jac
         perm(5,i,j,k) = .5*(work2(2,3)+work2(3,2))*jac
         perm(6,i,j,k) = work2(3,3)*jac
      enddo
      enddo
      enddo

      return
      end
c=======================================================================
c Modify the identity tensor

      subroutine modifyIdentity(nxp,nyp,nzp,dMap,
     $     nxc,nyc,nzc,effIdentity,nxr,nyr,nzr,identityMap)

      implicit none
      integer nxp,nyp,nzp,nxc,nyc,nzc,nxr,nyr,nzr,identityMap
      real*4  dMap(3,3,0:nxp,0:nyp,0:nzp),
     $        effIdentity(6,0:nxc,0:nyc,0:nzc)

      integer i,j,k,ipvt(2),m,n
      real*8  work1(3,3),work2(3,3),s

c-----------------------------------------------------------------------
c modifying the identity
c
c effIdentity = dMap^{-1} dMap^{-T}
c   1. solve   dMap D = I
c   2. solve   dMap effIdentity = D^T

      if(identityMap.eq.1) then
         do k = 0,nzc
         do j = 0,nyc
         do i = 0,nxc
            effIdentity(1,i,j,k) = 1.
            effIdentity(2,i,j,k) = 0.
            effIdentity(3,i,j,k) = 0.
            effIdentity(4,i,j,k) = 1.
            effIdentity(5,i,j,k) = 0.
            effIdentity(6,i,j,k) = 1.
         enddo
         enddo
         enddo
      else
         do k = 0,nzc
         do j = 0,nyc
         do i = 0,nxc
            do n = 1,3
            do m = 1,3
               work1(m,n) = dMap(m,n,i*nxr,j*nyr,k*nzr)
               work2(m,n) = 0.
            enddo
            enddo
            work2(1,1) = 1.
            work2(2,2) = 1.
            work2(3,3) = 1.

            call mapfactor(3,work1,ipvt)
            do m = 1,3
               call mapsolve(3,work1,work2(1,m),ipvt)
            enddo

            s = work2(1,2)
            work2(1,2) = work2(2,1)
            work2(2,1) = s

            s = work2(1,3)
            work2(1,3) = work2(3,1)
            work2(3,1) = s

            s = work2(2,3)
            work2(2,3) = work2(3,2)
            work2(3,2) = s

            do m = 1,3
               call mapsolve(3,work1,work2(1,m),ipvt)
            enddo

            effIdentity(1,i,j,k) = work2(1,1)
            effIdentity(2,i,j,k) = .5*(work2(1,2)+work2(2,1))
            effIdentity(3,i,j,k) = .5*(work2(1,3)+work2(3,1))
            effIdentity(4,i,j,k) = work2(2,2)
            effIdentity(5,i,j,k) = .5*(work2(2,3)+work2(3,2))
            effIdentity(6,i,j,k) = work2(3,3)
         enddo
         enddo
         enddo
      endif

      return
      end
c-----------------------------------------------------------------------

      subroutine mapfactor(n,a,ipvt)

      implicit none
      integer n,ipvt(n-1)
      real*8  a(n,n)

      integer mapimax

      integer i,j,k

      do k = 1,n-1
         ipvt(k) = mapimax(n-k+1,a(k,k)) + (k-1)
         if (ipvt(k).ne.k) then
            call mapswap(n-k+1,a(k,k),n,a(ipvt(k),k),n)
         endif
         do i = k+1,n
            a(i,k) = a(i,k)/a(k,k)
            do j = k+1,n
               a(i,j) = a(i,j) - a(k,j)*a(i,k)
            enddo
         enddo
      enddo

      return
      end
c-----------------------------------------------------------------------

      subroutine mapsolve(n,a,b,ipvt)

      implicit none
      integer n,ipvt(n-1)
      real*8  a(n,n),b(n)

      integer i,j,k
      do k = 1,n-1
         if (ipvt(k).ne.k) then
            call mapswap(1,b(k),1,b(ipvt(k)),1)
         endif
         do i = k+1,n
            b(i) = b(i) - b(k)*a(i,k)
         enddo
      enddo

      b(n) = b(n)/a(n,n)
      do i = n-1,1,-1
         do j = n,i+1,-1
            b(i) = b(i) - a(i,j)*b(j)
         enddo
         b(i) = b(i)/a(i,i)
      enddo

      return
      end
c-----------------------------------------------------------------------

      integer function mapimax(m,v)

      implicit none
      integer m
      real*8 v(m)

      integer i

      mapimax = 1
      do i = 2,m
         if (abs(v(i)).gt.abs(v(mapimax))) mapimax = i
      enddo

      return
      end
c-----------------------------------------------------------------------

      subroutine mapswap(m,u,incu,v,incv)

      implicit none
      integer m,incu,incv
      real*8 u(*),v(*),s

      integer i,indu,indv

      indu = 1
      indv = 1
      do i = 1,m
         s = u(indu)
         u(indu) = v(indv)
         v(indv) = s
         indu = indu + incu
         indv = indv + incv
      enddo

      return
      end
c=======================================================================
c define a radial map

      subroutine setRadialMap(map,nr,ntheta,nz,r,theta,z,
     $     r0,r1,theta0,theta1,z0,z1,ierror)
      implicit none
      include 'mpif.h'
      include 'msgs.hf'

      integer nr,ntheta,nz,ierror
      real*4  map(3,-1:nr+1,-1:ntheta+1,-1:nz+1)
      real*8  r(0:nr),theta(0:ntheta),z(0:nz),
     $        r0,r1,theta0,theta1,z0,z1

      integer i,j,k
      real*8  low(3),high(3)
      real*8  x,rr,tt,sine,cosine
      real*8  pi,deg2rad
      parameter(
     $     pi = 3.14159265359d0,
     $     deg2rad = pi/180.)

      real*8  scaleR,scaleTheta,scaleZ
      scaleR(x) = (r1 - r0)*(x-low(1))/(high(1) - low(1)) + r0
      scaleTheta(x) = ( (theta1 - theta0)*(x-low(2))
     $     /(high(2) - low(2)) + theta0 )*deg2rad
      scaleZ(x) = (z1 - z0)*(x-low(3))/(high(3) - low(3)) + z0

      low(1) = r(0)
      low(2) = theta(0)
      low(3) = z(0)
cmpi      call gdbcastx(MSGRADIALMAP,low,3,0)
      call MPI_Bcast(low,3,MPI_REAL8,0,MPI_COMM_WORLD,ierror)
      high(1) = r(nr)
      high(2) = theta(ntheta)
      high(3) = z(nz)
cmpi      call gdbcastx(MSGRADIALMAP+1,high,3,0)
      call MPI_Bcast(high,3,MPI_DOUBLE_PRECISION,0,
     $     MPI_COMM_WORLD,ierror)

      if( (r0.ge.r1).or.(theta0.ge.theta1).or.(z0.ge.z1) ) then
         ierror = 1
         return
      endif
      if ( (theta1.gt.theta0+360.).or.(r0.le.0.) ) then
         ierror = 2
         return
      endif

      do 10 j=0,ntheta
         tt = scaleTheta(theta(j))
         cosine = cos(tt)
         sine = sin(tt)
         do 10 i=0,nr
            rr = scaleR(r(i))
            do 10 k=0,nz
               map(1,i,j,k) = rr*cosine
               map(2,i,j,k) = rr*sine
               map(3,i,j,k) = scaleZ(z(k))
 10   continue

      return
      end
c=======================================================================
c Volume of an element
c   Vertices:   Faces:
c     8----7     bottom = 1
c    /    /|     top    = 2
c   5----6 |     left   = 3
c   | 4  | 3     right  = 4
c   |    |/      front  = 5
c   1----2       back   = 6

      real*8 function elementVol(v1,v2,v3,v4,v5,v6,v7,v8)
      implicit none

      real*4  v1(3),v2(3),v3(3),v4(3),v5(3),v6(3),v7(3),v8(3)
      integer i
      real*4  f1(3),f2(3),f3(3),f4(3),f5(3),f6(3)
      real*8  vol,tetraVol

c Extra vertices (6 = one per face)

      do i=1,3
         f1(i) = .25*(v1(i) + v2(i) + v3(i) + v4(i))
         f2(i) = .25*(v5(i) + v6(i) + v7(i) + v8(i))
         f3(i) = .25*(v1(i) + v4(i) + v5(i) + v8(i))
         f4(i) = .25*(v2(i) + v3(i) + v6(i) + v7(i))
         f5(i) = .25*(v1(i) + v2(i) + v5(i) + v6(i))
         f6(i) = .25*(v3(i) + v4(i) + v7(i) + v8(i))
      enddo

c Tetrahedral volumes

      vol = 0.

c edges (12)

      vol = vol + tetraVol(v1,v2,f1,f5)
      vol = vol + tetraVol(v2,v3,f1,f4)
      vol = vol + tetraVol(v3,v4,f1,f6)
      vol = vol + tetraVol(v1,v4,f1,f3)
      vol = vol + tetraVol(v1,v5,f3,f5)
      vol = vol + tetraVol(v2,v6,f4,f5)
      vol = vol + tetraVol(v3,v7,f4,f6)
      vol = vol + tetraVol(v4,v8,f3,f6)
      vol = vol + tetraVol(v5,v6,f2,f5)
      vol = vol + tetraVol(v6,v7,f2,f4)
      vol = vol + tetraVol(v7,v8,f2,f6)
      vol = vol + tetraVol(v5,v8,f2,f3)

c vertices (8)

      vol = vol + tetraVol(v1,f1,f3,f5)
      vol = vol + tetraVol(v2,f1,f4,f5)
      vol = vol + tetraVol(v3,f1,f4,f6)
      vol = vol + tetraVol(v4,f1,f3,f6)
      vol = vol + tetraVol(v5,f2,f3,f5)
      vol = vol + tetraVol(v6,f2,f4,f5)
      vol = vol + tetraVol(v7,f2,f4,f6)
      vol = vol + tetraVol(v8,f2,f3,f6)

c center (4)

      vol = vol + tetraVol(f1,f2,f3,f5)
      vol = vol + tetraVol(f1,f2,f3,f6)
      vol = vol + tetraVol(f1,f2,f4,f5)
      vol = vol + tetraVol(f1,f2,f4,f6)

      elementVol = vol
      return
      end
c=======================================================================
c Volume of a tetrahedra

      real*8 function tetraVol(v1,v2,v3,v4)
      implicit none

      real*4 v1(3),v2(3),v3(3),v4(3)
      real*8 det
      real*4 a1,a2,a3,b1,b2,b3,c1,c2,c3
      det(a1,a2,a3,b1,b2,b3,c1,c2,c3)
     $     = (a1*(b2*c3-c2*b3)-b1*(a2*c3-c2*a3)+c1*(a2*b3-b2*a3))

      tetraVol = abs( det(
     $     v1(1) - v4(1), v2(1) - v4(1), v3(1) - v4(1),
     $     v1(2) - v4(2), v2(2) - v4(2), v3(2) - v4(2),
     $     v1(3) - v4(3), v2(3) - v4(3), v3(3) - v4(3) ) ) / 6.

      return
      end
c=======================================================================
c Setup Coefficients from the Mapping
c   (Compute Jacobian matrix and modify coefficients)

      subroutine setupMapCoefs(dMap,jacInv,effPorosity,effIdentity,perm,
     $     porosity,nSorpTypes,sorp,
     $     xpComp,ypComp,zpComp,map,identityMap,nx,ny,nz,myNbr)
      implicit none

      integer nx,ny,nz,nsorpTypes

      real*4  dMap(3,3,0:nx,0:ny,0:nz)
      real*8  jacInv(nx*ny*nz),effPorosity(nx*ny*nz)
      real*4  effIdentity(6*(nx+1)*(ny+1)*(nz+1))
      real*8  perm(6,nx,ny,nz),porosity(nx*ny*nz),
     $        xpComp(-1:nx+1),ypComp(-1:ny+1),zpComp(-1:nz+1)
      real*8  sorp(nx*ny*nz,nSorpTypes)
      real*4  map(3,-1:nx+1,-1:ny+1,-1:nz+1)
      integer identityMap,myNbr(-1:1,-1:1,-1:1)

      integer i

      do i=1,nx*ny*nz
         effPorosity(i) = porosity(i)
      enddo

      if(identityMap.ne.0) then
         do i=1,nx*ny*nz
            jacInv(i) = 1.
         enddo
      else
         call setupDMap(map,nx,ny,nz,
     $        xpComp(-1),ypComp(-1),zpComp(-1),dMap,myNbr)
         call computeJac(nx,ny,nz,map,
     $        xpComp(-1),ypComp(-1),zpComp(-1),jacInv)
         call modifyPoros(nx,ny,nz,jacInv,effPorosity)
         do i=1,nSorpTypes
            call modifyPoros(nx,ny,nz,jacInv,sorp(1,i))
         enddo
         call computeJacInv(nx,ny,nz,jacInv)
         call modifyPerm(nx,ny,nz,dMap,jacInv,perm,0,0,0)
      endif

      call modifyIdentity(nx,ny,nz,dMap,
     $     nx,ny,nz,effIdentity,1,1,1,identityMap)

      return
      end
c#######################################################################
c Map the velocity: mapVel = jac * (dMap)^{-1} vel
c Note that we preserve normal fluxes, therefore
c      \int_f vel . nu = \int_mapF mapVel . mapNu
c   implies that in fact
c      mapVel . mapNu = (|f|/|mapF|) vel . nu
c We approximate the surface area by computing the areas of 4
c   trianglules, where each triangle has two corners of the face and the
c   average point.
c The area of the triangle with corners A, B, and C is
c   (1/2) * || (A - C) X (B - C) ||

      subroutine mapVel(velx,vely,velz,map,x1,x2,x3,n1,n2,n3)
      implicit none
      INTRINSIC sqrt

      integer n1,n2,n3
      real*8  velx(0:n1,n2,n3),vely(n1,0:n2,n3),velz(n1,n2,0:n3)
      real*4  map(3,-1:n1+1,-1:n2+1,-1:n3+1)
      real*8  x1(0:n1),x2(0:n2),x3(0:n3)

      integer i,j,k,m
      real*8  face,mapFaceInv
      real*4  avg(3)

      real*8  area
      integer i1,j1,k1, i2,j2,k2

      area(i1,j1,k1, i2,j2,k2) = sqrt(
     $       ( (map(1,i1,j1,k1)-avg(1))*(map(2,i2,j2,k2)-avg(2))
     $       - (map(1,i2,j2,k2)-avg(1))*(map(2,i1,j1,k1)-avg(2)) )**2
     $     + ( (map(1,i1,j1,k1)-avg(1))*(map(3,i2,j2,k2)-avg(3))
     $       - (map(1,i2,j2,k2)-avg(1))*(map(3,i1,j1,k1)-avg(3)) )**2
     $     + ( (map(2,i1,j1,k1)-avg(2))*(map(3,i2,j2,k2)-avg(3))
     $       - (map(2,i2,j2,k2)-avg(2))*(map(3,i1,j1,k1)-avg(3)) )**2 )

      do 10 k=1,n3
      do 10 j=1,n2
         mapFaceInv = 1. / ( (x2(j) - x2(j-1))*(x3(k) - x3(k-1)) )
         do 10 i=0,n1
            do m=1,3
               avg(m) = 0.25 * (
     $                map(m,i,j,k) + map(m,i,j-1,k)
     $              + map(m,i,j,k-1) + map(m,i,j-1,k-1) )
            enddo
            face = 0.5 * (
     $             area(i,j,k, i,j-1,k) + area(i,j-1,k-1, i,j-1,k)
     $           + area(i,j,k, i,j,k-1) + area(i,j-1,k-1, i,j,k-1) )
            velx(i,j,k) = face*mapFaceInv*velx(i,j,k)
 10   continue

      do 20 k=1,n3
      do 20 i=1,n1
         mapFaceInv = 1. / ( (x1(i) - x1(i-1))*(x3(k) - x3(k-1)) )
         do 20 j=0,n2
            do m=1,3
               avg(m) = 0.25 * (
     $                map(m,i,j,k) + map(m,i-1,j,k)
     $              + map(m,i,j,k-1) + map(m,i-1,j,k-1) )
            enddo
            face = 0.5 * (
     $             area(i,j,k, i-1,j,k) + area(i-1,j,k-1, i-1,j,k)
     $           + area(i,j,k, i,j,k-1) + area(i-1,j,k-1, i,j,k-1) )
            vely(i,j,k) = face*mapFaceInv*vely(i,j,k)
 20   continue

      do 30 j=1,n2
      do 30 i=1,n1
         mapFaceInv = 1. / ( (x1(i) - x1(i-1))*(x2(j) - x2(j-1)) )
         do 30 k=0,n3
            do m=1,3
               avg(m) = 0.25 * (
     $                map(m,i,j,k) + map(m,i-1,j,k)
     $              + map(m,i,j-1,k) + map(m,i-1,j-1,k) )
            enddo
            face = 0.5 * (
     $             area(i,j,k, i-1,j,k) + area(i-1,j-1,k, i-1,j,k)
     $           + area(i,j,k, i,j-1,k) + area(i-1,j-1,k, i,j-1,k) )
            velz(i,j,k) = face*mapFaceInv*velz(i,j,k)
 30   continue

      return
      end
c#######################################################################
c Title: setcgrid
c Description: defines a 1-D grid x1 as a coarsening of another grid x2
c Inputs:
c     n?            Number of grid cells
c     x2            Fine grid
c Outputs:
c     x1            Coarse grid
c     ierror        error flag
c                     1 = bad coarsening

      subroutine setcgrid(x1,n1,x2,n2,ierror)
      implicit none

      integer n1,n2,ierror
      real*8  x1(0:n1),x2(0:n2)

      integer i,step

      step = n2/n1
      if( step*n1.ne.n2 ) then
         ierror = 1
      else
         x1(0)  = x2(0)
         x1(n1) = x2(n2)
         do i=1,n1-1
            x1(i) = x2(i*step)
         enddo
      endif

      return
      end
