      subroutine MPI_Allgather(buf1,len1,type1,
     $     buf2,len2,type2,comm,error)
      integer len1,type1,len2,type2,comm,error
      real*8 buf1(len1),buf2(len2)
      end

      subroutine MPI_Allgatherv(buf1,len1,type1,
     $     buf2,len2,displacement,type2,comm,error)
      integer len1,type1,len2(*),displacement(*),type2,comm,error
      real*8 buf1(len1),buf2(*)
      end

      subroutine MPI_Barrier(comm,error)
      integer comm,error
      end

      subroutine MPI_Bcast(buf,len,type,source,comm,error)
      integer len,type,source,comm
      real*8 buf(len)
      end

      subroutine MPI_Bsend(buf,len,type,to,tag,comm,error)
      integer len,type,to,tag,comm,error
      real*8 buf(len)
      end

      subroutine MPI_Comm_rank(comm,myProc,error)
      integer comm,myProc,error
      myProc = 0
      end

      subroutine MPI_Comm_size(comm,nProcs,error) 
      integer comm,nProcs,error
      nProcs = 1
      end

      subroutine MPI_Gather(buf1,len1,type1,
     $     buf2,len2,type2,root,comm,error)
      integer len1,type1,len2,type2,root,comm,error
      real*8 buf1(len1),buf2(len2)
      end

      subroutine MPI_Irecv(buf,len,type,from,tag,comm,request,error)
      integer len,type,from,tag,comm,request,error
      real*8 buf(len)
      end

      subroutine MPI_Recv(buf,len,type,from,tag,comm,status,error)
      integer len,type,from,tag,comm,status(3),error
      real*8 buf(len)
      end

      subroutine MPI_Sendrecv(buf1,n1,type1,to,
     $     tag1,buf2,n2,type2,from,tag2,comm,status,error)
      integer n1,type1,to,tag1,n2,type2,from,tag2,comm,status(3),error
      real*8 buf1(n1),buf2(n2)
      end

      subroutine MPI_Waitany(count,requests,index,status,error)
      integer count,requests(*),index,status(3),error
      end

      double precision function MPI_Wtime()
      MPI_Wtime = MSG_f_Wtime()
      end
