#define COMMENT(x)

COMMENT(THE CENTER FOR SUBSURFACE MODELING)
COMMENT(PARALLEL SUBSURFACE SIMULATOR (PARSSIM))

COMMENT(This file is generated by a template)

#ifndef _PSSGLOBALS_H
#define _PSSGLOBALS_H

#include "pss.h"

#define SIZE_OUTFLAGS_F 20
#define SIZE_OUTFLAGS_T 20

struct globals {
  int nProcs;
  int myProc;

  int nDom[3];
  int myDom[3];
  int myNbr[27];

  int computeFlow;
  int steadyFlow;
  int callTransport;
  int computeTransport;
  int computeChemistry;
  int computeRND;
  int computeRXN;

  double tInitial;
  double tFinal;
  double time_f;
  double time_t;
  int step_f;
  int step_t;
  int nStepsMax_f;
  int nStepsMax_t;
  int nStepsMax_t_per_f;
  int ndtMax_f;
  int ndtMax_t;
  double* tdtMax_f;
  double* tdtMax_t;
  double* dtMax_f;
  double* dtMax_t;

  int runNumber;
  char runDescription[SIZE_LINE];
  char outDir[SIZE_DIRECTORYNAME];
  int outFormat3D;
  int nSpeciesPerOutfile;
  int initialOut;
  int dStepOut_pres;
  int dStepOut_vel;
  int dStepOut_conc;
  double dtOut_pres;
  double dtOut_vel;
  double dtOut_conc;
  int presType_out;
  int outFormat1D;
  int nHistories_t;
  int* histType_t;
  int* histIndexLo_t;
  int* histIndexHi_t;
  double* histVolFactor_t;
  int* nHistSpecies_t;
  int* * histSpecie_t;
  int* dStepOut_hist_t;
  double* dtOut_hist_t;
  int verbosity;
  int debug;
  int outFlags_f[SIZE_OUTFLAGS_F];
  int outFlags_t[SIZE_OUTFLAGS_T];

  int nx_g;
  int ny_g;
  int nz_g;
  int nx;
  int ny;
  int nz;
  int xOffset_g[4];
  int yOffset_g[4];
  int zOffset_g[4];
  int periodicBC[3];
  int identityMap;
  int zIsDepth;
  double* xp;
  double* yp;
  double* zp;

  int uniformDispersion;
  double molDiff;
  double longDisp;
  double transDisp;
  double* molDiffAry;
  double* longDispAry;
  double* transDispAry;

  int nSpecies;
  char (*specieName)[SIZE_WORD];
  double* molecularWeight;
  int* primaryPhase;
  double* phaseDist;
  float* conc;

  int modelMiscDisp;
  double* viscosityRatio;

  int niParmRND;
  int* iParmRND;
  int nrParmRND;
  double* rParmRND;

  int rxn_nComps;
  int* rxn_comp;
  int rxn_nMicroSteps;
  double rxn_tolerance;
  int rxn_nIParams;
  int* rxn_iParam;
  int rxn_nDParams;
  double* rxn_dParam;

  int nBCRegions;
  int* bcRegion1;
  int* bcRegion2;
  int* bcRegion3;

  int maxnBCInterp_f;
  int* bcType_f;
  int* nBCInterp_f;
  float* bc_f;
  int* bcPresType_in;

  int maxnBCInterp_t;
  int* bcType_t;
  int* nBCInterp_t;
  float* bc_t;

  int maxIterIF_f;
  double relTolIF_f;
  double absTolIF_f;
  int pcTypeIF_f;
  int dWorkspace_f;

  int maxIter_t;
  double relTol_t;
  int dWorkspace_t;
  int padx;
  int pady;
  int padz;
  int volRefine_t[3];
  double cflFactor_t;
  int ntCutMax_t;
  double volTol_t;

  int nSorpTypes;
  int* sorpType;
  double* sorp;

  double gravity;
  double phaseViscosity;
  double phaseDensity;

  double* porosity;
  double* perm;
  double* facePerm;
  int permType_in;
  int permType;
  int diagMapPerm;

  double* pressure;
  double* velX;
  double* velY;
  double* velZ;

  double* lagrangePresX;
  double* lagrangePresY;
  double* lagrangePresZ;

  int nWells;
  int* wellType;
  int* hWellIndex;
  int* zWellIndexLo;
  int* zWellIndexHi;

  int maxnWellInterp_f;
  int* nWellInterp_f;
  float* wellInj_f;
  double* wellRadius;
  double* wellPres;

  int maxnWellInterp_t;
  int* nWellInterp_t;
  float* wellInj_t;

  int nLeaks;
  int* leakIndexLo;
  int* leakIndexHi;

  int maxnLeakInterp;
  int* nLeakInterp;
  float* leakRate;

  int dimDwk;
  double* dwk;
  int dimIwk;
  int* iwk;

  double* xpComp;
  double* ypComp;
  double* zpComp;

  float* map;
  float* dMap;
  double* jacInv;
  float* effIdentity;
  double* effPorosity;

  int nTraceTypes;
  int* traceType;
  float* totCoef;
};

struct chmGlobals {
  int nComps;
  int nProducts;
  int chmLoadBalFlag;
  int chmMaxIter;
  double chmAbsTol;
  double chmEpsConc;
  int chmGuessType;
  int chmScaleFlag;
  int chmTestSolFlag;
  int chmInterpFlag;
  int nViol;
  double chmAlpha;
  int hessFlag;
  double tauMin;
  double chmRho;
  int ntReact;
  int odeAlgType;
  int switchFlag;
  double absTemp;
  double chemPres;
  int ideal;
  int locH;
  int locWater;
  int chemPhases;
  double* chmPhaseDensity;
  double* compCharge;
  char* phaseNames;
  char* chmSpecieName;
  int* chmPhaseIdentity;
  double* stoich;
  int* reactionType;
  int nRQ;
  int nRK;
  int* nSpeciesInPhase;
  int chemPhasePure;
  int chemPhaseMulti;
  double* peqk;
  double* pkf;
  double* pkb;
  double* stoichK;
  double* halfSatConst;
  double* peqkX;
  double* mu0;
  int iRxnparSZ;
  int rRxnparSZ;
  int cRxnparSZ;
  int* iRxnpar;
  double* rRxnpar;
  char* cRxnpar;
  double* chemAmatrix;
  double* chemVmatrix;
  double* kval;
  double* ratepow;
  int dWorkspace_c;
  int iWorkspace_c;
};

#ifdef PSS_ALLOCATE_MEMORY
struct globals PSS;
struct chmGlobals CHM;
#else
extern struct globals PSS;
extern struct chmGlobals CHM;
#endif

#endif
