c alpha p - \div( (perm/mu) \grad p ) = f
c
c=======================================================================
c Initialize the parcel information common blocks

      subroutine parcelFlowInit(nProcs,outflags_f,myNbr,
     $     PCstyle_if,nIter_if,relTol_if,absTol_if,diagMapPerm)
      implicit none

      integer PRESUNIT
      parameter(PRESUNIT = 10)

      integer nProcs,outflags_f(*),myNbr(-1:1,-1:1,-1:1),
     $        PCstyle_if,nIter_if,diagMapPerm
      real*8  relTol_if,absTol_if

      integer MajorVersion,MinorVersion,icube,iparam,myNbrp,permType
      real*8  rparam,SDparam
      common/parcelIData/ MajorVersion,MinorVersion,
     $     icube(3),iparam(8),myNbrp(3,2),permType
      common/parcelDData/ rparam(12),SDparam(5)

c Version of Parcel

      MajorVersion = 1
      MinorVersion = 4

c Pack up the parameters

      icube(1) = myNbr(0,0,0)
      icube(2) = 0
      icube(3) = nProcs

      iparam(1) = PRESUNIT
      iparam(2) = 1
      iparam(3) = outflags_f(1)
      iparam(4) = outflags_f(2)
      iparam(6) = PCstyle_if
      iparam(7) = nIter_if

      rparam(1) = relTol_if
      rparam(2) = absTol_if

c Subdomain solver parameters
c   (use a direct solver, see the include file 'sdsolver.hf')

      if(diagMapPerm.eq.0) then
         SDparam(1) = 5
         permType = 3
      else
         SDparam(1) = 3
         permType = 1
      endif
      SDparam(2) = 0.
      SDparam(3) = 0.
      SDParam(4) = 0.
      SDParam(5) = 0.

c Misc

      myNbrp(1,1) = myNbr(-1,0,0)
      myNbrp(1,2) = myNbr(1,0,0)
      myNbrp(2,1) = myNbr(0,-1,0)
      myNbrp(2,2) = myNbr(0,1,0)
      myNbrp(3,1) = myNbr(0,0,-1)
      myNbrp(3,2) = myNbr(0,0,1)

      if(outflags_f(1).ne.0) open(PRESUNIT,file='pres')

      return
      end
c=======================================================================
c Set up the pressure PDE problem (equation and boundary conditions)
c   and call Parcel to solve it

      subroutine parcelFlow(tp,permx,permy,mu,jacInv,map,
     $     nxp,nyp,nzp,xp,yp,zp,locWell,topWell,botWell,wellFlag,
     $     nWells,wRadius,wPres,perm,facePerm,parcelAlpha,parcelF,
     $     pBCRegion1,pBCRegion2,pBCRegion3,pBCType,nPBCRegions,
     $     bcPresType,presPotential,presPressure,
     $     presHydraulicHead,presHead,gravity,density,
     $     bc1,bc2,bc3,lagPres1,lagPres2,lagPres3,
     $     pressure,velX,velY,velZ,
     $     modelMiscDisp,viscosityRatio,molecularWeight,
     $     conc,padx,pady,padz,nSpecies,
     $     dwk,dimdwk,iwk,dimiwk,myNbr,nDom,ierror)
      implicit none

      integer nxp,nyp,nzp,nWells,wellFlag(nWells),
     $        locWell(2,nWells),topWell(2,nWells),botWell(2,nWells),
     $        pBCRegion1(*),pBCRegion2(*),pBCRegion3(*),pBCType(*),
     $        nPBCRegions,dimdwk,iwk(*),dimiwk,
     $        myNbr(-1:1,-1:1,-1:1),nDom(3),ierror
      real*8  pressure(*),velX(*),velY(*),velZ(*)
      real*8  tp,permx(*),permy(*),mu,jacInv(*),
     $        xp(*),yp(*),zp(*),wRadius(*),wPres(*),
     $        perm(*),facePerm(*),parcelAlpha(*),parcelF(*),dwk(*),
     $        lagPres1(*),lagPres2(*),lagPres3(*),
     $        bc1(*),bc2(*),bc3(*),gravity,density
      real*4  map(*)
      integer bcPresType(*),presPotential,presPressure,
     $        presHydraulicHead,presHead
      integer modelMiscDisp,padx,pady,padz,nSpecies
      real*8  viscosityRatio(*),molecularWeight(*)
      real*4  conc(*)
      integer ddwk,diwk

      integer MajorVersion,MinorVersion,icube,iparam,myNbrp,permType
      real*8  rparam,SDparam
      common/parcelIData/ MajorVersion,MinorVersion,
     $     icube(3),iparam(8),myNbrp(3,2),permType
      common/parcelDData/ rparam(12),SDparam(5)

      integer isSingular

ccc
      integer i,j

      if(dimdwk.lt.3*nzp*nWells) then
         ierror = 1
         return
      endif
      call setupparcel(tp,permx,permy,mu,jacInv,
     $     nxp,nyp,nzp,xp,yp,zp,locWell,topWell,botWell,wellFlag,
     $     dwk(1),dwk(1+nzp*nWells),dwk(1+2*nzp*nWells),
     $     nWells,wRadius,wPres,perm,facePerm,permType,
     $     parcelAlpha,parcelF,ierror)
      if(ierror.ne.0) then
         ierror = 2
         return
      endif
      iparam(5) = isSingular(parcelAlpha,pBCType,nPBCRegions,
     $     nxp*nyp*nzp)

      call setupBC(tp,nxp,nyp,nzp,pBCRegion1,pBCRegion2,pBCRegion3,
     $     pBCType,bcPresType,presPotential,presPressure,
     $     presHydraulicHead,presHead,gravity,density,
     $     myNbr,bc1,bc2,bc3,xp,yp,zp,map,2)

c UMD factor

      if(modelMiscDisp.ne.0) then
         call scalPerm(modelMiscDisp,perm,facePerm,permType,
     $        viscosityRatio,molecularWeight,density,
     $        conc,1,nxp,nyp,nzp,padx,pady,padz,nSpecies)
      endif

c Call parcel

      ddwk = dimdwk
      diwk = dimiwk

ccc:
c      write(30,*) MajorVersion,MinorVersion,nxp,nyp,nzp
c      write(30,*) (xp(i),i=1,nxp+1)
c      write(30,*) (yp(i),i=1,nyp+1)
c      write(30,*) (zp(i),i=1,nzp+1)
c      write(30,*) (lagPres1(i),i=1,2*nyp*nzp)
c      write(30,*) (lagPres2(i),i=1,2*nxp*nzp)
c      write(30,*) (lagPres3(i),i=1,2*nxp*nyp)
c      write(30,*) (pressure(i),i=1,nxp*nyp*nzp)
c      write(30,*) (velX(i),i=1,(nxp+1)*nyp*nzp)
c      write(30,*) (velY(i),i=1,nxp*(nyp+1)*nzp)
c      write(30,*) (velZ(i),i=1,nxp*nyp*(nzp+1))
c      write(30,*) (parcelAlpha(i),i=1,nxp*nyp*nzp)
c      if(permType.ne.1) then
c         write(30,*) (perm(i),i=1,6*nxp*nyp*nzp)
c      else
c         write(30,*) (perm(i),i=1,
c     $     (nxp+1)*nyp*nzp + nxp*(nyp+1)*nzp + nxp*nyp*(nzp+1))
c      endif
c      write(30,*) permType
c      write(30,*) (parcelF(i),i=1,nxp*nyp*nzp)
c      write(30,*) (pBCType(i),i=1,nPBCRegions)
c      write(30,*) nPBCRegions
c      write(30,*) (pBCRegion1(i),i=1,2*nyp*nzp)
c      write(30,*) (pBCRegion2(i),i=1,2*nxp*nzp)
c      write(30,*) (pBCRegion3(i),i=1,2*nxp*nyp)
c      write(30,*) (bc1(i),i=1,2*nyp*nzp)
c      write(30,*) (bc2(i),i=1,2*nxp*nzp)
c      write(30,*) (bc3(i),i=1,2*nxp*nyp)
c      write(30,*) ((myNbrp(i,j),i=1,3),j=1,2)
c      write(30,*) (icube(i),i=1,3)
c      write(30,*) (rparam(i),i=1,20)
c      write(30,*) (iparam(i),i=1,9)
c      write(30,*) (nDom(i),i=1,3)
c      write(30,*) (SDparam(i),i=1,4)
c      write(30,*) ddwk
c      write(30,*) diwk
ccc.
      if(permType.eq.1) then
         call parcel3D(MajorVersion,MinorVersion,
     $        nxp,nyp,nzp,xp,yp,zp,
     $        lagPres1,lagPres2,lagPres3,
     $        pressure,velX,velY,velZ,
     $        parcelAlpha,facePerm,permType,parcelF,
     $        pBCType,nPBCRegions,
     $        pBCRegion1,pBCRegion2,pBCRegion3,bc1,bc2,bc3,
     $        myNbrp,icube,rparam,iparam,nDom,
     $        SDparam,dwk,ddwk,iwk,diwk)
      else
ccc         write(*,*) (perm(i),i=1,nxp*nyp*nzp*6)
         call parcel3D(MajorVersion,MinorVersion,
     $        nxp,nyp,nzp,xp,yp,zp,
     $        lagPres1,lagPres2,lagPres3,
     $        pressure,velX,velY,velZ,
     $        parcelAlpha,perm,permType,parcelF,
     $        pBCType,nPBCRegions,
     $        pBCRegion1,pBCRegion2,pBCRegion3,bc1,bc2,bc3,
     $        myNbrp,icube,rparam,iparam,nDom,
     $        SDparam,dwk,ddwk,iwk,diwk)
      endif
c Undo UMD factor

      if(modelMiscDisp.ne.0) then
         call scalPerm(modelMiscDisp,perm,facePerm,permType,
     $        viscosityRatio,molecularWeight,density,
     $        conc,0,nxp,nyp,nzp,padx,pady,padz,nSpecies)
      endif

ccc:
cc OUTPUT RAW VEL
c      open(unit=39,file="veldata")
c 999  format(1x,64e23.15,/)
c
c      write(39,*) "u_l"
c      do j=nyp,1,-1
c         write(39,999) (-velx(i+(nxp+1)*(j-1))*3.168895e-6,i=1,nxp)
c      end do
c
c      write(39,*) "u_r"
c      do j=nyp,1,-1
c         write(39,999) (velx(i+1+(nxp+1)*(j-1))*3.168895e-6,i=1,nxp)
c      end do
c
c      write(39,*) "u_t"
c      do j=nyp,1,-1
c         write(39,999) (vely(i+nxp*(j))*3.168895e-6,i=1,nxp)
c      end do
c
c      write(39,*) "u_b"
c      do j=nyp,1,-1
c         write(39,999) (-vely(i+nxp*(j-1))*3.168895e-6,i=1,nxp)
c      end do
c
c      close(unit=39)
ccc.
                                                                   
      return
      end
c=======================================================================

      subroutine setupparcel(time,permx,permy,mu,jacInv,
     $     n1,n2,n3,x1,x2,x3,locWell,topWell,botWell,wellFlag,
     $     qrate,pmancorr,equrad,nWells,wradius,prout,
     $     perm,facePerm,permType,alpha,f,ierror)

c *******************************************************************
c
c Description: Sets up the matrix and right hand side coefficients
c              for a call to Parcel
c
c In:
c --
c time         current time
c permx,permy  permeabilities
c mu           viscosity
c jacInv       inverse of the Jacobian of the mapping
c n1,n2,n3     numbers of cells
c x1,x2,x3     grids
c prout        wellbore pressure
c wradius      well radius
c nwells       number of wells
c locWell      horizontal location of the wells
c topWell      top of well (two pieces allowed)
c botWell      bottom of well (two pieces allowed)
c wellFlag     describes whether the well is production or injection
c perm         mapped permeability tensor
c facePerm     face permeability coefficients
c permType     use face permeability if permType = 1
c
c Out:
c ---
c alpha        diagonal coefficients of the matrix corresponding
c              to the peaceman correction
c perm         (mapped) conductivity tensor for the second order problem
c facePerm     coefficient for the second order problem (if permType = 1)
c f            right hand side coefficients
c qrate        injection rates at each layers of each injection well
c equrad       effective well-block radius at production wells
c pmancorr     peaceman correction at the production wells
c ierror       error flag from setwells
c
c *******************************************************************

      implicit none

      integer nWells,n1,n2,n3,ierror,permType
      integer wellFlag(*),locWell(2,*),
     $        topWell(2,*),botWell(2,*)
      real*8  time,perm(6,n1,n2,n3),facePerm(*),jacInv(n1,n2,n3),
     $        alpha(n1,n2,n3),f(n1,n2,n3),permx(n1,n2,n3),
     $        permy(n1,n2,n3),equrad(n3,*),
     $        pmancorr(n3,*),x1(0:n1),x2(0:n2),x3(0:n3),
     $        prout(*),qrate(n3,*),mu,wradius(*)
      integer firstcall
      data firstcall/1/

c set up wells

      if(nwells.gt.0) then
         call setwells(time,locWell,topWell,botWell,wellFlag,
     $        qrate,pmancorr,equrad,permx,permy,nWells,n1,n2,n3,
     $        wradius,x1,x2,mu,x3,jacInv,ierror)
         if(ierror.ne.0) return
      endif

c set up the matrix coefficients perm and alpha

      if(firstcall.eq.1) then
         call setmatcoef(perm,facePerm,permType,mu,jacInv,pmancorr,
     $        nWells,wellFlag,locWell,topWell,botWell,
     $        n1,n2,n3,x1,x2,x3,alpha)
         firstcall = 0
      endif

c set up the right-hand side f

      call setrhs(jacInv,pmancorr,qrate,prout,nWells,
     $     wellFlag,locWell,topWell,botWell,n1,n2,n3,x1,x2,x3,f)

      return
      end
c=======================================================================
c     
      subroutine setwells(time,locWell,topWell,botWell,wellFlag,
     $     qrate,pmancorr,equrad,permx,permy,nWells,nxp,nyp,nzp,
     $     wradius,xp,yp,mu,zp,jacInv,ierror)

c ******************************************************************
c Description:  compute the peaceman correction at the production
c -----------   wells. compute the flow rate at the injection wells;
c               explicit injection rates.
c
c In:
c --
c time         current time
c nWells       number of wells
c locWell      horizontal location of wells
c topWell      top of well (two pieces allowed)
c botWell      bottom of well (two pieces allowed)
c wellFlag     well type (e.g., production or injection)
c nxp nyp nzp  numbers of blocs
c xp,yp,zp     grids
c wradius      well radius
c permx permy  permeabilities
c mu           viscosity
c jacInv       inverse of the Jacobian of the mapping
c
c Out:
c ---
c equrad       effective well-block radius at production wells
c pmancorr     peaceman correction at the production wells
c qrate        flow rate in each layers at an injection well
c ierror       error flag
c                0 = no error
c                1 = bad well type
c
c Function:
c --------
c pWellValue   total rate at the injection wells
c
c ******************************************************************
      implicit none
      INTRINSIC sqrt , log
      include 'well.hf'

      integer i,j,k,nWells,nxp,nyp,nzp,well,ierror
      real*8  wradius(*),pi,kx,ky
      integer locWell(2,*),wellFlag(*),
     $        topWell(2,*),botWell(2,*)
      real*8  time,qrate(nzp,*),equrad(nzp,*),permx(nxp,nyp,nzp),
     $        permy(nxp,nyp,nzp),pmancorr(nzp,*),xp(0:nxp),
     $        yp(0:nyp),zp(0:nzp),mu,sum,hx,hy,hz,jacInv(nxp,nyp,nzp)
      real*8  pWellValue

      parameter(pi = 3.14159265359d0)
      logical mywell
      mywell(i,j) = (1.le.i).and.(i.le.nxp).and.(1.le.j).and.(j.le.nyp)

c Loop over the wells

      do 10 well = 1, nWells
         i = locWell(1,well)
         j = locWell(2,well)
         if(.not.mywell(i,j)) goto 10
         hx = xp(i) - xp(i-1)
         hy = yp(j) - yp(j-1)

c Compute the peaceman correction for the production wells

         if (wellFlag(well).eq.WELL_BOTTOMHOLE_PROD) then
            do 20 k = topWell(2,well), botWell(2,well)
               hz = zp(k) - zp(k-1)
               kx = permx(i,j,k)
               ky = permy(i,j,k)
               equrad(k,well) = 0.28d0*
     $              sqrt( sqrt(ky/kx)*hx**2 + sqrt(kx/ky)*hy**2 ) /
     $              ( (ky/kx)**0.25+(kx/ky)**0.25 )
               pmancorr(k,well) =
     $              2.0d0*pi*hz*sqrt(kx*ky) /
     $              ( mu*log( equrad(k,well)/wradius(well) ) )
 20         continue

c Partition the injection/production rate into various layers 

         elseif( (wellFlag(well).eq.WELL_INJECTION).or.
     $           (wellFlag(well).eq.WELL_EXTRACTION).or.
     $           (wellFlag(well).eq.WELL_REINJECTION) ) then
            if ( (wellFlag(well).eq.WELL_INJECTION).or.
     $           (wellFlag(well).eq.WELL_REINJECTION) ) then
               sum = 0.0d0
               do 30 k = topwell(1,well), botwell(1,well)
                  hz = zp(k) - zp(k-1)
                  sum = sum + sqrt(permx(i,j,k)*permy(i,j,k))
     $                 *hx*hy*hz/jacInv(i,j,k)
 30            continue
               do 40 k = topwell(1,well), botwell(1,well)
                  hz = zp(k) - zp(k-1)
                  qrate(k,well) = pWellValue(time,1,well)
     $                 *sqrt(permx(i,j,k)*permy(i,j,k))
     $                 / ( jacInv(i,j,k)*sum )
 40            continue
            endif
            if ( (wellFlag(well).eq.WELL_EXTRACTION).or.
     $           (wellFlag(well).eq.WELL_REINJECTION) ) then
               sum = 0.0d0
               do 50 k = topWell(2,well), botWell(2,well)
                  hz = zp(k) - zp(k-1)
                  sum = sum + sqrt(permx(i,j,k)*permy(i,j,k))
     $                 *hx*hy*hz/jacInv(i,j,k)
 50            continue
               do 60 k = topWell(2,well), botWell(2,well)
                  qrate(k,well) = -pWellValue(time,1,well)
     $                 *sqrt(permx(i,j,k)*permy(i,j,k))
     $                 / ( jacInv(i,j,k)*sum )
 60            continue
            endif
         elseif(wellFlag(well).eq.WELL_INACTIVE) then
         else
            ierror = 1
            return
         endif
 10   continue

 15   format (5(2x,f10.6))

      ierror = 0
      return
      end
c=======================================================================

      subroutine setmatcoef(perm,facePerm,permType,mu,jacInv,pmancorr,
     $     nWells,wellFlag,locWell,topWell,botWell,
     $     n1,n2,n3,x1,x2,x3,alpha)

c *******************************************************************
c
c Description: Sets up the matrix coefficients
c
c In:
c --
c perm         mapped permeability tensor
c facePerm     face permeability coefficients
c permType     use face permeability if permType = 1
c mu           viscosity
c jacInv       inverse of the Jacobian of the mapping
c n1,n2,n3     numbers of cells
c x1,x2,x3     size of the cells
c nWells       number of wells
c locWell      horizontal location of wells
c topWell      top of well (two pieces allowed)
c botWell      bottom of well (two pieces allowed)
c wellFlag     well type
c
c Out:
c ---
c perm         (mapped) tensor for the second order problem
c facePerm     coefficient for the second order problem (if permType = 1)
c alpha        diagonal coefficients of the matrix corresponding
c              to the peaceman correction
c
c *******************************************************************

      implicit none
      include 'well.hf'
      integer i,j,k,m,well
      integer permType,nWells,wellFlag(*),locWell(2,*),
     $        topWell(2,*),botWell(2,*),n1,n2,n3
      real*8  perm(6*n1*n2*n3),facePerm(*),
     $        alpha(n1,n2,n3),mu,
     $        pmancorr(n3,*),x1(0:n1),x2(0:n2),x3(0:n3),
     $        hx,hy,hz,jacInv(n1,n2,n3),const
      logical mywell
      mywell(i,j) = (1.le.i).and.(i.le.n1).and.(1.le.j).and.(j.le.n2)

c     Computation of the Tensor perm

      const = 1.0/mu
      do 10 m=1,6*n1*n2*n3
         perm(m) = const*perm(m)
 10   continue
      if(permType.eq.1) then
         do 20 m=1,(n1+1)*n2*n3+n1*(n2+1)*n3+n1*n2*(n3+1)
            facePerm(m) = const*facePerm(m)
 20      continue
      endif

c compute the vector alpha for the peacemann correction

      do 110 k=1,n3
         do 120 j=1,n2
            do 130 i=1,n1
               alpha(i,j,k) = 0
 130        continue
 120     continue
 110  continue

      do 140 well=1,nWells
         i = locWell(1,well)
         j = locWell(2,well)
         if(.not.mywell(i,j)) goto 140
         hx = x1(i) - x1(i-1)
         hy = x2(j) - x2(j-1)
         if (wellFlag(well).eq.WELL_BOTTOMHOLE_PROD) then
            do 150 k=topWell(2,well),botWell(2,well)
               hz = x3(k) - x3(k-1)
               alpha(i,j,k) = pmancorr(k,well)/(hx*hy*hz*jacInv(i,j,k))
 150        continue
         endif
 140  continue
      return
      end
c=======================================================================
c     
      subroutine setrhs(jacInv,pmancorr,qrate,prout,nWells,
     $     wellFlag,locWell,topWell,botWell,n1,n2,n3,x1,x2,x3,f)

c *******************************************************************
c
c Description: Sets up the right hand side coefficients
c
c In:
c --
c jacInv       inverse of the Jacobian of the mapping
c n1,n2,n3     numbers of cells
c hx,hy,hz     size of the cells
c nWells       number of wells
c locWell      horizontal location of the wells
c topWell      top of well (two pieces allowed)
c botWell      bottom of well (two pieces allowed)
c wellFlag     well type
c pmancorr     Peaceman correction at the production wells
c qrate        flow rate at each layers of an injection well
c prout        wellbore pressure
c
c Out:
c ---
c f            right hand side coeficients
c *******************************************************************

      implicit none
      include 'well.hf'
      integer i,j,k,well
      integer nWells,n1,n2,n3
      integer wellFlag(*),locWell(2,*),
     $        topWell(2,*),botWell(2,*)
      real*8  jacInv(n1,n2,n3),f(n1,n2,n3),qrate(n3,*),prout(*),
     $        pmancorr(n3,*),x1(0:n1),x2(0:n2),x3(0:n3),hx,hy,hz
      logical mywell
      mywell(i,j) = (1.le.i).and.(i.le.n1).and.(1.le.j).and.(j.le.n2)

      do 10 k=1,n3
      do 10 j=1,n2
      do 10 i=1,n1
         f(i,j,k) = 0
 10   continue

      do 20 well=1,nwells
         i = locwell(1,well)
         j = locwell(2,well)
         if(.not.mywell(i,j)) goto 20

         if(wellFlag(well).eq.WELL_BOTTOMHOLE_PROD) then
            hx = x1(i) - x1(i-1)
            hy = x2(j) - x2(j-1)
            do 30 k=topWell(2,well),botWell(2,well)
               hz = x3(k) - x3(k-1)
               f(i,j,k) = prout(well)*pmancorr(k,well)
     $              / (hx*hy*hz*jacInv(i,j,k))
 30         continue
         else
            if ( (wellFlag(well).eq.WELL_INJECTION).or.
     $           (wellFlag(well).eq.WELL_REINJECTION)) then
               do 40 k=topWell(1,well),botWell(1,well)
                  f(i,j,k) = qrate(k,well)
 40            continue
            endif
            if ( (wellFlag(well).eq.WELL_EXTRACTION).or.
     $           (wellFlag(well).eq.WELL_REINJECTION)) then
               do 50 k=topWell(2,well),botWell(2,well)
                  f(i,j,k) = qrate(k,well)
 50            continue
            endif
         endif
 20   continue

      return
      end
c=======================================================================
      real*8 function pbcvalue_dir(time,region,gravity,density,
     $     depth1,depth2,depth3,depth4,
     $     presType,presPotential,presPressure,
     $     presHydraulicHead,presHead)
      implicit none

      real*8  time,gravity,density,depth
      integer region,presType,presPotential,presPressure,
     $        presHydraulicHead,presHead
      real*8  pbcvalue
      real*4  depth1,depth2,depth3,depth4

      depth() = .25*(depth1+depth2+depth3+depth4)

      pbcvalue_dir = pbcvalue(time,1,region) 
      if(presType.eq.presPressure) then
         pbcvalue_dir = pbcvalue_dir - density*gravity*depth()
      else if(presType.eq.presHydraulicHead) then
         pbcvalue_dir = density*gravity*pbcvalue_dir
      else if(presType.eq.presHead) then
         pbcvalue_dir = density*gravity*(pbcvalue_dir - depth())
      endif

      return
      end
c=======================================================================
c Sets up the boundary conditions

c In:
c   n?          Number of Grid divisions
c   bcRegion?   Region designation
c   bcType      Type of boundary conitions: see the include file
c   bcPresType  Interpretation of bc pressure in Dirichlet conditions
c               The possible types are the next set of inputs:
c                 presPotential,presPressure,presHydraulicHead,presHead
c   gravity     gravitational constant
c   density     density
c   myNbr       list of neighbors, -1 if it is an actually boundary
c   x?          point centered mesh
c   fflag       Type of integrals: see the include file

c OUT:
c   bc?       Boundary conditions

      subroutine setupBC(time,n1,n2,n3,bcRegion1,bcRegion2,bcRegion3,
     $     bcType,bcPresType,presPotential,presPressure,
     $     presHydraulicHead,presHead,gravity,density,
     $     myNbr,bc1,bc2,bc3,x1,x2,x3,map,fflag)
      implicit none
      include '../Flow/Include/BCtypes.hf'

      integer n1,n2,n3,bcType(*),myNbr(-1:1,-1:1,-1:1),fflag
      integer bcRegion1(n2,n3,2),bcRegion2(n1,n3,2),bcRegion3(n1,n2,2)
      real*8  time,bc1(n2,n3,2),bc2(n1,n3,2),bc3(n1,n2,2),
     $        x1(0:n1),x2(0:n2),x3(0:n3),gravity,density
      real*4  map(3,-1:n1+1,-1:n2+1,-1:n3+1)
      integer bcPresType(*),presPotential,presPressure,
     $        presHydraulicHead,presHead

      integer i1,i2,i3,region

      integer FLUX,VELOCITY
      parameter(FLUX=1,VELOCITY=2)

c     Function Declarations

      real*8  pbcvalue,pbcvalue_dir,boundaryArea

c Dirichlet, Neumann, and NOFLOW Conditions

c x

      if (myNbr(-1,0,0).eq.-1) then
         do 10 i3=1,n3
         do 10 i2=1,n2
            region = bcRegion1(i2,i3,1)
            if (bcType(region).eq.BCDIRICHLET) then
               bc1(i2,i3,1) = pbcvalue_dir(time,region,
     $              gravity,density,map(3,0,i2,i3),map(3,0,i2-1,i3),
     $              map(3,0,i2,i3-1),map(3,0,i2-1,i3-1),
     $              bcPresType(region),presPotential,presPressure,
     $              presHydraulicHead,presHead)
            else if (bcType(region).eq.BCNEUMANN) then
               bc1(i2,i3,1) = -pbcvalue(time,1,region)*
     $              boundaryArea(map(1,0,i2-1,i3-1),map(1,0,i2,i3-1),
     $              map(1,0,i2,i3),map(1,0,i2-1,i3))
               if (fflag.eq.FLUX) then
                  bc1(i2,i3,1) = bc1(i2,i3,1)
     $                 / ((x2(i2)-x2(i2-1))*(x3(i3)-x3(i3-1)))
               endif
            else if (bcType(region).eq.BCNOFLOW) then
               bc1(i2,i3,1) = 0.0d0
            else
               call parcelcrash('Unknown BDRY type Edge(1,1)',-30)
            endif
 10      continue
      else
         do 15 i3=1,n3
         do 15 i2=1,n2
            bc1(i2,i3,1) = 0.
 15      continue
      endif

      if (myNbr(1,0,0).eq.-1) then
         do 20 i3=1,n3
         do 20 i2=1,n2
            region = bcRegion1(i2,i3,2)
            if (bcType(region).eq.BCDIRICHLET) then
               bc1(i2,i3,2) = pbcvalue_dir(time,region,
     $              gravity,density,map(3,n1,i2,i3),map(3,n1,i2-1,i3),
     $              map(3,n1,i2,i3-1),map(3,n1,i2-1,i3-1),
     $              bcPresType(region),presPotential,presPressure,
     $              presHydraulicHead,presHead)
            else if (bcType(region).eq.BCNEUMANN) then
               bc1(i2,i3,2) = -pbcvalue(time,1,region)*
     $              boundaryArea(map(1,n1,i2-1,i3-1),map(1,n1,i2,i3-1),
     $              map(1,n1,i2,i3),map(1,n1,i2-1,i3))
               if (fflag.eq.FLUX) then
                  bc1(i2,i3,2) =  bc1(i2,i3,2)
     $                 / ((x2(i2)-x2(i2-1))*(x3(i3)-x3(i3-1)))
               endif
            else if (bcType(region).eq.BCNOFLOW) then
               bc1(i2,i3,2) = 0.0d0
            else
               call parcelcrash('Unknown BDRY type Edge(1,2)',-30)
            endif
 20      continue
      else
         do 25 i3=1,n3
         do 25 i2=1,n2
            bc1(i2,i3,2) = 0.
 25      continue
      endif

c y

      if (myNbr(0,-1,0).eq.-1) then
         do 30 i3=1,n3
         do 30 i1=1,n1
            region = bcRegion2(i1,i3,1)
            if (bcType(region).eq.BCDIRICHLET) then
               bc2(i1,i3,1) = pbcvalue_dir(time,region,
     $              gravity,density,map(3,i1,0,i3),map(3,i1-1,0,i3),
     $              map(3,i1,0,i3-1),map(3,i1-1,0,i3-1),
     $              bcPresType(region),presPotential,presPressure,
     $              presHydraulicHead,presHead)
            else if (bcType(region).eq.BCNEUMANN) then
               bc2(i1,i3,1) = -pbcvalue(time,1,region)*
     $              boundaryArea(map(1,i1-1,0,i3-1),map(1,i1,0,i3-1),
     $              map(1,i1,0,i3),map(1,i1-1,0,i3))
               if (fflag.eq.FLUX) then
                  bc2(i1,i3,1) = bc2(i1,i3,1)
     $                 / ((x1(i1)-x1(i1-1))*(x3(i3)-x3(i3-1)))
               endif
            else if (bcType(region).eq.BCNOFLOW) then
               bc2(i1,i3,1) = 0.0d0
            else
               call parcelcrash('Unknown BDRY type Edge(2,1)',-30)
            endif
 30      continue
      else
         do 35 i3=1,n3
         do 35 i1=1,n1
            bc2(i1,i3,1) = 0.
 35      continue
      endif

      if (myNbr(0,1,0).eq.-1) then
         do 40 i3=1,n3
         do 40 i1=1,n1
            region = bcRegion2(i1,i3,2)
            if (bcType(region).eq.BCDIRICHLET) then
               bc2(i1,i3,2) = pbcvalue_dir(time,region,
     $              gravity,density,map(3,i1,n2,i3),map(3,i1-1,n2,i3),
     $              map(3,i1,n2,i3-1),map(3,i1-1,n2,i3-1),
     $              bcPresType(region),presPotential,presPressure,
     $              presHydraulicHead,presHead)
            else if (bcType(region).eq.BCNEUMANN) then
               bc2(i1,i3,2) = -pbcvalue(time,1,region)*
     $              boundaryArea(map(1,i1-1,n2,i3-1),map(1,i1,n2,i3-1),
     $              map(1,i1,n2,i3),map(1,i1-1,n2,i3))
               if (fflag.eq.FLUX) then
                  bc2(i1,i3,2) = bc2(i1,i3,2)
     $                 / ((x1(i1)-x1(i1-1))*(x3(i3)-x3(i3-1)))
               endif
            else if (bcType(region).eq.BCNOFLOW) then
               bc2(i1,i3,2) = 0.0d0
            else
               call parcelcrash('Unknown BDRY type Edge(2,2)',-30)
            endif
 40      continue
      else
         do 45 i3=1,n3
         do 45 i1=1,n1
            bc2(i1,i3,2) = 0.
 45      continue
      endif

c z

      if (myNbr(0,0,-1).eq.-1) then
         do 50 i2=1,n2
         do 50 i1=1,n1
            region = bcRegion3(i1,i2,1)
            if (bcType(region).eq.BCDIRICHLET) then
               bc3(i1,i2,1) = pbcvalue_dir(time,region,
     $              gravity,density,map(3,i1,i2,0),map(3,i1-1,i2,0),
     $              map(3,i1,i2-1,0),map(3,i1-1,i2-1,0),
     $              bcPresType(region),presPotential,presPressure,
     $              presHydraulicHead,presHead)
            else if (bcType(region).eq.BCNEUMANN) then
               bc3(i1,i2,1) = -pbcvalue(time,1,region)*
     $              boundaryArea(map(1,i1-1,i2-1,0),map(1,i1,i2-1,0),
     $              map(1,i1,i2,0),map(1,i1-1,i2,0))
               if (fflag.eq.FLUX) then
                  bc3(i1,i2,1) = bc3(i1,i2,1)
     $                 / ((x1(i1)-x1(i1-1))*(x2(i2)-x2(i2-1)))
               endif
            else if (bcType(region).eq.BCNOFLOW) then
               bc3(i1,i2,1) = 0.0d0
            else
               call parcelcrash('Unknown BDRY type Edge(3,1)',-30)
            endif
 50      continue
      else
         do 55 i2=1,n2
         do 55 i1=1,n1
            bc3(i1,i2,1) = 0.
 55      continue
      endif

      if (myNbr(0,0,1).eq.-1) then
         do 60 i2=1,n2
         do 60 i1=1,n1
            region = bcRegion3(i1,i2,2)
            if (bcType(region).eq.BCDIRICHLET) then
               bc3(i1,i2,2) = pbcvalue_dir(time,region,
     $              gravity,density,map(3,i1,i2,n3),map(3,i1-1,i2,n3),
     $              map(3,i1,i2-1,n3),map(3,i1-1,i2-1,n3),
     $              bcPresType(region),presPotential,presPressure,
     $              presHydraulicHead,presHead)
            else if (bcType(region).eq.BCNEUMANN) then
               bc3(i1,i2,2) = -pbcvalue(time,1,region)*
     $              boundaryArea(map(1,i1-1,i2-1,n3),map(1,i1,i2-1,n3),
     $              map(1,i1,i2,n3),map(1,i1-1,i2,n3))
               if (fflag.eq.FLUX) then
                  bc3(i1,i2,2) = bc3(i1,i2,2)
     $                 / ((x1(i1)-x1(i1-1))*(x2(i2)-x2(i2-1)))
               endif
            else if (bcType(region).eq.BCNOFLOW) then
               bc3(i1,i2,2) = 0.0d0
            else
               call parcelcrash('Unknown BDRY type Edge(3,2)',-30)
            endif
 60      continue
      else
         do 65 i2=1,n2
         do 65 i1=1,n1
            bc3(i1,i2,2) = 0.
 65      continue
      endif

      return
      end
c=======================================================================
c Determine if the global problem is singular
c    Return 1 if problem is singular, 0 otherwise

      integer function isSingular(alpha,bcType,nBCRegions,n)
      implicit none
      include '../Flow/Include/BCtypes.hf'
      include 'mpif.h'
cmpi      include 'msgs.hf'

      integer n,nBCRegions,bcType(nBCRegions),i,sing
      real*8  alpha(n)

      integer region,error

      sing = 1

c If not all BC's are Neumann, then the problem is not singular

      do region = 1,nBCRegions
         if ( (bcType(region).ne.BCNEUMANN).and.
     $        (bcType(region).ne.BCNOFLOW) ) sing = 0
      enddo

c If the lower order term is not zero, then the problem is not singular

      do 20 i=1,n
         if(alpha(i).ne.0.d0) sing = 0
 20   continue

cmpi      call giminx(CMSGISSING,sing,1)
      call msg_f_Gimin1(sing,MPI_COMM_WORLD,error)

      IsSingular = sing

      return
      end
c=======================================================================

      subroutine Parcelcrash(msg,errorcode)
      implicit none
      include 'mpif.h'
      integer errorcode,mynod,mynodex,error
      character*(*) msg

cmpi      mynod = mynodex()
      call MPI_Comm_rank(MPI_COMM_WORLD,mynod,error)

      write(*,1000) mynod,errorcode,msg
 1000 format('FATAL ERROR IN FLOW: node=',i4.4,', code=',i5,3x,a)

      stop
      end
c-----------------------------------------------------------------------
c Compute the area of an element's face
c   Vertices:
c     d---c
c     |   |
c     a---b

      real*8 function boundaryArea(a,b,c,d)
      implicit none

      real*4 a(3),b(3),c(3),d(3),m(3),u(3),v(3)
      integer i
      real*8 crosArea

      do i = 1,3
         m(i) = .25*(a(i) + b(i) + c(i) + d(i))
      enddo

      do i = 1,3
         u(i) = m(i) - a(i)
         v(i) = b(i) - a(i)
      enddo
      boundaryArea = crosArea(u,v)
      do i = 1,3
         v(i) = d(i) - a(i)
      enddo
      boundaryArea = boundaryArea + crosArea(u,v)
      do i = 1,3
         u(i) = m(i) - c(i)
         v(i) = b(i) - c(i)
      enddo
      boundaryArea = boundaryArea + crosArea(u,v)
      do i = 1,3
         v(i) = d(i) - c(i)
      enddo
      boundaryArea = boundaryArea + crosArea(u,v)
      boundaryArea = .5*boundaryArea

      return
      end
c-----------------------------------------------------------------------
c Compute the absolute value of a vector product

      real*8 function crosArea(u,v)
      implicit none
      INTRINSIC sqrt

      real*4 u(3),v(3)

      crosArea = sqrt( (u(2)*v(3) - u(3)*v(2))**2 
     $     + (u(1)*v(3) - u(3)*v(1))**2  
     $     + (u(1)*v(2) - u(2)*v(1))**2 )

      return
      end
