/*
Todd Arbogast
The University of Texas at Austin
August 1996 and March 1997
*/
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "msgs.h"
#include "read.h"

#include "driverGlobals.h"

#define SIZE_BUF 16384
/* #define SIZE_BUF 4096 */
#define BEGIN_LIST '{'
#define END_LIST   '}'
#define BEGIN_UNIT '['
#define END_UNIT   ']'

/* MACROS */
#define max(x,y) (((x)>(y)) ? (x) : (y))
#define min(x,y) (((x)<(y)) ? (x) : (y))

#define iLocal(i)  i - xOffset_g_(0)
#define jLocal(j)  j - yOffset_g_(0)
#define kLocal(k)  k - zOffset_g_(0)
#define array_(l,i,j,k) \
  array[l + n*(i+px + (nnx+2*px)*(j+py + (nny+2*py)*(k+pz)))]
#define arrayBndry_(l,i,j) \
  arrayBndry[l + n*(i+p1 + (nn1+2*p1)*(j+p2))]

int getString(char* string, int charSize) {
  int c;
  int error = 0;
  int list = 0;

  if(!myProc) {
    skipWS();
    c = prs_getc();
    if(c == BEGIN_LIST) {
      list = 1;
    } else {
      prs_ungetc(c);
      list = 0;
    }
  }

  /* gibcastX(MSG_READ3D,&list,1,0); */
  MPI_Bcast((void*)&list,1,MPI_INT,0,comm);

  if(list) {
    string[0] = BEGIN_LIST;
    string[1] = '\0';
    prs_echoString(string);
    prs_echoChar('\n');
  } else {
    readString(string,charSize);
  }

 exit:
  return error;
}

int getUnits(double* units, int* dimen) {
  int error = 0;

  if(myProc) return 0;

  skipWS();
  error = prs_readUnits(units,dimen);
  if(error == NO_UNITS) {
    error = 0;
  } else if(error) {
    goto exit;
  } else {
    char str[34];
    sprintf(str,"   # * %g\n",*units);
    prs_echoString(str);
  }

 exit:
  return error;
}

/* EVALUATE TEMPLATES FOR EACH REQUIRED TYPE */

#define CAT2(i,j) Cat2(i,j)
#define Cat2(i,j) i##j
#define CAT3(i,j,k) Cat3(i,j,k)
#define Cat3(i,j,k) i##j##k

/* double */
#define TYPE double
#define TYPE_CAP Double
#define TYPE_UNITS units
#include "read3DTemplate.h"
#undef TYPE
#undef TYPE_CAP
#undef TYPE_UNITS

/* float */
#define TYPE float
#define TYPE_CAP Float
#define TYPE_UNITS units
#include "read3DTemplate.h"
#undef TYPE
#undef TYPE_CAP
#undef TYPE_UNITS

/* int */
#define TYPE int
#define TYPE_CAP Int
#include "read3DTemplate.h"
#undef TYPE
#undef TYPE_CAP
