#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "read.h"

#include "driverGlobals.h"

#define STRING_IS(str) !strcmp(string,str)

/******************************************************************************
Title: readChemGen
Description: Read and preprocess the general chemistry 
Return: Error code (see reader.h).
*/
int readChemGen() {
  static char CHEMISTRY[] = {"CHEMISTRY"};
  char string[21];

  int error = 0;

  skipToSection(CHEMISTRY);
  packDoubleTemp(absTemp);
  packDoubleUnits(chemPres,DIMEN_PRESSURE);
  readString(string,21);
  if(STRING_IS("ideal")) {
    ideal = 1;
  } else if(STRING_IS("non-ideal")) {
    ideal = 0;
  } else ABORT(-1);

 exit:
  if(myProc == 0) {
    switch(error) {
    case -1:
      fprintf(stderr,"Reaction type must be ideal or non-ideal\n");
      error = ERR_ON_LINE;
      break;
    }
  }
  return error;
}
