#include <stdlib.h>
#include "read.h"
#include "typeNumbers.h"

#include "driverGlobals.h"

/******************************************************************************
Title: readMiscDisp
Description: Read and preprocess the miscible displacement data.
Return: Error code (see reader.h).
*/
int readMiscDisp() {
  static char MISCIBLE_DISPLACEMENT[] = {"MISCIBLE DISPLACEMENT"};

  int i;
  int error = 0;

  skipToSection(MISCIBLE_DISPLACEMENT);

  packInt(modelMiscDisp);
  unPackInt();
  switch(modelMiscDisp) {
  case 0:
    goto exit;
  case UMD_QUARTER_POWER:
    steadyFlow = 0;
    break;
  default:
    ABORT(ERR_UNSUPPORTED_OPTION);
  }

  viscosityRatio = (double*) malloc(nSpecies*sizeof(double));
  if(viscosityRatio == NULL) ABORT(ERR_MEMORY);

  beginList();
  for(i=0; i<nSpecies; i++) {
    packDoubleUnits(viscosityRatio[i],DIMEN_NUMBER);
  }
  endList();

 exit:
  return error;
}
