c#######################################################################
c Title: transportSetup
c Set-up the transport routines by initializing certain global
c   variables and functions

      subroutine transportSetup(nDom,myDom,myNbr,
     $     nxp_g,nyp_g,nzp_g,nxp,nyp,nzp,padxp,padyp,padzp,
     $     nxc_g,nyc_g,nzc_g,nxc,nyc,nzc,padxc,padyc,padzc,
     $     xp,yp,zp,xc,yc,zc,identityMap,dMap,
     $     point_xc,point_yc,point_zc,
     $     effPorosity,nsorpTypes,sorp,
     $     ncomp,steadyFlow,tInitial,tFinal,
     $     velX,velY,velZ)
      implicit none
      include 'msgs.hf'

      integer nDom(3),myDom(3),myNbr(-1:1,-1:1,-1:1)
      integer nxp_g,nyp_g,nzp_g,nxp,nyp,nzp,padxp,padyp,padzp
      integer nxc_g,nyc_g,nzc_g,nxc,nyc,nzc,padxc,padyc,padzc
      real*8  xp(-padxp:nxp+padxp),yp(-padyp:nyp+padyp),
     $        zp(-padzp:nzp+padzp)
      real*8  xc(-padxc-1:nxc+padxc+1),yc(-padyc-1:nyc+padyc+1),
     $        zc(-padzc-1:nzc+padzc+1)
      integer identityMap
      real*4  dMap(3,3,(nxp+1)*(nyp+1)*(nzp+1))
      integer point_xc(-1:2),point_yc(-1:2),point_zc(-1:2)

      real*8  effPorosity(nxp*nyp*nzp)
      integer nsorpTypes
      real*8  sorp(nsorpTypes)
      integer ncomp,steadyFlow
      real*8  tInitial,tFinal
      real*8  velX(*),velY(*),velZ(*)

c Internal variables

      integer nxr,nyr,nzr

c-----------------------------------------------------------------------

      nxr = nxp_g/nxc_g
      nyr = nyp_g/nyc_g
      nzr = nzp_g/nzc_g

c GLOBALS

      call cglobals(ncomp,xc(-padxc),yc(-padyc),zc(-padzc),
     $     nxc,nyc,nzc,padxc,padyc,padzc,
     $     point_xc(0),point_yc(0),point_zc(0),nxc_g,nyc_g,nzc_g,
     $     myDom,nDom,myNbr)

c TRANSPORT FUNCTIONS

      call allocFcnMem(xp(-padxp),yp(-padyp),zp(-padzp),
     $     nxp,nyp,nzp,padxp,padyp,padzp,
     $     nsorpTypes,myNbr,MSGFCN,myDom(1)+myDom(2)+myDom(3),
     $     identityMap,dMap,nxr,nyr,nzr)

      call sendPorosData(effPorosity)
      if(nsorpTypes.gt.0) call sendSorpData(sorp)

      if(steadyFlow.eq.0) then
         call sendVelPorSatData(velX,velY,velZ,effPorosity,tInitial-10.)
         call sendVelPorSatData(velX,velY,velZ,effPorosity,tInitial)
      else
         call sendVelPorSatData(velX,velY,velZ,effPorosity,tInitial)
         call sendVelPorSatData(velX,velY,velZ,effPorosity,tFinal)
      endif

      return
      end
