c********************************************************************

      subroutine hog(cbar,s,dx,dy,dz,dt,tc,tp,cflTimeOnly,
     $     nWells,wellFlag,hWellIndex,zWellIndexLo,zWellIndexHi,
     $     wellInj,padxc,padyc,padzc,nxc,nyc,nzc,
     $     ncomp,phaseDist,mynbr,xc,yc,zc,
     $     traceType,sorpType,computeTransport,slx,sly,slz,
     $     velx,vely,velz,phios,phis,
     $     xVelocity,yVelocity,zVelocity,msg,
     $     flagwell,monitorRoutines)

c****  This subroutine models transport
c****  An unsplit, higher order Godunov method is used
c      If cflTimeOnly is set to a non-zero number, this will return
c      after finding a timestep which satisfies the CFL constraint
c
c********************************************************************
      implicit none
      include 'mpif.h'
      include '../Main/well.hf'

      integer NPHASES
      parameter(NPHASES=1)

      integer nxc,nyc,nzc,ncomp,padxc,padyc,padzc
      real*4  s(-padxc:nxc+padxc+1,-padyc:nyc+padyc+1,
     $     -padzc:nzc+padzc+1,ncomp)

      real*8 dx(-padxc:nxc+padxc+1),dy(-padyc:nyc+padyc+1),
     $     dz(-padzc:nzc+padzc+1),dt,tc,tp
      real*8 xc(-padxc:nxc+padxc+2),yc(-padyc:nyc+padyc+2),
     $     zc(-padzc:nzc+padzc+2),
     $     wellInj(ncomp,*)
      real*8 cbar(nxc,nyc,nzc,ncomp),phaseDist(0:NPHASES,ncomp)
      integer cflTimeOnly,monitorRoutines
      integer nWells,wellFlag(nwells), mynbr(-1:1,-1:1,-1:1)
      integer hWellIndex(2,*),zWellIndexLo(2,*),zWellIndexHi(2,*)
      integer flagwell(0:nxc+1,0:nyc+1,0:nzc+1)
      integer sorpType(ncomp),traceType(ncomp)

      real*8 f,df,vdifx,vdify,vdifz,vaddif,phidif,v,c,
     $     dtd2,phi,phio,sat(NPHASES),stem,siphjk,sijphk,sijkph

      integer msg,ierror
      real*8 xVelocity(0:nxc,nyc,nzc,NPHASES),
     $     yVelocity(nxc,0:nyc,nzc,NPHASES),
     $     zVelocity(nxc,nyc,0:nzc,NPHASES)

      real*8 phis(0:nxc+1,0:nyc+1,0:nzc+1),
     $     phios(0:nxc+1,0:nyc+1,0:nzc+1)
      real*8 velx(-1:nxc+1,0:nyc+1,0:nzc+1),
     $     vely(0:nxc+1,-1:nyc+1,0:nzc+1),
     $     velz(0:nxc+1,0:nyc+1,-1:nzc+1)
      real*8 slx(0:nxc+1,0:nyc+1,0:nzc+1),sly(0:nxc+1,0:nyc+1,0:nzc+1),
     $       slz(0:nxc+1,0:nyc+1,0:nzc+1)
      real*8 slxijk,slxijp1k,slxijm1k,slxijkm1,slxip1jk,slxip1jp1k,
     $     slxip1jm1k,slxijkp1,
     $     slxijp1km1,slxijm1kp1,slxijp1kp1,
     $     slxip1jkm1,slxim1jp1k,slxim1jkp1,slxip1jkp1,slxim1jk
      real*8 slyijk,slyijp1k,slyijm1k,slyijkm1,slyip1jk,slyip1jp1k,
     $     slyip1jm1k,slyip1jkm1,slyip1jkp1,slyijkp1,
     $     slyijp1km1,slyijm1kp1,slyijp1kp1,
     $     slyim1jp1k,slyim1jkp1,slyim1jk
      real*8 slzijk,slzijp1k,slzijm1k,slzijkm1,slzip1jk,slzip1jp1k,
     $     slzip1jm1k,slzip1jkm1,slzip1jkp1,slzijkp1,
     $     slzijp1km1,slzijm1kp1,slzijp1kp1,
     $     slzim1jp1k,slzim1jkp1,slzim1jk
      real*8 slxyijk,slxzijk,slyzijk,slxyzijk
ccc:
c      real*8 slxyijk,slxyijp1k,slxyijm1k,slxyijkm1,slxyip1jk,
c     $     slxyip1jp1k,
c     $     slxyip1jm1k,slxyip1jkm1,slxyip1jkp1,slxyijkp1,
c     $     slxyijp1km1,slxyijm1kp1,slxyijp1kp1,
c     $     slxyim1jp1k,slxyim1jkp1,slxyim1jk
c      real*8 slxzijk,slxzijp1k,slxzijm1k,slxzijkm1,slxzip1jk,
c     $     slxzip1jp1k,
c     $     slxzip1jm1k,slxzip1jkm1,slxzip1jkp1,slxzijkp1,
c     $     slxzijp1km1,slxzijm1kp1,slxzijp1kp1,
c     $     slxzim1jp1k,slxzim1jkp1,slxzim1jk
c      real*8 slyzijk,slyzijp1k,slyzijm1k,slyzijkm1,slyzip1jk,
c     $     slyzip1jp1k,
c     $     slyzip1jm1k,slyzip1jkm1,slyzip1jkp1,slyzijkp1,
c     $     slyzijp1km1,slyzijm1kp1,slyzijp1kp1,
c     $     slyzim1jp1k,slyzim1jkp1,slyzim1jk
c      real*8 slxyzijk,slxyzijp1k,slxyzijm1k,slxyzijkm1,slxyzip1jk,
c     $     slxyzip1jp1k,slxyzip1jm1k,slxyzip1jkm1,slxyzip1jkp1,
c     $     slxyzijkp1,
c     $     slxyzijp1km1,slxyzijm1kp1,slxyzijp1kp1,
c     $     slxyzim1jp1k,slxyzim1jkp1,slxyzim1jk
ccc.

      real*8 rcijk
      real*8 sijk,sip1jk,sijp1k,sijm1k,sijkp1,sijkm1,sip1jkm1,sip1jkp1,
     $     sip1jm1k,sip1jp1k,sijp1km1,sijp1kp1,sijm1kp1,
     $     sim1jp1k,sim1jkp1,sim1jk
      real*8 vx,vxiphjk,vximhjk,vximhjp1k,vxiphjp1k,vximhjkp1,vxiphjkp1
ccc      real*8 vad(3,10)
      real*8 vy,vyijmhk,vyip1jmhk,vyijphk,vyip1jphk,vyijmhkp1,vyijphkp1
      real*8 vz,vzijkmh,vzip1jkmh,vzijkph,vzip1jkph,vzijp1kmh,vzijp1kph
      real*8 gampy,dyd2,gampz,dzd2,gampx,dxd2,gammy,gammz,gammx
      real*8 evalOneSorp
      integer imax,jmax,kmax,i,j,k,l,n,ph,computeTransport,islope
      integer advFlag
      integer ii,jj,kk
      real*8 dtCFL

      logical myWell,nearbyWell
      myWell(i,j) = 0.lt.i.and.i.lt.imax+1.and.0.lt.j.and.j.lt.jmax+1
      nearbyWell(i,j) =
     $     0.le.i.and.i.le.imax+1.and.0.le.j.and.j.le.jmax+1

      f(v,c)=v*c
      df(v,c)=v

      imax=nxc
      jmax=nyc
      kmax=nzc

      if(mynbr(-1,0,0).eq.-1) dx(0) = xc(1)-xc(0)
      if(mynbr(0,-1,0).eq.-1) dy(0) = yc(1)-yc(0)
      if(mynbr(0,0,-1).eq.-1) dz(0) = zc(1)-zc(0)
      if(mynbr(1,0,0).eq.-1)  dx(nxc+1) = xc(nxc+2)-xc(nxc+1)
      if(mynbr(0,1,0).eq.-1)  dy(nyc+1) = yc(nyc+2)-yc(nyc+1)
      if(mynbr(0,0,1).eq.-1)  dz(nzc+1) = zc(nzc+2)-zc(nzc+1)

 1000 continue
      dtd2=dt*.5d0
      dtCFL=dt

      do 9000 n=1,ncomp

      if (traceType(n).eq.0) then
         do k=1,kmax
         do j=1,jmax
         do i=1,imax
            cbar(i,j,k,n)=s(i,j,k,n)
            cbar(i,j,k,n)=dmax1(0.0d0,cbar(i,j,k,n))
         enddo
         enddo
         enddo
         go to 9000
      endif

      do 20 k=1,kmax
      do 20 j=1,jmax
      do 20 i=0,imax
         velx(i,j,k)=0.0
         do ph=1,NPHASES
            velx(i,j,k)
     $           = velx(i,j,k) + phaseDist(ph,n)*xVelocity(i,j,k,ph)
         enddo
 20   continue
      do 25 k=1,kmax
      do 25 j=0,jmax
      do 25 i=1,imax
         vely(i,j,k)=0.0
         do ph=1,NPHASES
            vely(i,j,k)
     $           = vely(i,j,k) + phaseDist(ph,n)*yVelocity(i,j,k,ph)
         enddo
 25   continue
      do 30 k=0,kmax
      do 30 j=1,jmax
      do 30 i=1,imax
         velz(i,j,k)=0.0
         do ph=1,NPHASES
            velz(i,j,k)
     $           = velz(i,j,k) + phaseDist(ph,n)*zVelocity(i,j,k,ph)
         enddo
 30   continue
      call padarray(velx, imax+1,jmax,kmax, 1,0,0, 1,1,1,
     $     myNbr,msg,ierror)
      if(ierror.ne.0) STOP
      call padarray(vely, imax,jmax+1,kmax, 0,1,0, 1,1,1,
     $     myNbr,msg,ierror)
      if(ierror.ne.0) STOP
      call padarray(velz, imax,jmax,kmax+1, 0,0,1, 1,1,1,
     $     myNbr,msg,ierror)
      if(ierror.ne.0) STOP
ccc:
c      do 20 k=0,kmax+1
c      do 20 j=0,jmax+1
c      do 20 i=-1,imax+1
c         velx(i,j,k)=0.0
c         if (i.eq.-1.and.mynbr(-1,0,0).eq.-1) go to 20
c         if (i.eq.imax+1.and.mynbr(1,0,0).eq.-1) go to 20
c         call evalVel(xc(i+1),.5*(yc(j)+yc(j+1)),.5*(zc(k)+zc(k+1))
c     $        ,tc,vad)
c         do ph=1,NPHASES
c            velx(i,j,k)=velx(i,j,k)+phaseDist(ph,n)*vad(1,ph)
c         enddo
c 20   continue
c 
c      do 25 k=0,kmax+1
c      do 25 i=0,imax+1
c      do 25 j=-1,jmax+1
c         vely(i,j,k)=0.0
c         if (j.eq.-1.and.mynbr(0,-1,0).eq.-1) go to 25
c         if (j.eq.jmax+1.and.mynbr(0,1,0).eq.-1) go to 25
c         call evalVel(.5*(xc(i)+xc(i+1)),yc(j+1),.5*(zc(k)+zc(k+1))
c     $        ,tc,vad)
c         do ph=1,NPHASES
c            vely(i,j,k)=vely(i,j,k)+phaseDist(ph,n)*vad(2,ph)
c         enddo
c 25   continue
cc
c      do 30 j=0,jmax+1
c      do 30 i=0,imax+1
c      do 30 k=-1,kmax+1
c         velz(i,j,k)=0.0
c         if (k.eq.-1.and.mynbr(0,0,-1).eq.-1) go to 30
c         if (k.eq.kmax+1.and.mynbr(0,0,1).eq.-1) go to 30
c         call evalVel(.5*(xc(i)+xc(i+1)),.5*(yc(j)+yc(j+1)),zc(k+1)
c     $        ,tc,vad)
c         do ph=1,NPHASES
c            velz(i,j,k)=velz(i,j,k)+phaseDist(ph,n)*vad(3,ph)
c         enddo         
c 30   continue
ccc.

      do 35 k=0,kmax+1
      do 40 j=0,jmax+1
      do 45 i=0,imax+1
         slx(i,j,k)=0.0d0
         sly(i,j,k)=0.0d0
         slz(i,j,k)=0.0d0
         if (k.eq.0.and.mynbr(0,0,-1).eq.-1) go to 45
         if (k.eq.kmax+1.and.mynbr(0,0,1).eq.-1) go to 45
         if (j.eq.0.and.mynbr(0,-1,0).eq.-1) go to 45
         if (j.eq.jmax+1.and.mynbr(0,1,0).eq.-1) go to 45
         if (i.eq.0.and.mynbr(-1,0,0).eq.-1) go to 45
         if (i.eq.imax+1.and.mynbr(1,0,0).eq.-1) go to 45
         rcijk=evalOneSorp(.5*(xc(i)+xc(i+1)),.5*(yc(j)+yc(j+1)),
     $        .5*(zc(k)+zc(k+1)),sorpType(n))*phaseDist(0,n)

         call evalPorSat(.5*(xc(i)+xc(i+1)),.5*(yc(j)+yc(j+1)),
     $        .5*(zc(k)+zc(k+1)),tc,sat)
         phios(i,j,k)=0.0
         do ph=1,NPHASES
            phios(i,j,k)=phios(i,j,k)+sat(ph)*phaseDist(ph,n)
         enddo
         phios(i,j,k)=phios(i,j,k)+rcijk

         call evalPorSat(.5*(xc(i)+xc(i+1)),.5*(yc(j)+yc(j+1)),
     $        .5*(zc(k)+zc(k+1)),tc+dt*.5,sat)
         phis(i,j,k)=0.0
         do ph=1,NPHASES
            phis(i,j,k)=phis(i,j,k)+sat(ph)*phaseDist(ph,n)
         enddo
         phis(i,j,k)=phis(i,j,k)+rcijk

 45   continue
 40   continue
 35   continue 
 
      do k=1,kmax
      do j=1,jmax
      do i=1,imax
         phio=phios(i,j,k)

         vxiphjk=.5*(velx(i,j,k)+velx(i-1,j,k))

         if (dt/dx(i)*dabs(vxiphjk).gt.phio) then
c            write(*,*) 'violating CFL timestep constraint'
c            write(*,*) 'dt, dx, vxiphjk, phio ',dt,dx(i),
c     $           vxiphjk,phio,sat(1),i,j,k,mybnr(0,0,0)
            dtCFL=dmin1(dtCFL,dx(i)*phio/dabs(vxiphjk))
         endif          

         vyijphk=.5*(vely(i,j,k)+vely(i,j-1,k))

         if (dt/dy(j)*dabs(vyijphk).gt.phio) then
c            write(*,*) 'violating CFL timestep constraint'
c            write(*,*) 'dt, dy, vyijphk, phio ',dt,dy(j),
c     $           vyijphk,phio,sat(1),i,j,k,mybnr(0,0,0)
            dtCFL=dmin1(dtCFL,dy(j)*phio/dabs(vyijphk))
         endif          

         vzijkph=.5*(velz(i,j,k)+velz(i,j,k-1))

         if (dt/dz(k)*dabs(vzijkph).gt.phio) then
c            write(*,*) 'violating CFL timestep constraint'
c            write(*,*) 'dt, dz, vzijkph, phio', dt,dz(k),
c     $           vzijkph,phio,sat(1),i,j,k,mybnr(0,0,0)
            dtCFL=dmin1(dtCFL,dz(k)*phio/dabs(vzijkph))
         endif
c         write(30+mybnr(0,0,0),*) i,j,k,dtCFL
      enddo
      enddo
      enddo

      rcijk = dtCFL 

C Wells add another CFL-type time constraint to the picture
      do l = 1, nwells 
         if(wellFlag(l).eq.WELL_INJECTION.or.
     $        wellFlag(l).eq.WELL_REINJECTION) then
            i = hWellIndex(1,l)
            j = hWellIndex(2,l)
            if (myWell(i,j)) then
               do k = zWellIndexLo(1,l),zWellIndexHi(1,l)
                  vaddif=(velx(i,j,k)-velx(i-1,j,k))/dx(i)
     $                 +(vely(i,j,k)-vely(i,j-1,k))/dy(j)
     $                 +(velz(i,j,k)-velz(i,j,k-1))/dz(k)
                  if(vaddif.gt.0.) then
                     phio = phios(i,j,k)
                     rcijk = min(rcijk,phio/vaddif)
                  endif
               enddo
            endif
         endif
      enddo

cmpi      call gdminx( 10, rcijk, 1)
cmpi      call gsyncx()
      call MSG_f_Gdmin1(rcijk,MPI_COMM_WORLD)
      dtCFL = min(rcijk,abs(tp-tc))
    
      if(dtCFL.lt.dt) then
         dt = dtCFL
         if(monitorRoutines.ne.0) write(*,*) 'CFL dt should be ',dtCFL
         if(dtCFL.eq.0) STOP
         if(cflTimeOnly.eq.0) goto 1000
      else if(dtCFL.gt.(1.2*dt)) then
         dt= 1.2d0*dtCFL
         if(monitorRoutines.ne.0) write(*,*) 'CFL dt increased to ', dt
         if(cflTimeOnly.eq.0) goto 1000
      endif
      if(cflTimeOnly.ne.0) goto 9900

      do 135 k=1,kmax
      do 140 j=1,jmax
      do 145 i=1,imax
         cbar(i,j,k,n)=s(i,j,k,n)*phios(i,j,k)
 145  continue
 140  continue
 135  continue 

      if(computeTransport.eq.2) then
         islope=1
         do 5 k=0,kmax+1
            if (k.eq.0.and.mynbr(0,0,-1).eq.-1) go to 5
            if (k.eq.kmax+1.and.mynbr(0,0,1).eq.-1) go to 5
            do 10 j=0,jmax+1
               if (j.eq.0.and.mynbr(0,-1,0).eq.-1) go to 10
               if (j.eq.jmax+1.and.mynbr(0,1,0).eq.-1) go to 10
               do 15 i=0,imax+1
                  if (i.eq.0.and.mynbr(-1,0,0).eq.-1) go to 15
                  if (i.eq.imax+1.and.mynbr(1,0,0).eq.-1) go to 15
                  call slope(i,j,k,slxijk,slyijk,slzijk,
     $                 slxyijk,slxzijk,slyzijk,slxyzijk,n,s,
     $                 padxc,padyc,padzc,dx,dy,dz,ncomp,
     $                 nxc,nyc,nzc,islope)
                  slx(i,j,k)=slxijk
                  sly(i,j,k)=slyijk
                  slz(i,j,k)=slzijk
 15            continue
 10         continue
 5       continue
      endif

      do k=0,kmax+1
      do j=0,jmax+1
      do i=0,imax+1
         flagwell(i,j,k)=0
      enddo
      enddo
      enddo

      do l=1,nWells
         if(wellFlag(l).eq.WELL_INJECTION.or.
     $        wellFlag(l).eq.WELL_REINJECTION) then
ctja 8/29/97            if (wellInj(n,l).gt.0.) then
            i=hWellIndex(1,l)
            j=hWellIndex(2,l)
            if (nearbyWell(i,j)) then
               do k=1,kmax
                  if (zWellIndexLo(1,l).le.k.and.
     $                 k.le.zWellIndexHi(1,l)) then
                     flagwell(i,j,k)=1
                  endif
               enddo
ctja               endif
            endif
         endif
      enddo

      do k=1,kmax
      do j=1,jmax
      do i=0,imax
         advFlag = computeTransport
         if(flagwell(i,j,k).eq.1 .or. flagwell(i+1,j,k).eq.1) advFlag=3

         vxiphjk=velx(i,j,k)

         if (vxiphjk.ge.0.0) then

            if (i.eq.0.and.mynbr(-1,0,0).eq.-1) then
               siphjk=s(0,j,k,n)
               cbar(i+1,j,k,n)
     $              = cbar(i+1,j,k,n)+dt/dx(i+1)*vxiphjk*siphjk
               go to 100
            endif

            if (advFlag.eq.2) then

            slxijk=slx(i,j,k)
            slyijk=sly(i,j,k)
            slzijk=slz(i,j,k)
            slxijp1k=slx(i,j+1,k)
            slyijp1k=sly(i,j+1,k)
            slzijp1k=slz(i,j+1,k)
            slxijkp1=slx(i,j,k+1)
            slyijkp1=sly(i,j,k+1)
            slzijkp1=slz(i,j,k+1)
            slxijm1k=slx(i,j-1,k)
            slyijm1k=sly(i,j-1,k)
            slzijm1k=slz(i,j-1,k)
            slxijkm1=slx(i,j,k-1)
            slyijkm1=sly(i,j,k-1)
            slzijkm1=slz(i,j,k-1)

            sijk=s(i,j,k,n)
            sijp1k=s(i,j+1,k,n)
            sijm1k=s(i,j-1,k,n)
            sijkp1=s(i,j,k+1,n)
            sijkm1=s(i,j,k-1,n)

            vyijmhk=vely(i,j-1,k)
            vyijphk=vely(i,j,k)
            vzijkmh=velz(i,j,k-1)
            vzijkph=velz(i,j,k)

            if(vyijphk.ge.0)then
               dyd2=dy(j)*.5d0
               gampy=sijk+slyijk*dyd2
            else
               dyd2=dy(j+1)*.5d0
               gampy=sijp1k-dyd2*slyijp1k
            endif
            if(vzijkph.ge.0)then
               dzd2=dz(k)*.5d0
               gampz=sijk+slzijk*dzd2
            else
               dzd2=dz(k+1)*.5d0
               gampz=sijkp1-dzd2*slzijkp1
            endif


            if(vyijmhk.ge.0)then
               dyd2=dy(j-1)*.5d0
               gammy=sijm1k+dyd2*slyijm1k
            else
               dyd2=dy(j)*.5d0
               gammy=sijk-dyd2*slyijk
            endif
            if(vzijkmh.ge.0)then
               dzd2=dz(k-1)*.5d0
               gammz=sijkm1+dzd2*slzijkm1
            else
               dzd2=dz(k)*.5
               gammz=sijk-dzd2*slzijk
            endif


            dxd2=dx(i)*.5d0
            stem=sijk+dxd2*slxijk


            phio=phios(i,j,k)
            phi=phis(i,j,k)

            dxd2=dx(i)*.5
            vdify=dtd2*(vyijphk*gampy-vyijmhk*gammy)/dy(j)
            vdifz=dtd2*(vzijkph*gampz-vzijkmh*gammz)/dz(k)

            vximhjk=velx(i-1,j,k)

            vaddif=stem*dtd2*(vxiphjk-vximhjk)/dx(i)
            phidif=stem*(phi-phio)
            siphjk=sijk
     &           +(dxd2-.5*dt*df(vxiphjk/phi,sijk))*slxijk
            siphjk=siphjk-(vdify+vdifz+vaddif+phidif)/phi

            else
               siphjk= s(i,j,k,n) !sijk
            endif


c  vx < 0

         else

            if (i.eq.imax.and.mynbr(1,0,0).eq.-1) then
               siphjk=s(imax+1,j,k,n)
               cbar(i,j,k,n)=cbar(i,j,k,n)-dt/dx(i)*vxiphjk*siphjk
               go to 100
            endif

            if (advFlag.eq.2) then

            slxip1jk=slx(i+1,j,k)
            slyip1jk=sly(i+1,j,k)
            slzip1jk=slz(i+1,j,k)
            slxip1jp1k=slx(i+1,j+1,k)
            slyip1jp1k=sly(i+1,j+1,k)
            slzip1jp1k=slz(i+1,j+1,k)
            slxip1jm1k=slx(i+1,j-1,k)
            slyip1jm1k=sly(i+1,j-1,k)
            slzip1jm1k=slz(i+1,j-1,k)
            slxip1jkm1=slx(i+1,j,k-1)
            slyip1jkm1=sly(i+1,j,k-1)
            slzip1jkm1=slz(i+1,j,k-1)
            slxip1jkp1=slx(i+1,j,k+1)
            slyip1jkp1=sly(i+1,j,k+1)
            slzip1jkp1=slz(i+1,j,k+1)

            sip1jk=s(i+1,j,k,n)
            sip1jkm1=s(i+1,j,k-1,n)
            sip1jkp1=s(i+1,j,k+1,n)
            sip1jm1k=s(i+1,j-1,k,n)
            sip1jp1k=s(i+1,j+1,k,n)

            vyip1jmhk=vely(i+1,j-1,k)
            vyip1jphk=vely(i+1,j,k)
            vzip1jkmh=velz(i+1,j,k-1)
            vzip1jkph=velz(i+1,j,k)

            if(vyip1jphk.ge.0)then
               dyd2=dy(j)*.5d0
               gampy=sip1jk+dyd2*slyip1jk
            else
               dyd2=dy(j+1)*.5d0
               gampy=sip1jp1k-dyd2*slyip1jp1k
            endif

            if(vzip1jkph.ge.0)then
               dzd2=dz(k)*.5d0
               gampz=sip1jk+dzd2*slzip1jk
            else
               dzd2=dz(k+1)*.5d0
               gampz=sip1jkp1-dzd2*slzip1jkp1
            endif

            if(vyip1jmhk.ge.0)then
               dyd2=dy(j-1)*.5
               gammy=sip1jm1k+dyd2*slyip1jm1k
            else
               dyd2=dy(j)*.5
               gammy=sip1jk-dyd2*slyip1jk
            endif
            if(vzip1jkmh.ge.0)then
               dzd2=dz(k-1)*.5d0
               gammz=sip1jkm1+dzd2*slzip1jkm1
            else
               dzd2=dz(k)*.5d0
               gammz=sip1jk-dzd2*slzip1jk
            endif

            dxd2=dx(i+1)*.5d0
            stem=sip1jk-dxd2*slxip1jk

            phio=phios(i+1,j,k)
            phi=phis(i+1,j,k)

            dxd2=dx(i+1)*.5
            vdify=dtd2*(vyip1jphk*gampy-vyip1jmhk*gammy)/dy(j)
            vdifz=dtd2*(vzip1jkph*gampz-vzip1jkmh*gammz)/dz(k)
            vx=velx(i+1,j,k)
            vaddif=stem*dtd2*(vx-vxiphjk)/dx(i+1)
            phidif=stem*(phi-phio)
            siphjk=sip1jk
     &           -(dxd2+dtd2*df(vxiphjk/phi,sip1jk))*slxip1jk
            siphjk=siphjk-(vdify+vdifz+vaddif+phidif)/phi

            else
               siphjk= s(i+1,j,k,n) !sip1jk
            endif  

         endif


        
         if (i.ne.0)
     $        cbar(i,j,k,n)=cbar(i,j,k,n)-dt/dx(i)*vxiphjk*siphjk

         if (i.ne.imax)
     $        cbar(i+1,j,k,n)=cbar(i+1,j,k,n)
     $        +dt/dx(i+1)*vxiphjk*siphjk
 100     continue

      enddo
      enddo
      enddo




      do k=1,kmax
      do i=1,imax
      do j=0,jmax
         advFlag = computeTransport
         if(flagwell(i,j,k).eq.1 .or. flagwell(i,j+1,k).eq.1) advFlag=3

         vyijphk=vely(i,j,k)

         if (vyijphk.ge.0.0) then

            if (j.eq.0.and.mynbr(0,-1,0).eq.-1) then
               sijphk=s(i,0,k,n)
               cbar(i,j+1,k,n)=cbar(i,j+1,k,n)
     $              +dt/dy(j+1)*vyijphk*sijphk
               go to 150
            endif

            if (advFlag.eq.2) then

            slxijk=slx(i,j,k)
            slyijk=sly(i,j,k)
            slzijk=slz(i,j,k)
            slxijkp1=slx(i,j,k+1)
            slyijkp1=sly(i,j,k+1)
            slzijkp1=slz(i,j,k+1)
            slxijkm1=slx(i,j,k-1)
            slyijkm1=sly(i,j,k-1)
            slzijkm1=slz(i,j,k-1)
            slxip1jk=slx(i+1,j,k)
            slyip1jk=sly(i+1,j,k)
            slzip1jk=slz(i+1,j,k)
            slxim1jk=slx(i-1,j,k)
            slyim1jk=sly(i-1,j,k)
            slzim1jk=slz(i-1,j,k)

            sijk=s(i,j,k,n)
            sijkp1=s(i,j,k+1,n)
            sijkm1=s(i,j,k-1,n)
            sim1jk=s(i-1,j,k,n)
            sip1jk=s(i+1,j,k,n)
            vximhjk=velx(i-1,j,k)
            vxiphjk=velx(i,j,k)
            vzijkmh=velz(i,j,k-1)
            vzijkph=velz(i,j,k)

            if(vxiphjk.ge.0.0d0)then
               dxd2=dx(i)*.5d0
               gampx=sijk+dxd2*slxijk
            else
               dxd2=dx(i+1)*.5d0
               gampx=sip1jk-dxd2*slxip1jk
            endif
            if(vzijkph.ge.0.0d0)then
               dzd2=dz(k)*.5d0
               gampz=sijk+dzd2*slzijk
            else
               dzd2=dz(k+1)*.5d0
               gampz=sijkp1-dzd2*slzijkp1
            endif

            if(vximhjk.ge.0)then
               dxd2=dx(i-1)*.5d0
               gammx=sim1jk+dxd2*slxim1jk
            else
               dxd2=dx(i)*.5d0
               gammx=sijk-dxd2*slxijk
            endif
            if(vzijkmh.ge.0)then
               dzd2=dz(k-1)*.5
               gammz=sijkm1+dzd2*slzijkm1
            else
               dzd2=dz(k)*.5
               gammz=sijk-dzd2*slzijk
            endif

            stem=sijk+dy(j)*.5d0*slyijk

            phio=phios(i,j,k)
            phi=phis(i,j,k)

            vdifx=dtd2*(vxiphjk*gampx-vximhjk*gammx)/dx(i)
            vdifz=dtd2*(vzijkph*gampz-vzijkmh*gammz)/dz(k)

            vyijmhk=vely(i,j-1,k)

            vaddif=stem*dtd2*(vyijphk-vyijmhk)/dy(j)
            phidif=stem*(phi-phio)
            dyd2=dy(j)*.5d0
            sijphk=sijk
     &           +(dyd2-.5d0*dt*df(vyijphk/phi,sijk))
     &           *slyijk
            sijphk=sijphk-
     &           (vdifx+vdifz+vaddif+phidif)/phi

            else
               sijphk= s(i,j,k,n) !sijk
            endif

c  vy < 0
         else
            if (j.eq.jmax.and.mynbr(0,1,0).eq.-1) then
               sijphk=s(i,jmax+1,k,n)
               cbar(i,j,k,n)=cbar(i,j,k,n)
     $              -dt/dy(j)*vyijphk*sijphk
               go to 150
            endif

            if (advFlag.eq.2) then

            slxijp1k=slx(i,j+1,k)
            slyijp1k=sly(i,j+1,k)
            slzijp1k=slz(i,j+1,k)
            slxijp1km1=slx(i,j+1,k-1)
            slyijp1km1=sly(i,j+1,k-1)
            slzijp1km1=slz(i,j+1,k-1)
            slxijp1kp1=slx(i,j+1,k+1)
            slyijp1kp1=sly(i,j+1,k+1)
            slzijp1kp1=slz(i,j+1,k+1)
            slxip1jp1k=slx(i+1,j+1,k)
            slyip1jp1k=sly(i+1,j+1,k)
            slzip1jp1k=slz(i+1,j+1,k)
            slxim1jp1k=slx(i-1,j+1,k)
            slyim1jp1k=sly(i-1,j+1,k)
            slzim1jp1k=slz(i-1,j+1,k)

            sijp1k=s(i,j+1,k,n)
            sijp1km1=s(i,j+1,k-1,n)
            sijp1kp1=s(i,j+1,k+1,n)
            sim1jp1k=s(i-1,j+1,k,n)
            sip1jp1k=s(i+1,j+1,k,n)

            vximhjp1k=velx(i-1,j+1,k)
            vxiphjp1k=velx(i,j+1,k)
            vzijp1kmh=velz(i,j+1,k-1)
            vzijp1kph=velz(i,j+1,k)

c  calculate right y-flux

            if(vxiphjp1k.ge.0)then
               dxd2=dx(i)*.5d0
               gampx=sijp1k+dxd2*slxijp1k
            else
               dxd2=dx(i+1)*.5d0
               gampx=sip1jp1k-dxd2*slxip1jp1k
            endif
            if(vzijp1kph.ge.0)then
               dzd2=dz(k)*.5
               gampz=sijp1k+dzd2*slzijp1k
            else
               dzd2=dz(k+1)*.5
               gampz=sijp1kp1-dzd2*slzijp1kp1
            endif

            if(vximhjp1k.ge.0)then
               dxd2=dx(i-1)*.5d0
               gammx=sim1jp1k+dxd2*slxim1jp1k
            else 
               dxd2=dx(i)*.5d0
               gammx=sijp1k-dxd2*slxijp1k
            endif
            if(vzijp1kmh.ge.0)then
               dzd2=dz(k-1)*.5
               gammz=sijp1km1+dzd2*slzijp1km1
            else 
               dzd2=dz(k)*.5
               gammz=sijp1k-dzd2*slzijp1k
            endif

            stem=sijp1k-dy(j+1)*.5d0*slyijp1k

            phio=phios(i,j+1,k)
            phi=phis(i,j+1,k)

            vdifx=dtd2*(vxiphjp1k*gampx-vximhjp1k*gammx)/dx(i)
            vdifz=dtd2*(vzijp1kph*gampz-vzijp1kmh*gammz)/dz(k)
            vy=vely(i,j+1,k)
            vaddif=stem*dtd2*(vy-vyijphk)/dy(j+1)
            phidif=stem*(phi-phio)
            dyd2=dy(j+1)*.5
            sijphk=sijp1k
     &           -(dyd2+dtd2*df(vyijphk/phi,sijp1k))
     &           *slyijp1k
            sijphk=sijphk-(vdifx+vdifz+vaddif+phidif)/phi

            else
               sijphk=s(i,j+1,k,n) !sijp1k
            endif

         endif

         if (j.ne.0) 
     $        cbar(i,j,k,n)=cbar(i,j,k,n)-dt/dy(j)*vyijphk*sijphk

         if (j.ne.jmax)
     $        cbar(i,j+1,k,n)=cbar(i,j+1,k,n)
     $        +dt/dy(j+1)*vyijphk*sijphk

 150     continue

      enddo
      enddo
      enddo


      do i=1,imax
      do j=1,jmax
      do k=0,kmax
         advFlag = computeTransport
         if(flagwell(i,j,k).eq.1 .or. flagwell(i,j,k+1).eq.1) advFlag=3

         vzijkph=velz(i,j,k)

         if (vzijkph.ge.0.0) then

            if (k.eq.0.and.mynbr(0,0,-1).eq.-1) then
               sijkph=s(i,j,0,n)
               cbar(i,j,k+1,n)=cbar(i,j,k+1,n)
     $              +dt/dz(k+1)*vzijkph*sijkph
               go to 200
            endif

            if (advFlag.eq.2) then

            slxijk=slx(i,j,k)
            slyijk=sly(i,j,k)
            slzijk=slz(i,j,k)
            slxijp1k=slx(i,j+1,k)
            slyijp1k=sly(i,j+1,k)
            slzijp1k=slz(i,j+1,k)
            slxijm1k=slx(i,j-1,k)
            slyijm1k=sly(i,j-1,k)
            slzijm1k=slz(i,j-1,k)
            slxip1jk=slx(i+1,j,k)
            slyip1jk=sly(i+1,j,k)
            slzip1jk=slz(i+1,j,k)
            slxim1jk=slx(i-1,j,k)
            slyim1jk=sly(i-1,j,k)
            slzim1jk=slz(i-1,j,k)

            sijk=s(i,j,k,n)
            sijm1k=s(i,j-1,k,n)
            sijp1k=s(i,j+1,k,n)
            sim1jk=s(i-1,j,k,n)
            sip1jk=s(i+1,j,k,n)
            vximhjk=velx(i-1,j,k)
            vxiphjk=velx(i,j,k)
            vyijmhk=vely(i,j-1,k)
            vyijphk=vely(i,j,k)

            if(vyijphk.ge.0)then
               dyd2=dy(j)*.5
               gampy=sijk+slyijk*dyd2
            else
               dyd2=dy(j+1)*.5d0
               gampy=sijp1k-dyd2*slyijp1k
            endif
            if(vxiphjk.ge.0)then
               dxd2=dx(i)*.5d0
               gampx=sijk+slxijk*dxd2
            else
               dxd2=dx(i+1)*.5d0
               gampx=sip1jk-dxd2*slxip1jk
            endif

            if(vyijmhk.ge.0)then
               dyd2=dy(j-1)*.5
               gammy=sijm1k+dyd2*slyijm1k
            else
               dyd2=dy(j)*.5
               gammy=sijk-dyd2*slyijk
            endif
            if(vximhjk.ge.0)then
               dxd2=dx(i-1)*.5d0
               gammx=sim1jk+dxd2*slxim1jk
            else
               dxd2=dx(i)*.5d0
               gammx=sijk-dxd2*slxijk
            endif

            dzd2=dz(k)*.5
            stem=sijk+dzd2*slzijk

            phio=phios(i,j,k)
            phi=phis(i,j,k)
            vdify=dtd2*(vyijphk*gampy-vyijmhk*gammy)/dy(j)
            vdifx=dtd2*(vxiphjk*gampx-vximhjk*gammx)/dx(i)
            vzijkmh=velz(i,j,k-1)

            vaddif=stem*dtd2*(vzijkph-vzijkmh)/dz(k)
            phidif=stem*(phi-phio)
            dzd2=dz(k)*.5d0
            sijkph=sijk
     &           +(dzd2-.5d0*dt*df(vzijkph/phi,sijk))
     &           *slzijk
            sijkph=sijkph-(vdify+vdifx+vaddif+phidif)/phi

            else
               sijkph= s(i,j,k,n) !sijk
            endif

c vz < 0

         else
            if (k.eq.kmax.and.mynbr(0,0,1).eq.-1) then
               sijkph=s(i,j,kmax+1,n)
               cbar(i,j,k,n)=cbar(i,j,k,n)
     $              -dt/dz(k)*vzijkph*sijkph
               go to 200
            endif

            if (advFlag.eq.2) then

            slxijkp1=slx(i,j,k+1)
            slyijkp1=sly(i,j,k+1)
            slzijkp1=slz(i,j,k+1)
            slxijm1kp1=slx(i,j-1,k+1)
            slyijm1kp1=sly(i,j-1,k+1)
            slzijm1kp1=slz(i,j-1,k+1)
            slxijp1kp1=slx(i,j+1,k+1)
            slyijp1kp1=sly(i,j+1,k+1)
            slzijp1kp1=slz(i,j+1,k+1)
            slxip1jkp1=slx(i+1,j,k+1)
            slyip1jkp1=sly(i+1,j,k+1)
            slzip1jkp1=slz(i+1,j,k+1)
            slxim1jkp1=slx(i-1,j,k+1)
            slyim1jkp1=sly(i-1,j,k+1)
            slzim1jkp1=slz(i-1,j,k+1)

            sijkp1=s(i,j,k+1,n)
            sijm1kp1=s(i,j-1,k+1,n)
            sijp1kp1=s(i,j+1,k+1,n)
            sim1jkp1=s(i-1,j,k+1,n)
            sip1jkp1=s(i+1,j,k+1,n)

            vximhjkp1=velx(i-1,j,k+1)
            vxiphjkp1=velx(i,j,k+1)
            vyijmhkp1=vely(i,j-1,k+1)
            vyijphkp1=vely(i,j,k+1)


            if(vyijphkp1.ge.0)then
               dyd2=dy(j)*.5d0
               gampy=sijkp1+dyd2*slyijkp1
            else
               dyd2=dy(j+1)*.5d0
               gampy=sijp1kp1-dyd2*slyijp1kp1
            endif

            if(vxiphjkp1.ge.0)then
               dxd2=dx(i)*.5d0
               gampx=sijkp1+dxd2*slxijkp1
            else
               dxd2=dx(i+1)*.5d0
               gampx=sip1jkp1-dxd2*slxip1jkp1
            endif

            if(vyijmhkp1.ge.0)then
               dyd2=dy(j-1)*.5d0
               gammy=sijm1kp1+dyd2*slyijm1kp1
            else
               dyd2=dy(j)*.5d0
               gammy=sijkp1-dyd2*slyijkp1
            endif
            if(vximhjkp1.ge.0)then
               dxd2=dx(i-1)*.5d0
               gammx=sim1jkp1+dxd2*slxim1jkp1
            else
               dxd2=dx(i)*.5d0
               gammx=sijkp1-dxd2*slxijkp1
            endif

            dzd2=dz(k+1)*.5
            stem=sijkp1-dzd2*slzijkp1

            phio=phios(i,j,k+1)
            phi=phis(i,j,k+1)

            vdify=dtd2*(vyijphkp1*gampy-vyijmhkp1*gammy)/dy(j)
            vdifx=dtd2*(vxiphjkp1*gampx-vximhjkp1*gammx)/dx(i)
            vz=velz(i,j,k+1)

            vaddif= stem*dtd2*(vz-vzijkph)/dz(k+1)
            phidif=stem*(phi-phio)
            dzd2=dz(k+1)*.5d0
            sijkph=sijkp1
     &           -(dzd2+dtd2*df(vzijkph/phi,sijkp1))*slzijkp1
            sijkph=sijkph-(vdify+vdifx+vaddif+phidif)/phi

            else
               sijkph=s(i,j,k+1,n) !sijkp1
            endif

         endif

         if (k.ne.0) 
     $        cbar(i,j,k,n)=cbar(i,j,k,n)-dt/dz(k)*vzijkph*sijkph

         if (k.ne.kmax)
     $        cbar(i,j,k+1,n)=cbar(i,j,k+1,n)
     $        +dt/dz(k+1)*vzijkph*sijkph

 200     continue


      enddo
      enddo
      enddo

c  correct for wells

      do l=1,nWells
         i=hWellIndex(1,l)
         j=hWellIndex(2,l)
         if (myWell(i,j)) then
            if(wellFlag(l).eq.WELL_INJECTION.or.
     $           wellFlag(l).eq.WELL_REINJECTION) then
               if (wellInj(n,l).gt.0.) then
                  do k=zWellIndexLo(1,l),zWellIndexHi(1,l)
                     vaddif=(velx(i,j,k)-velx(i-1,j,k))/dx(i)
     $                    +(vely(i,j,k)-vely(i,j-1,k))/dy(j)
     $                    +(velz(i,j,k)-velz(i,j,k-1))/dz(k)
                     cbar(i,j,k,n)=cbar(i,j,k,n)
     $                    +wellInj(n,l)*vaddif*dt
                  enddo
               endif
            endif
            if(wellFlag(l).eq.WELL_EXTRACTION.or.
     $           wellFlag(l).eq.WELL_REINJECTION.or.
     $           wellFlag(l).eq.WELL_BOTTOMHOLE_PROD) then
               do k=zWellIndexLo(2,l),zWellIndexHi(2,l)
                  vaddif=(velx(i,j,k)-velx(i-1,j,k))/dx(i)
     $                 +(vely(i,j,k)-vely(i,j-1,k))/dy(j)
     $                 +(velz(i,j,k)-velz(i,j,k-1))/dz(k)
                  vaddif=vaddif/phis(i,j,k)
                  cbar(i,j,k,n)=cbar(i,j,k,n)/(1-dt*vaddif)
               enddo
            endif
         endif
      enddo

      do k=1,kmax
      do j=1,jmax
      do i=1,imax
         cbar(i,j,k,n)=cbar(i,j,k,n)/phis(i,j,k)
         cbar(i,j,k,n)=dmax1(0.0d0,cbar(i,j,k,n))
      enddo
      enddo
      enddo

 9000 continue

 9900 continue

      if(mynbr(-1,0,0).eq.-1) dx(0) = 0.
      if(mynbr(0,-1,0).eq.-1) dy(0) = 0.
      if(mynbr(0,0,-1).eq.-1) dz(0) = 0.
      if(mynbr(1,0,0).eq.-1)  dx(nxc+1) = 0.
      if(mynbr(0,1,0).eq.-1)  dy(nyc+1) = 0.
      if(mynbr(0,0,1).eq.-1)  dz(nzc+1) = 0.

      return
      end

c*******************************************************************
      subroutine slope(i,j,k,slx,sly,slz,slxy,
     $        slxz,slyz,slxyz,n,s,padxc,padyc,padzc,dx,dy,dz,ncomp,
     $     nxc,nyc,nzc,islope)

c  This subroutine calculates x,y,z,xy,xz,yz,and xyz slopes
c  A 3-dimensional slope limiting procedure is used
c
c*******************************************************************
      implicit none
      integer i,j,k,n,padxc,padyc,padzc,ncomp,nxc,nyc,nzc,islope
      real*4  s(-padxc:nxc+padxc+1,-padyc:nyc+padyc+1,
     $     -padzc:nzc+padzc+1,ncomp)
      real*8 dx(-padxc:nxc+padxc+1),dy(-padyc:nyc+padyc+1),
     $     dz(-padzc:nzc+padzc+1)
      real*8 slx,sly,slxy,slz,slxz,slyz,slxyz

      real*8 sc(8),dif(8),smin(8),smax(8),dsign
      real*8 sint(8)
      real*8 sumloc,sumdif,signdif,divp,redfac1,redmax,divn
      real*8 difx1,difx2,difx3,difx4,dify1,dify2
      real*8 alz,hz,alx,hx,aly,hy,b1,b2,b3,b4,b5,b6,b7,b8,smaxx,sminn,
     $     redfac,savg
      integer kdp,kdn,l,ll,ii(8),jj(8),kk(8),kkk,itemp,jtemp,ktemp
ccc:
c      integer mynodex
ccc.

      slx=0.0d0
      sly=0.0d0
      slz=0.0d0
      slxy=0.0d0
      slxz=0.0d0
      slyz=0.0d0
      slxyz=0.0d0

      if (islope.eq.1) then
         if ((s(i+1,j,k,n)-s(i,j,k,n))
     $        *(s(i,j,k,n)-s(i-1,j,k,n)).le.0.0) then
            slx=0.0
         else
            slx=dabs(dble(s(i+1,j,k,n))-dble(s(i,j,k,n)))
     $           /(.5*(dx(i)+dx(i+1)))
            slx=dmin1(slx,dabs(dble(s(i,j,k,n))-dble(s(i-1,j,k,n)))
     $           /(.5*(dx(i-1)+dx(i))))
            slx=slx*dsign(1.0d0,dble(s(i+1,j,k,n))-dble(s(i,j,k,n)))
         endif

         if ((s(i,j+1,k,n)-s(i,j,k,n))
     $        *(s(i,j,k,n)-s(i,j-1,k,n)).le.0.0) then
            sly=0.0
         else
            sly=dabs(dble(s(i,j+1,k,n))-dble(s(i,j,k,n)))
     $           /(.5*(dy(j)+dy(j+1)))
            sly=dmin1(sly,dabs(dble(s(i,j,k,n))-dble(s(i,j-1,k,n)))
     $           /(.5*(dy(j-1)+dy(j))))
            sly=sly*dsign(1.0d0,dble(s(i,j+1,k,n))-dble(s(i,j,k,n)))
         endif

         if ((s(i,j,k+1,n)-s(i,j,k,n))
     $        *(s(i,j,k,n)-s(i,j,k-1,n)).le.0.0) then
            slz=0.0
         else
            slz=dabs(dble(s(i,j,k+1,n))-dble(s(i,j,k,n)))
     $           /(.5*(dz(k)+dz(k+1)))
            slz=dmin1(slz,dabs(dble(s(i,j,k,n))-dble(s(i,j,k-1,n)))
     $           /(.5*(dz(k-1)+dz(k))))
            slz=slz*dsign(1.0d0,dble(s(i,j,k+1,n))-dble(s(i,j,k,n)))
         endif
         return
      endif

      itemp=i
      jtemp=j
      ktemp=k
      ii(1)=i-1
      jj(1)=j-1
      kk(1)=k-1
      ii(2)=i
      jj(2)=j-1
      kk(2)=k-1
      ii(3)=i-1
      jj(3)=j
      kk(3)=k-1
      ii(4)=i
      jj(4)=j
      kk(4)=k-1
      ii(5)=i-1
      jj(5)=j-1
      kk(5)=k
      ii(6)=i
      jj(6)=j-1
      kk(6)=k
      ii(7)=i-1
      jj(7)=j
      kk(7)=k
      ii(8)=i
      jj(8)=j
      kk(8)=k
      do kkk=1,8
         i=ii(kkk)
         j=jj(kkk)
         k=kk(kkk)
         alz=.5d0*(dz(k)+dz(k+1))
         hz=dz(k)*.5d0
         aly=.5d0*(dy(j)+dy(j+1))
         hy=dy(j)*.5d0
         alx=.5d0*(dx(i)+dx(i+1))
         hx=dx(i)*.5d0
         b1=(1.0d0-hx/alx)*(1.0d0-hy/aly)*(1.0d0-hz/alz)*s(i,j,k,n)
         b2=(hx/alx)*(1.0d0-hy/aly)*(1.0d0-hz/alz)*s(i+1,j,k,n)
         b3=(1.0d0-hx/alx)*(hy/aly)*(1.0d0-hz/alz)*s(i,j+1,k,n)
         b4=(hx/alx)*(hy/aly)*(1.0d0-hz/alz)*s(i+1,j+1,k,n)
         b5=(1.0d0-hx/alx)*(1.0d0-hy/aly)*(hz/alz)*s(i,j,k+1,n)
         b6=(hx/alx)*(1.0d0-hy/aly)*(hz/alz)*s(i+1,j,k+1,n)
         b7=(1.0d0-hx/alx)*(hy/aly)*(hz/alz)*s(i,j+1,k+1,n)
         b8=(hx/alx)*(hy/aly)*(hz/alz)*s(i+1,j+1,k+1,n)
     
         sint(kkk)=b1+b2+b3+b4+b5+b6+b7+b8

      enddo

      i=itemp
      j=jtemp
      k=ktemp

      slx=.25d0*(sint(8)+sint(6)+
     &     sint(4)+sint(2)-(sint(7)+sint(5)
     &     +sint(3)+sint(1)))/dx(i)
      sly=.25d0*(sint(8)+sint(7)+sint(4)+
     &     sint(3)-(sint(6)+sint(5)
     &     +sint(2)+sint(1)))/dy(j)
      slz=.25d0*(sint(8)+sint(7)-sint(4)-
     &     sint(3)+sint(6)+sint(5)
     &     -sint(1)-sint(2))/dz(k)
      slxy=.5d0*(sint(8)+sint(4)+sint(5)
     &     +sint(1)-(sint(7)+sint(6)
     &     +sint(3)+sint(2)))/dx(i)/dy(j)
      slxz=.5d0*(sint(8)+sint(6)-(sint(5)
     &     +sint(7))-(sint(4)+sint(2)
     &     -(sint(1)+sint(3))))/dx(i)/dz(k)
      slyz=.5d0*(sint(8)+sint(7)-(sint(5)
     &     +sint(6))-(sint(4)+sint(3)
     &     -(sint(1)+sint(2))))/dx(i)/dy(j)
      difx1=(sint(8)-sint(7))/dx(i)
      difx2=(sint(4)-sint(3))/dx(i)
      difx3=(sint(6)-sint(5))/dx(i)
      difx4=(sint(2)-sint(1))/dx(i)
      dify1=(difx1-difx3)/dy(j)
      dify2=(difx2-difx4)/dy(j)
      slxyz=(dify1-dify2)/dz(k)


      smin(8)=amin1(s(i,j,k,n),s(i+1,j,k,n),s(i,j+1,k,n),
     $     s(i+1,j+1,k,n),s(i,j,k+1,n),s(i+1,j,k+1,n),
     $     s(i,j+1,k+1,n),s(i+1,j+1,k+1,n))
      smax(8)=amax1(s(i,j,k,n),s(i+1,j,k,n),s(i,j+1,k,n),
     $     s(i+1,j+1,k,n),s(i,j,k+1,n),s(i+1,j,k+1,n),
     $     s(i,j+1,k+1,n),s(i+1,j+1,k+1,n))
      smin(7)=amin1(s(i-1,j,k,n),s(i,j,k,n),s(i-1,j+1,k,n),
     $     s(i,j+1,k,n),s(i-1,j,k+1,n),s(i,j,k+1,n),
     $     s(i-1,j+1,k+1,n),s(i,j+1,k+1,n))
      smax(7)=amax1(s(i-1,j,k,n),s(i,j,k,n),s(i-1,j+1,k,n),
     $     s(i,j+1,k,n),s(i-1,j,k+1,n),s(i,j,k+1,n),
     $     s(i-1,j+1,k+1,n),s(i,j+1,k+1,n))
      smin(6)=amin1(s(i,j-1,k,n),s(i+1,j-1,k,n),s(i,j,k,n),
     $     s(i+1,j,k,n),s(i,j-1,k+1,n),s(i+1,j-1,k+1,n),
     $     s(i,j,k+1,n),s(i+1,j,k+1,n))
      smax(6)=amax1(s(i,j-1,k,n),s(i+1,j-1,k,n),s(i,j,k,n),
     $     s(i+1,j,k,n),s(i,j-1,k+1,n),s(i+1,j-1,k+1,n),
     $     s(i,j,k+1,n),s(i+1,j,k+1,n))
      smin(5)=amin1(s(i-1,j-1,k,n),s(i,j-1,k,n),s(i-1,j,k,n),
     $     s(i,j,k,n),s(i-1,j-1,k+1,n),s(i,j-1,k+1,n),
     $     s(i-1,j,k+1,n),s(i,j,k+1,n))
      smax(5)=amax1(s(i-1,j-1,k,n),s(i,j-1,k,n),s(i-1,j,k,n),
     $     s(i,j,k,n),s(i-1,j-1,k+1,n),s(i,j-1,k+1,n),
     $     s(i-1,j,k+1,n),s(i,j,k+1,n))
      smin(4)=amin1(s(i,j,k-1,n),s(i+1,j,k-1,n),s(i,j+1,k-1,n),
     $     s(i+1,j+1,k-1,n),s(i,j,k,n),s(i+1,j,k,n),
     $     s(i,j+1,k,n),s(i+1,j+1,k,n))
      smax(4)=amax1(s(i,j,k-1,n),s(i+1,j,k-1,n),s(i,j+1,k-1,n),
     $     s(i+1,j+1,k-1,n),s(i,j,k,n),s(i+1,j,k,n),
     $     s(i,j+1,k,n),s(i+1,j+1,k,n))
      smin(3)=amin1(s(i-1,j,k-1,n),s(i,j,k-1,n),s(i-1,j+1,k-1,n),
     $     s(i,j+1,k-1,n),s(i-1,j,k,n),s(i,j,k,n),
     $     s(i-1,j+1,k,n),s(i,j+1,k,n))
      smax(3)=amax1(s(i-1,j,k-1,n),s(i,j,k-1,n),s(i-1,j+1,k-1,n),
     $     s(i,j+1,k-1,n),s(i-1,j,k,n),s(i,j,k,n),
     $     s(i-1,j+1,k,n),s(i,j+1,k,n))
      smin(2)=amin1(s(i,j-1,k,n),s(i+1,j-1,k,n),s(i,j,k,n),
     $     s(i+1,j,k,n),s(i,j-1,k-1,n),s(i+1,j-1,k-1,n),
     $     s(i,j,k-1,n),s(i+1,j,k-1,n))
      smax(2)=amax1(s(i,j-1,k,n),s(i+1,j-1,k,n),s(i,j,k,n),
     $     s(i+1,j,k,n),s(i,j-1,k-1,n),s(i+1,j-1,k-1,n),
     $     s(i,j,k-1,n),s(i+1,j,k-1,n))
      smin(1)=amin1(s(i-1,j-1,k,n),s(i,j-1,k,n),s(i-1,j,k,n),
     $     s(i,j,k,n),s(i-1,j-1,k-1,n),s(i,j-1,k-1,n),
     $     s(i-1,j,k-1,n),s(i,j,k-1,n))
      smax(1)=amax1(s(i-1,j-1,k,n),s(i,j-1,k,n),s(i-1,j,k,n),
     $     s(i,j,k,n),s(i-1,j-1,k-1,n),s(i,j-1,k-1,n),
     $     s(i-1,j,k-1,n),s(i,j,k-1,n))

      sc(8)=sint(8)
      sc(7)=sint(7)
      sc(6)=sint(6)
      sc(5)=sint(5)
      sc(4)=sint(4)
      sc(3)=sint(3)
      sc(2)=sint(2)
      sc(1)=sint(1)

      sc(8)=dmax1(dmin1(sc(8),smax(8)),smin(8))
      sc(7)=dmax1(dmin1(sc(7),smax(7)),smin(7))
      sc(6)=dmax1(dmin1(sc(6),smax(6)),smin(6))
      sc(5)=dmax1(dmin1(sc(5),smax(5)),smin(5))
      sc(4)=dmax1(dmin1(sc(4),smax(4)),smin(4))
      sc(3)=dmax1(dmin1(sc(3),smax(3)),smin(3))
      sc(2)=dmax1(dmin1(sc(2),smax(2)),smin(2))
      sc(1)=dmax1(dmin1(sc(1),smax(1)),smin(1))


      smaxx=0.0d0
      sminn=1.d10
      do 5400 l=1,8
         smaxx=dmax1(smaxx,smax(l))
         sminn=dmin1(sminn,smin(l))
 5400 continue
      if (s(i,j,k,n).eq.smaxx.or.s(i,j,k,n).eq.sminn) then
         slx=0.0d0
         sly=0.0d0
         slz=0.0d0
         slxy=0.0d0
         slxz=0.0d0
         slyz=0.0d0
         slxyz=0.0d0
         return
      endif

      do 341 ll=1,8
         sumloc=0.0d0
         do 1340 kkk=1,8
            sumloc=sumloc+sc(kkk)
 1340    continue
         sumloc=sumloc/8.0d0
         sumdif =(sumloc-s(i,j,k,n))*8.0d0
         signdif=dsign(1.0d0,sumdif)
         if (dabs(sumdif).lt.1.d-10)
     $        go to 342
         kdp=0
         kdn=0
         do 1341 kkk=1,8
            dif(kkk)=sc(kkk)-s(i,j,k,n)
c  test to see whether a corner is active
            if (signdif.gt.0.d0.and.
     $           dabs(sc(kkk)-smin(kkk)).lt.1.d-14)
     $           dif(kkk)=0.d0
            if (signdif.lt.0.d0.and.dabs(sc(kkk)
     $           -smax(kkk)).lt.1.d-14)
     $           dif(kkk)=0.d0

c            if (dabs(dif(kkk)).lt.1.d-10) dif(kkk)=0.0d0
            if (dif(kkk).gt.0.d0) kdp=kdp+1
            if (dif(kkk).lt.0.d0) kdn=kdn+1

 1341    continue


         if (signdif.gt.0.d0) then
            divp=dmax1(1.d0,dble(kdp ))
            redfac1=sumdif /divp
            do 285 kkk=1,8
               if (dif(kkk).gt.0.d0) then
c     kdp =kdp -1
                  redmax=sc(kkk)-smin(kkk)
                  redfac=dmin1(redfac1,redmax)
                  sumdif =sumdif-redfac
                  sc(kkk)=sc(kkk)-redfac
               endif
 285        continue

            if (dabs(sumdif).gt.1.d-10) then
               divn=dmax1(1.0d0,dble(kdn ))
               redfac1=sumdif/divn
               do 286 kkk=1,8
                  if (dif(kkk).lt.0.d0) then
c     kdn =kdn -1
                     redmax=sc(kkk)-smin(kkk)
                     redfac=dmin1(redfac1,redmax)
                     sumdif =sumdif -redfac
                     sc(kkk)=sc(kkk)-redfac
                  endif
 286           continue
            endif

         else

            divn=dmax1(1.d0,dble(kdn ))
            redfac1=-sumdif /divn
            do 385 kkk=1,8
               if (dif(kkk).lt.0.d0) then
c     kdn =kdn -1
                  redmax=smax(kkk)-sc(kkk)
                  redfac=dmin1(redfac1,redmax)
                  sumdif =sumdif+redfac
                  sc(kkk)=sc(kkk)+redfac
               endif
 385        continue

            if (dabs(sumdif).gt.1.d-10) then
               divp=dmax1(1.d0,dble(kdp ))
               redfac1=-sumdif/divp
               do 386 kkk=1,8
                  if (dif(kkk).gt.0.0d0) then
                     kdp=kdp -1
                     redmax=smax(kkk)-sc(kkk)
                     redfac=dmin1(redfac1,redmax)
                     sumdif =sumdif +redfac
                     sc(kkk)=sc(kkk)+redfac
                  endif
 386           continue
            endif

         endif
 341  continue
 342  continue


      slx=.25d0*((sc(8)+sc(6)+
     &        sc(4)+sc(2))
     &        -(sc(7)+sc(5)
     &        +sc(3)+sc(1)))/dx(i)
      sly=.25d0*(sc(8)+sc(7)+sc(4)+
     &        sc(3)-(sc(5)+sc(6)
     &        +sc(1)+sc(2)))/dy(j)
      slz=.25d0*(sc(8)+sc(7)-sc(4)-
     &        sc(3)+sc(5)+sc(6)
     &        -sc(1)-sc(2))/dz(k)
      slxy=.5d0*(sc(8)+sc(4)+sc(5)
     &        +sc(1)-(sc(6)+sc(2)
     &        +sc(7)+sc(3)))/dx(i)/dy(j)
      slxz=.5d0*(sc(8)+sc(6)-(sc(5)
     &        +sc(7))-(sc(4)+sc(2)
     &        -(sc(1)+sc(3))))/dx(i)/dz(k)
      slyz=.5d0*(sc(8)+sc(7)-(sc(5)
     &        +sc(6))-(sc(4)+sc(3)
     &        -(sc(1)+sc(2))))/dx(i)/dy(j)
      difx1=(sc(8)-sc(7))/dx(i)
      difx2=(sc(4)-sc(3))/dx(i)
      difx3=(sc(6)-sc(5))/dx(i)
      difx4=(sc(2)-sc(1))/dx(i)
      dify1=(difx1-difx3)/dy(j)
      dify2=(difx2-difx4)/dy(j)
      slxyz=(dify1-dify2)/dz(k)
      savg=.125d0*(sc(1)+sc(2)+sc(3)+sc(4)+
     &     sc(5)+sc(6)+sc(7)+sc(8))
      if (dabs(savg-s(i,j,k,n)).gt.1.d-5) write(6,*)
     &     'slope procedure not preserving average value ',
     &     i,j,k,s(i,j,k,n),savg

      return
      end

