c=======================================================================
c Addition of mass from leaking sources
c
c  tc = current conc time
c  dt = time step (if dt<0, we remove mass--useful to undo a step)
c
c-----------------------------------------------------------------------

      subroutine updateLeaks(conc,totCoef,tc,dt,
     $     leakIndexLo,leakIndexHi,traceType,nLeaks,nSpecies,
     $     jacInv,nxc,nyc,nzc,padxc,padyc,padzc,mynbr)
      implicit none
      include 'mpif.h'
      include 'tmsgtypes.hf'

      integer nLeaks,nSpecies,nxc,nyc,nzc,padxc,padyc,padzc
      real*4  conc(-padxc:nxc+padxc+1,-padyc:nyc+padyc+1,
     $             -padzc:nzc+padzc+1,nSpecies)
      real*4  totCoef(1-padxc:nxc+padxc,1-padyc:nyc+padyc,
     $                1-padzc:nzc+padzc,*)
      real*8  dt, tc, jacInv(nxc,nyc,nzc)
      integer leakIndexLo(3,nLeaks),leakIndexHi(3,nLeaks)
      integer traceType(nSpecies)
      integer mynbr(-1:1,-1:1,-1:1)

      integer i,j,k,specie,leak
      integer nxLo,nyLo,nzLo,nxHi,nyHi,nzHi,ierror

      real*8  AvgLeakRate,amt

c-----------------------------------------------------------------------

      do 1000 leak=1,nLeaks
         nxLo = max(1,leakIndexLo(1,leak))
         nyLo = max(1,leakIndexLo(2,leak))
         nzLo = max(1,leakIndexLo(3,leak))
         nxHi = min(nxc,leakIndexHi(1,leak))
         nyHi = min(nyc,leakIndexHi(2,leak))
         nzHi = min(nzc,leakIndexHi(3,leak))

         do 100 specie=1, nSpecies
            amt = AvgLeakRate(tc,tc+dt,specie,leak)*dt
            if(traceType(specie).ne.0) then
               do 10 k=nzLo, nzHi
               do 10 j=nyLo, nyHi
               do 10 i=nxLo, nxHi
                  conc(i,j,k,specie) = conc(i,j,k,specie)
     $                 + amt / ( totCoef(i,j,k,traceType(specie))
     $                           *jacInv(i,j,k) )
 10            continue
            else
               do 20 k=nzLo, nzHi
               do 20 j=nyLo, nyHi
               do 20 i=nxLo, nxHi
                  conc(i,j,k,specie) = conc(i,j,k,specie)
     $                 + amt/jacInv(i,j,k)
 20            continue               
            endif

            call MPI_Barrier(MPI_COMM_WORLD,ierror)
            call rpadstencil(conc(-padxc,-padyc,-padzc,specie),
     $           1,nxc,nyc,nzc,0,0,0,padxc+1,padyc+1,padzc+1,
     $           mynbr,MSGLEAK,ierror)

 100     continue
 1000 continue

      return
      end
