c=======================================================================
c Fill the exterior padded region with the exterior face values
c
c Note: dir = 1, 2, or 3 and 0 means all directions
c       face = 1 (low) or 2 (high) and 0 means both faces
c
c-----------------------------------------------------------------------

      subroutine padextface (array,stencil,n1,n2,n3,pad1,pad2,pad3,
     $     mynbr,dir,face)
      implicit none

      integer stencil,n1,n2,n3,pad1,pad2,pad3,
     $        mynbr(-1:1,-1:1,-1:1),dir,face
      real*8  array(stencil,1-pad1:n1+pad1,1-pad2:n2+pad2,
     $              1-pad3:n3+pad3)

      integer i,j,k,m

c-----------------------------------------------------------------------

      if((dir.eq.1).or.(dir.eq.0)) then
         if(((face.eq.1).or.(face.eq.0)).and.(mynbr(-1,0,0).eq.-1)) then
            do 10 k=1-pad3,n3+pad3
            do 10 j=1-pad2,n2+pad2
            do 10 i=1-pad1,0
            do 10 m=1,stencil
               array(m,i,j,k) = array(m,1,j,k)
 10         continue
         endif

         if(((face.eq.2).or.(face.eq.0)).and.(mynbr(1,0,0).eq.-1)) then
            do 20 k=1-pad3,n3+pad3
            do 20 j=1-pad2,n2+pad2
            do 20 i=n1+1,n1+pad1
            do 20 m=1,stencil
               array(m,i,j,k) = array(m,n1,j,k)
 20         continue
         endif
      endif

      if((dir.eq.2).or.(dir.eq.0)) then
         if(((face.eq.1).or.(face.eq.0)).and.(mynbr(0,-1,0).eq.-1)) then
            do 30 k=1-pad3,n3+pad3
            do 30 j=1-pad2,0
            do 30 i=1-pad1,n1+pad1
            do 30 m=1,stencil
               array(m,i,j,k) = array(m,i,1,k)
 30         continue
         endif

         if(((face.eq.2).or.(face.eq.0)).and.(mynbr(0,1,0).eq.-1)) then
            do 40 k=1-pad3,n3+pad3
            do 40 j=n2+1,n2+pad2
            do 40 i=1-pad1,n1+pad1
            do 40 m=1,stencil
               array(m,i,j,k) = array(m,i,n2,k)
 40         continue
         endif
      endif

      if((dir.eq.3).or.(dir.eq.0)) then
         if(((face.eq.1).or.(face.eq.0)).and.(mynbr(0,0,-1).eq.-1)) then
            do 50 k=1-pad3,0
            do 50 j=1-pad2,n2+pad2
            do 50 i=1-pad1,n1+pad1
            do 50 m=1,stencil
               array(m,i,j,k) = array(m,i,j,1)
 50         continue
         endif

         if(((face.eq.2).or.(face.eq.0)).and.(mynbr(0,0,1).eq.-1)) then
            do 60 k=n3+1,n3+pad3
            do 60 j=1-pad2,n2+pad2
            do 60 i=1-pad1,n1+pad1
            do 60 m=1,stencil
               array(m,i,j,k) = array(m,i,j,n3)
 60         continue
         endif
      endif

      return
      end
c=======================================================================
c Fill the exterior padded region with the exterior face values
c
c Note: dir = 1, 2, or 3 and 0 means all directions
c       face = 1 (low) or 2 (high) and 0 means both faces
c
c-----------------------------------------------------------------------

      subroutine rpadextface (array,stencil,n1,n2,n3,pad1,pad2,pad3,
     $     mynbr,dir,face)
      implicit none

      integer stencil,n1,n2,n3,pad1,pad2,pad3,
     $        mynbr(-1:1,-1:1,-1:1),dir,face
      real*4  array(stencil,1-pad1:n1+pad1,1-pad2:n2+pad2,
     $              1-pad3:n3+pad3)

      integer i,j,k,m

c-----------------------------------------------------------------------

      if((dir.eq.1).or.(dir.eq.0)) then
         if(((face.eq.1).or.(face.eq.0)).and.(mynbr(-1,0,0).eq.-1)) then
            do 10 k=1-pad3,n3+pad3
            do 10 j=1-pad2,n2+pad2
            do 10 i=1-pad1,0
            do 10 m=1,stencil
               array(m,i,j,k) = array(m,1,j,k)
 10         continue
         endif

         if(((face.eq.2).or.(face.eq.0)).and.(mynbr(1,0,0).eq.-1)) then
            do 20 k=1-pad3,n3+pad3
            do 20 j=1-pad2,n2+pad2
            do 20 i=n1+1,n1+pad1
            do 20 m=1,stencil
               array(m,i,j,k) = array(m,n1,j,k)
 20         continue
         endif
      endif

      if((dir.eq.2).or.(dir.eq.0)) then
         if(((face.eq.1).or.(face.eq.0)).and.(mynbr(0,-1,0).eq.-1)) then
            do 30 k=1-pad3,n3+pad3
            do 30 j=1-pad2,0
            do 30 i=1-pad1,n1+pad1
            do 30 m=1,stencil
               array(m,i,j,k) = array(m,i,1,k)
 30         continue
         endif

         if(((face.eq.2).or.(face.eq.0)).and.(mynbr(0,1,0).eq.-1)) then
            do 40 k=1-pad3,n3+pad3
            do 40 j=n2+1,n2+pad2
            do 40 i=1-pad1,n1+pad1
            do 40 m=1,stencil
               array(m,i,j,k) = array(m,i,n2,k)
 40         continue
         endif
      endif

      if((dir.eq.3).or.(dir.eq.0)) then
         if(((face.eq.1).or.(face.eq.0)).and.(mynbr(0,0,-1).eq.-1)) then
            do 50 k=1-pad3,0
            do 50 j=1-pad2,n2+pad2
            do 50 i=1-pad1,n1+pad1
            do 50 m=1,stencil
               array(m,i,j,k) = array(m,i,j,1)
 50         continue
         endif

         if(((face.eq.2).or.(face.eq.0)).and.(mynbr(0,0,1).eq.-1)) then
            do 60 k=n3+1,n3+pad3
            do 60 j=1-pad2,n2+pad2
            do 60 i=1-pad1,n1+pad1
            do 60 m=1,stencil
               array(m,i,j,k) = array(m,i,j,n3)
 60         continue
         endif
      endif

      return
      end
c=======================================================================
c Fill the exterior padded region with the value val
c
c Note: dir = 1, 2, or 3 and 0 means all directions
c       face = 1 (low) or 2 (high) and 0 means both faces
c
c-----------------------------------------------------------------------

      subroutine rpadextval (array,val8,
     $     stencil,n1,n2,n3,pad1,pad2,pad3,mynbr,dir,face)
      implicit none

      integer stencil,n1,n2,n3,pad1,pad2,pad3,mynbr(-1:1,-1:1,-1:1),
     $        dir,face
      real*4  array(stencil,1-pad1:n1+pad1,1-pad2:n2+pad2,
     $              1-pad3:n3+pad3),val4
      real*8  val8

      integer m,i,j,k

      val4 = val8

      if((dir.eq.1).or.(dir.eq.0)) then
         if(((face.eq.1).or.(face.eq.0)).and.(mynbr(-1,0,0).eq.-1)) then
            do 10 k=1-pad3,n3+pad3
            do 10 j=1-pad2,n2+pad2
            do 10 i=1-pad1,0
            do 10 m=1,stencil
               array(m,i,j,k) = val4
 10         continue
         endif

         if(((face.eq.2).or.(face.eq.0)).and.(mynbr(1,0,0).eq.-1)) then
            do 20 k=1-pad3,n3+pad3
            do 20 j=1-pad2,n2+pad2
            do 20 i=n1+1,n1+pad1
            do 20 m=1,stencil
               array(m,i,j,k) = val4
 20         continue
         endif
      endif

      if((dir.eq.2).or.(dir.eq.0)) then
         if(((face.eq.1).or.(face.eq.0)).and.(mynbr(0,-1,0).eq.-1)) then
            do 30 k=1-pad3,n3+pad3
            do 30 j=1-pad2,0
            do 30 i=1-pad1,n1+pad1
            do 30 m=1,stencil
               array(m,i,j,k) = val4
 30         continue
         endif

         if(((face.eq.2).or.(face.eq.0)).and.(mynbr(0,1,0).eq.-1)) then
            do 40 k=1-pad3,n3+pad3
            do 40 j=n2+1,n2+pad2
            do 40 i=1-pad1,n1+pad1
            do 40 m=1,stencil
               array(m,i,j,k) = val4
 40         continue
         endif
      endif

      if((dir.eq.3).or.(dir.eq.0)) then
         if(((face.eq.1).or.(face.eq.0)).and.(mynbr(0,0,-1).eq.-1)) then
            do 50 k=1-pad3,0
            do 50 j=1-pad2,n2+pad2
            do 50 i=1-pad1,n1+pad1
            do 50 m=1,stencil
               array(m,i,j,k) = val4
 50         continue
         endif

         if(((face.eq.2).or.(face.eq.0)).and.(mynbr(0,0,1).eq.-1)) then
            do 60 k=n3+1,n3+pad3
            do 60 j=1-pad2,n2+pad2
            do 60 i=1-pad1,n1+pad1
            do 60 m=1,stencil
               array(m,i,j,k) = val4
 60         continue
         endif
      endif

      return
      end
c=======================================================================
c Fill the inflow padded region
c
c-----------------------------------------------------------------------

      subroutine padinflow(conc,tc,
     $     bcType,bcRegion1,bcRegion2,bcRegion3,
     $     nSpecies,nxc,nyc,nzc,padxc,padyc,padzc,mynbr)
      implicit none

      include 'bctypes.hf'

      integer nSpecies,nxc,nyc,nzc,padxc,padyc,padzc
      integer bcRegion1(nyc,nzc,0:1),bcRegion2(nxc,nzc,0:1),
     $        bcRegion3(nxc,nyc,0:1),bcType(-1:1)
      real*4  conc(-padxc:nxc+padxc+1,-padyc:nyc+padyc+1,
     $             -padzc:nzc+padzc+1,nSpecies)
      real*8  tc
      integer mynbr(-1:1,-1:1,-1:1)

      integer i,j,k,ii,jj,kk,specie,region
      real*8  CBCValue

c-----------------------------------------------------------------------

      if(mynbr(-1,0,0).eq.-1) then
         do 110 k=-padzc,nzc+padzc+1
            kk = min(nzc,max(1,k))
            do 110 j=-padyc,nyc+padyc+1
               jj = min(nyc,max(1,j))
               do 110 i=-padxc,0
                  region = bcRegion1(jj,kk,0)
                  if (bcType(region).eq.CBCNOFLOW) then
                     do specie=1,nSpecies
                        conc(i,j,k,specie) = conc(1,jj,kk,specie)
                     enddo
                  else
                     do specie=1,nSpecies
                        conc(i,j,k,specie) = CBCValue(tc,specie,region)
                     enddo
                  endif
 110     continue
      endif

      if(mynbr(1,0,0).eq.-1) then
         do 120 k=-padzc,nzc+padzc+1
            kk = min(nzc,max(1,k))
            do 120 j=-padyc,nyc+padyc+1
               jj = min(nyc,max(1,j))
               do 120 i=nxc+1,nxc+padxc+1
                  region = bcRegion1(jj,kk,1)
                  if (bcType(region).eq.CBCNOFLOW) then
                     do specie=1,nSpecies
                        conc(i,j,k,specie) = conc(nxc,jj,kk,specie)
                     enddo
                  else
                     do specie=1,nSpecies
                        conc(i,j,k,specie) = CBCValue(tc,specie,region)
                     enddo
                  endif
 120     continue
      endif

      if(mynbr(0,-1,0).eq.-1) then
         do 210 k=-padzc,nzc+padzc+1
            kk = min(nzc,max(1,k))
            do 210 j=-padyc,0
               do 210 i=-padxc,nxc+padxc+1
                  ii = min(nxc,max(1,i))
                  region = bcRegion2(ii,kk,0)
                  if (bcType(region).eq.CBCNOFLOW) then
                     do specie=1,nSpecies
                        conc(i,j,k,specie) = conc(ii,1,kk,specie)
                     enddo
                  else
                     do specie=1,nSpecies
                        conc(i,j,k,specie) = CBCValue(tc,specie,region)
                     enddo
                  endif
 210     continue
      endif

      if(mynbr(0,1,0).eq.-1) then
         do 220 k=-padzc,nzc+padzc+1
            kk = min(nzc,max(1,k))
            do 220 j=nyc+1,nyc+padyc+1
               do 220 i=-padxc,nxc+padxc+1
                  ii = min(nxc,max(1,i))
                  region = bcRegion2(ii,kk,1)
                  if (bcType(region).eq.CBCNOFLOW) then
                     do specie=1,nSpecies
                        conc(i,j,k,specie) = conc(ii,nyc,kk,specie)
                     enddo
                  else
                     do specie=1,nSpecies
                        conc(i,j,k,specie) = CBCValue(tc,specie,region)
                     enddo
                  endif
 220     continue
      endif

      if(mynbr(0,0,-1).eq.-1) then
         do 310 k=-padzc,0
            do 310 j=-padyc,nyc+padyc+1
               jj = min(nyc,max(1,j))
               do 310 i=-padxc,nxc+padxc+1
                  ii = min(nxc,max(1,i))
                  region = bcRegion3(ii,jj,0)
                  if (bcType(region).eq.CBCNOFLOW) then
                     do specie=1,nSpecies
                        conc(i,j,k,specie) = conc(ii,jj,1,specie)
                     enddo
                  else
                     do specie=1,nSpecies
                        conc(i,j,k,specie) = CBCValue(tc,specie,region)
                     enddo
                  endif
 310     continue
      endif

      if(mynbr(0,0,1).eq.-1) then
         do 320 k=nzc+1,nzc+padzc+1
            do 320 j=-padyc,nyc+padyc+1
               jj = min(nyc,max(1,j))
               do 320 i=-padxc,nxc+padxc+1
                  ii = min(nxc,max(1,i))
                  region = bcRegion3(ii,jj,1)
                  if (bcType(region).eq.CBCNOFLOW) then
                     do specie=1,nSpecies
                        conc(i,j,k,specie) = conc(ii,jj,nzc,specie)
                     enddo
                  else
                     do specie=1,nSpecies
                        conc(i,j,k,specie) = CBCValue(tc,specie,region)
                     enddo
                  endif
 320     continue
      endif

      return
      end
c=======================================================================
c Fill the wells with concentration values
c
c-----------------------------------------------------------------------

      subroutine FillWellConc(conc,tc,
     $     nWells,wellType,locWell,topWell,botWell,
     $     nSpecies,nxc,nyc,nzc,padxc,padyc,padzc,mynbr)
      implicit none

      include '../Main/well.hf'

      integer nSpecies,nxc,nyc,nzc,padxc,padyc,padzc,nWells
      real*8  tc
      real*4  conc(-padxc:nxc+padxc+1,-padyc:nyc+padyc+1,
     $             -padzc:nzc+padzc+1,nSpecies)
      integer wellType(nWells)
      integer locWell(2,nWells),topWell(2,nWells),botWell(2,nWells)
      integer mynbr(-1:1,-1:1,-1:1)

      integer i,j,k,well,specie
      real*8  CWellValue,value

c-----------------------------------------------------------------------

      do 10 well=1,nWells
         if(wellType(well).eq.WELL_INJECTION .or.
     $        wellType(well).eq.WELL_REINJECTION) then
            i = locWell(1,well)
            if(i.lt.1 .or. i.gt.nxc) goto 10
            j = locWell(2,well)
            if(j.lt.1 .or. j.gt.nyc) goto 10

            do 20 specie=1,nSpecies
               value = CWellValue(tc,specie,well)
               do 30 k=topWell(1,well),botwell(1,well)
                  conc(i,j,k,specie) = value
 30            continue
 20         continue
         endif
 10   continue

      return
      end
