#include <stdlib.h>
#include <math.h>
#include "reaction.h"
#include "../Main/ftn.h"

/*#define FORTRAN_ROUTINES uncomment to interface with fortran */

#ifdef FORTRAN_ROUTINES

/* STUBS FOR CALLS TO FORTRAN ROUTINES */

/* Nonequilibrium reactions */
int rxn_react(double* x, double* k, int n, double t, double dt,
              int nDParams, double* dParam, int nIParams, int* iParam) {
  int error;
  RxnReact(x,k,&n,&t,&dt,&nDParams,dParam,&nIParams,iParam,&error);
  return error;
}

/* Equilibrium reactions */
int rxn_equil(double* c, int n, double t, int nDParams, double* dParam,
              int nIParams, int* iParam, double tol) {
  int error;
  RxnEquil(c,&n,&t,&nDParams,dParam,&nIParams,iParam,&tol,&error);
  return error;
}

#else

/* STUBS FOR CALLS TO USER SUPPLIED SPECIALIZED REACTION C ROUTINES */

/* Null nonequilibrium reactions */
int rxn_react(double* x, double* k, int n, double t, double dt, 
              int nDParams, double* dParam, int nIParams, int* iParam) {
  int i;
  for(i=0; i<n; i++) k[i] = 0;
  return 0;
}

/* Null equilibrium reactions */
int rxn_equil(double* c, int n, double t, int nDParams, double* dParam,
              int nIParams, int* iParam, double tol) {
  return 0;
}

#endif
