c=======================================================================
c Open debugging files

      subroutine openTransDebug(myProc, debugUnit)
      implicit none
      integer myProc
      integer debugUnit
      character*4 cmyProc
 
      write(cmyProc,'(i4.4)') myProc
      open(debugunit,file='transDebug'//cmyProc)
 
      return
      end
c=======================================================================
c Close debugging files

      subroutine closeTransDebug(debugUnit)
      implicit none
      integer debugUnit
 
      close(debugunit)
 
      return
      end
c=======================================================================
c Stubs to call 3-D arrays for debugging

      subroutine mydebugout(ivar,itc,b,stencil,n1,n2,n3,nSpecies,
     $     pad1,pad2,pad3,printpad,debugunit)
      implicit none

      integer ivar,itc,stencil,n1,n2,n3,nSpecies,pad1,pad2,pad3,
     $        printpad,debugunit
      real*8  b(stencil,1-pad1:n1+pad1,1-pad2:n2+pad2,1-pad3:n3+pad3,
     $          nSpecies)
      if(ivar.eq.1) then
        call debugout("cbar",itc,b,stencil,n1,n2,n3,nSpecies,
     $        pad1,pad2,pad3,printpad,debugunit)
        return
      endif
      if(ivar.eq.2) then
        call debugout("totCoefInt",itc,b,stencil,n1,n2,n3,nSpecies,
     $        pad1,pad2,pad3,printpad,debugunit)
        return
      endif
      if(ivar.eq.3) then
        call debugout("crhs",itc,b,stencil,n1,n2,n3,nSpecies,
     $        pad1,pad2,pad3,printpad,debugunit)
        return
      endif

      return
      end
c=======================================================================
c Stubs to call 3-D arrays for rdebugging

      subroutine myrdebugout(ivar,itc,b,stencil,n1,n2,n3,nSpecies,
     $     pad1,pad2,pad3,printpad,debugunit)
      implicit none

      integer ivar,itc,stencil,n1,n2,n3,nSpecies,pad1,pad2,pad3,
     $        printpad,debugunit
      real    b(stencil,1-pad1:n1+pad1,1-pad2:n2+pad2,1-pad3:n3+pad3,
     $          nSpecies)
      if(ivar.eq.4) then
        call rdebugout("conc",itc,b,stencil,n1,n2,n3,nSpecies,
     $       pad1,pad2,pad3,printpad,debugunit)
        return
      endif

      return
      end
c=======================================================================
c Write out 3-D arrays for debugging

      subroutine debugout(a,itc,b,stencil,n1,n2,n3,nSpecies,
     $     pad1,pad2,pad3,printpad,debugunit)
      implicit none

      character*(*) a
      integer itc,stencil,n1,n2,n3,nSpecies,pad1,pad2,pad3,
     $        printpad,debugunit
      real*8  b(stencil,1-pad1:n1+pad1,1-pad2:n2+pad2,1-pad3:n3+pad3,
     $          nSpecies)

      integer m,i,j,k,specie,offset1,offset2,offset3

c-----------------------------------------------------------------------

      if(printpad.eq.0) then
         write(debugunit,1010) a,itc
         offset1 = 0
         offset2 = 0
         offset3 = 0
      else
         write(debugunit,1020) a,itc
         offset1 = pad1
         offset2 = pad2
         offset3 = pad3
      endif

      do 10 specie=1,nSpecies
         if(nSpecies.gt.1) write(debugunit,1025) specie
         do 10 m=1,stencil
            if(stencil.gt.1) write(debugunit,1030) m
            do 10 k=1-offset3,n3+offset3
               write(debugunit,1040) k
               do 10 j=1-offset2,n2+offset2
                  write(debugunit,1050) j
                  write(debugunit,1000) (b(m,i,j,k,specie),
     $                 i=1-offset1,n1+offset1)
 10   continue
      write(debugunit,*)

ccc 1000 format(10x,10f11.6)
 1000 format(1p,10x,10e11.3)
 1010 format('DEBUGOUT: ',a,5x,'itc:',i5,5x)
 1020 format('DEBUGOUT: ',a,5x,'itc: ',i3,5x,'(includes padded region)')
 1025 format('specie:',i3)
 1030 format('stencil entry: ',i3)
 1040 format('k: ',i3)
 1050 format('  j: ',i3)

      return
      end
c=======================================================================
c Write out 3-D real*4 arrays for debugging

      subroutine rdebugout(a,itc,b,stencil,n1,n2,n3,nSpecies,
     $     pad1,pad2,pad3,printpad,debugunit)
      implicit none

      character*(*) a
      integer itc,stencil,n1,n2,n3,nSpecies,pad1,pad2,pad3,
     $        printpad,debugunit
      real*4  b(stencil,1-pad1:n1+pad1,1-pad2:n2+pad2,1-pad3:n3+pad3,
     $          nSpecies)

      integer m,i,j,k,specie,offset1,offset2,offset3

c-----------------------------------------------------------------------

      if(printpad.eq.0) then
         write(debugunit,1010) a,itc
         offset1 = 0
         offset2 = 0
         offset3 = 0
      else
         write(debugunit,1020) a,itc
         offset1 = pad1
         offset2 = pad2
         offset3 = pad3
      endif

      do 10 specie=1,nSpecies
         if(nSpecies.gt.1) write(debugunit,1025) specie
         do 10 m=1,stencil
            if(stencil.gt.1) write(debugunit,1030) m
            do 10 k=1-offset3,n3+offset3
               write(debugunit,1040) k
               do 10 j=1-offset2,n2+offset2
                  write(debugunit,1050) j
                  write(debugunit,1000) (b(m,i,j,k,specie),
     $                 i=1-offset1,n1+offset1)
 10   continue
      write(debugunit,*)

ccc 1000 format(10x,10f11.6)
 1000 format(1p,10x,10e11.3)
 1010 format('DEBUGOUT: ',a,5x,'itc:',i5,5x)
 1020 format('DEBUGOUT: ',a,5x,'itc: ',i3,5x,'(includes padded region)')
 1025 format('specie:',i3)
 1030 format('stencil entry: ',i3)
 1040 format('k: ',i3)
 1050 format('  j: ',i3)

      return
      end
c=======================================================================
c Write out 3-D integer arrays for debugging

      subroutine idebugout(a,itc,b,stencil,n1,n2,n3,nSpecies,
     $     pad1,pad2,pad3,printpad,debugunit)
      implicit none

      character*(*) a
      integer itc,stencil,n1,n2,n3,nSpecies,pad1,pad2,pad3,
     $        printpad,debugunit
      integer b(stencil,1-pad1:n1+pad1,1-pad2:n2+pad2,1-pad3:n3+pad3,
     $          nSpecies)

      integer m,i,j,k,specie,offset1,offset2,offset3

c-----------------------------------------------------------------------

      if(printpad.eq.0) then
         write(debugunit,1010) a,itc
         offset1 = 0
         offset2 = 0
         offset3 = 0
      else
         write(debugunit,1020) a,itc
         offset1 = pad1
         offset2 = pad2
         offset3 = pad3
      endif

      do 10 specie=1,nSpecies
         if(nSpecies.gt.1) write(debugunit,1025) specie
         do 10 m=1,stencil
            if(stencil.gt.1) write(debugunit,1030) m
            do 10 k=1-offset3,n3+offset3
               write(debugunit,1040) k
               do 10 j=1-offset2,n2+offset2
                  write(debugunit,1050) j
                  write(debugunit,1000) (b(m,i,j,k,specie),
     $                 i=1-offset1,n1+offset1)
 10   continue
      write(debugunit,*)

 1000 format(1p,10x,10i11)
 1010 format('DEBUGOUT: ',a,5x,'itc:',i5,5x)
 1020 format('DEBUGOUT: ',a,5x,'itc: ',i3,5x,'(includes padded region)')
 1025 format('specie:',i3)
 1030 format('stencil entry: ',i3)
 1040 format('k: ',i3)
 1050 format('  j: ',i3)

      return
      end
c=======================================================================
c set cbar from conc

      subroutine setCbar(cbar,conc,
     $     nSpecies,nxc,nyc,nzc,padxc,padyc,padzc)
      implicit none

      integer nSpecies,nxc,nyc,nzc,padxc,padyc,padzc
      real*8  cbar(nxc,nyc,nzc,nSpecies)
      real*4  conc(-padxc:nxc+padxc+1,-padyc:nyc+padyc+1,
     $             -padzc:nzc+padzc+1,nSpecies)
      integer i,j,k,specie

      do 10 specie=1,nSpecies
      do 10 k=1,nzc
      do 10 j=1,nyc
      do 10 i=1,nxc
         cbar(i,j,k,specie) = conc(i,j,k,specie)
 10   continue

      return
      end
c=======================================================================
c advance cbar into conc (for a single specie)

      subroutine advanceCbar(cbar,conc,nxc,nyc,nzc,padxc,padyc,padzc)
      implicit none

      integer nxc,nyc,nzc,padxc,padyc,padzc
      real*8  cbar(nxc,nyc,nzc)
      real*4  conc(-padxc:nxc+padxc+1,-padyc:nyc+padyc+1,
     $             -padzc:nzc+padzc+1)

      integer i,j,k

      do 10 k=1,nzc
      do 10 j=1,nyc
      do 10 i=1,nxc
         conc(i,j,k) = cbar(i,j,k)
 10   continue

      return
      end
c=======================================================================
c set conc to csol

      subroutine setConc (conc,csol,nxc,nyc,nzc,padxc,padyc,padzc)
      implicit none

      integer nxc,nyc,nzc,padxc,padyc,padzc
      real*8  csol(0:nxc+1,0:nyc+1,0:nzc+1)
      real*4  conc(-padxc:nxc+padxc+1,-padyc:nyc+padyc+1,
     $             -padzc:nzc+padzc+1)

      integer i,j,k

      do 10 k=1,nzc
      do 10 j=1,nyc
      do 10 i=1,nxc
         conc(i,j,k) = csol(i,j,k)
 10   continue

      return
      end
c=======================================================================
c Smooth the conc profile (so conc >= 0)

      subroutine smooth (csol,nxc,nyc,nzc)
      implicit none

      integer nxc,nyc,nzc,i,j,k
      real*8  csol(0:nxc+1,0:nyc+1,0:nzc+1)

      do 10 k = 1, nzc
      do 10 j = 1, nyc
      do 10 i = 1, nxc
ccc:
c         if(csol(i,j,k).lt.0) 
c     $        write(*,*) "warning: mass gain",-csol(i,j,k)
ccc.
         csol(i,j,k) = max(0.0d0,csol(i,j,k))
 10   continue

      return
      end
c=======================================================================
c Define the total concentration

      subroutine defineTotConc(conc,totCoef,
     $     nxc,nyc,nzc,nSpecies,traceType,padxc,padyc,padzc,myNbr)
      implicit none

      integer nxc,nyc,nzc,nSpecies,padxc,padyc,padzc
      integer traceType(nSpecies)
      real*4  conc(-padxc:nxc+padxc+1,-padyc:nyc+padyc+1,
     $             -padzc:nzc+padzc+1,nSpecies)
      real*4  totCoef(1-padxc:nxc+padxc,1-padyc:nyc+padyc,
     $                1-padzc:nzc+padzc,*)
      integer myNbr(-1:1,-1:1,-1:1)

      integer i,j,k,specie,ii,jj,kk
      real*8  byvol

c-----------------------------------------------------------------------
c loop over the concentration mesh

      do 20 specie=1,nSpecies
         if(traceType(specie).ne.0) then
            do 10 k=1,nzc
            do 10 j=1,nyc
            do 10 i=1,nxc
               conc(i,j,k,specie) = conc(i,j,k,specie)
     $              *totCoef(i,j,k,traceType(specie))
 10         continue
         endif
 20   continue

c correct in the external (padded) region

      if(mynbr(-1,0,0).eq.-1) then
         do specie=1,nSpecies
            if(traceType(specie).ne.0) then
               do 110 k=-padzc,nzc+padzc+1
                  kk = min(nzc,max(1,k))
                  do 110 j=-padyc,nyc+padyc+1
                     jj = min(nyc,max(1,j))
                     do 110 i=-padxc,0
                        conc(i,j,k,specie) = conc(i,j,k,specie)
     $                       *totCoef(1,jj,kk,traceType(specie))
 110           continue
            endif
         enddo
      endif

      if(mynbr(1,0,0).eq.-1) then
         do specie=1,nSpecies
            if(traceType(specie).ne.0) then
               do 120 k=-padzc,nzc+padzc+1
                  kk = min(nzc,max(1,k))
                  do 120 j=-padyc,nyc+padyc+1
                     jj = min(nyc,max(1,j))
                     do 120 i=nxc+1,nxc+padxc+1
                        conc(i,j,k,specie) = conc(i,j,k,specie)
     $                       *totCoef(nxc,jj,kk,traceType(specie))
 120           continue
            endif
         enddo
      endif

      if(mynbr(0,-1,0).eq.-1) then
         do specie=1,nSpecies
            if(traceType(specie).ne.0) then
               do 210 k=-padzc,nzc+padzc+1
                  kk = min(nzc,max(1,k))
                  do 210 j=-padyc,0
                     do 210 i=-padxc,nxc+padxc+1
                        ii = min(nxc,max(1,i))
                        conc(i,j,k,specie) = conc(i,j,k,specie)
     $                       *totCoef(ii,1,kk,traceType(specie))
 210          continue
            endif
         enddo
      endif

      if(mynbr(0,1,0).eq.-1) then
         do specie=1,nSpecies
            if(traceType(specie).ne.0) then
               do 220 k=-padzc,nzc+padzc+1
                  kk = min(nzc,max(1,k))
                  do 220 j=nyc+1,nyc+padyc+1
                     do 220 i=-padxc,nxc+padxc+1
                        ii = min(nxc,max(1,i))
                        conc(i,j,k,specie) = conc(i,j,k,specie)
     $                       *totCoef(ii,nyc,kk,traceType(specie))
 220           continue
            endif
         enddo
      endif

      if(mynbr(0,0,-1).eq.-1) then
         do specie=1,nSpecies
            if(traceType(specie).ne.0) then
               do 310 k=-padzc,0
                  do 310 j=-padyc,nyc+padyc+1
                     jj = min(nyc,max(1,j))
                     do 310 i=-padxc,nxc+padxc+1
                        ii = min(nxc,max(1,i))
                        conc(i,j,k,specie) = conc(i,j,k,specie)
     $                       *totCoef(ii,jj,1,traceType(specie))
 310           continue
            endif
         enddo
      endif

      if(mynbr(0,0,1).eq.-1) then
         do specie=1,nSpecies
            if(traceType(specie).ne.0) then
               do 320 k=nzc+1,nzc+padzc+1
                  do 320 j=-padyc,nyc+padyc+1
                     jj = min(nyc,max(1,j))
                     do 320 i=-padxc,nxc+padxc+1
                        ii = min(nxc,max(1,i))
                        conc(i,j,k,specie) = conc(i,j,k,specie)
     $                       *totCoef(ii,jj,nzc,traceType(specie))
 320           continue
            endif
         enddo
      endif

      return
      end
c=======================================================================
c Define concentration from total concentration (undefine total conc)

      subroutine unDefineTotConc(conc,totCoef,
     $     nxc,nyc,nzc,nSpecies,traceType,padxc,padyc,padzc,myNbr)
      implicit none

      integer nxc,nyc,nzc,nSpecies,padxc,padyc,padzc
      integer traceType(nSpecies)
      real*4  conc(-padxc:nxc+padxc+1,-padyc:nyc+padyc+1,
     $             -padzc:nzc+padzc+1,nSpecies)
      real*4  totCoef(1-padxc:nxc+padxc,1-padyc:nyc+padyc,
     $                1-padzc:nzc+padzc,*)
      integer myNbr(-1:1,-1:1,-1:1)

      integer i,j,k,specie,ii,jj,kk
      real*8  byvol

c-----------------------------------------------------------------------
c loop over the concentration mesh

      do 20 specie=1,nSpecies
         if(traceType(specie).ne.0) then
            do 10 k=1,nzc
            do 10 j=1,nyc
            do 10 i=1,nxc
               conc(i,j,k,specie) = conc(i,j,k,specie)
     $              /totCoef(i,j,k,traceType(specie))
 10         continue
         endif
 20   continue

c correct in the external (padded) region

      if(mynbr(-1,0,0).eq.-1) then
         do specie=1,nSpecies
            if(traceType(specie).ne.0) then
               do 110 k=-padzc,nzc+padzc+1
                  kk = min(nzc,max(1,k))
                  do 110 j=-padyc,nyc+padyc+1
                     jj = min(nyc,max(1,j))
                     do 110 i=-padxc,0
                        conc(i,j,k,specie) = conc(i,j,k,specie)
     $                       /totCoef(1,jj,kk,traceType(specie))
 110           continue
            endif
         enddo
      endif

      if(mynbr(1,0,0).eq.-1) then
         do specie=1,nSpecies
            if(traceType(specie).ne.0) then
               do 120 k=-padzc,nzc+padzc+1
                  kk = min(nzc,max(1,k))
                  do 120 j=-padyc,nyc+padyc+1
                     jj = min(nyc,max(1,j))
                     do 120 i=nxc+1,nxc+padxc+1
                        conc(i,j,k,specie) = conc(i,j,k,specie)
     $                       /totCoef(nxc,jj,kk,traceType(specie))
 120           continue
            endif
         enddo
      endif

      if(mynbr(0,-1,0).eq.-1) then
         do specie=1,nSpecies
            if(traceType(specie).ne.0) then
               do 210 k=-padzc,nzc+padzc+1
                  kk = min(nzc,max(1,k))
                  do 210 j=-padyc,0
                     do 210 i=-padxc,nxc+padxc+1
                        ii = min(nxc,max(1,i))
                        conc(i,j,k,specie) = conc(i,j,k,specie)
     $                       /totCoef(ii,1,kk,traceType(specie))
 210          continue
            endif
         enddo
      endif

      if(mynbr(0,1,0).eq.-1) then
         do specie=1,nSpecies
            if(traceType(specie).ne.0) then
               do 220 k=-padzc,nzc+padzc+1
                  kk = min(nzc,max(1,k))
                  do 220 j=nyc+1,nyc+padyc+1
                     do 220 i=-padxc,nxc+padxc+1
                        ii = min(nxc,max(1,i))
                        conc(i,j,k,specie) = conc(i,j,k,specie)
     $                       /totCoef(ii,nyc,kk,traceType(specie))
 220           continue
            endif
         enddo
      endif

      if(mynbr(0,0,-1).eq.-1) then
         do specie=1,nSpecies
            if(traceType(specie).ne.0) then
               do 310 k=-padzc,0
                  do 310 j=-padyc,nyc+padyc+1
                     jj = min(nyc,max(1,j))
                     do 310 i=-padxc,nxc+padxc+1
                        ii = min(nxc,max(1,i))
                        conc(i,j,k,specie) = conc(i,j,k,specie)
     $                       /totCoef(ii,jj,1,traceType(specie))
 310           continue
            endif
         enddo
      endif

      if(mynbr(0,0,1).eq.-1) then
         do specie=1,nSpecies
            if(traceType(specie).ne.0) then
               do 320 k=nzc+1,nzc+padzc+1
                  do 320 j=-padyc,nyc+padyc+1
                     jj = min(nyc,max(1,j))
                     do 320 i=-padxc,nxc+padxc+1
                        ii = min(nxc,max(1,i))
                        conc(i,j,k,specie) = conc(i,j,k,specie)
     $                       /totCoef(ii,jj,nzc,traceType(specie))
 320           continue
            endif
         enddo
      endif

      return
      end
c=======================================================================
c Define the primary phase concentration
c from the total concentration integral (cbar)

      subroutine definePrimaryCBar(cbar,totCoef,byhxc,byhyc,byhzc,
     $     nxc,nyc,nzc,padxc,padyc,padzc,nSpecies,traceType)
      implicit none

      integer nxc,nyc,nzc,padxc,padyc,padzc,nSpecies
      integer traceType(nSpecies)
      real*8  cbar(nxc,nyc,nzc,nSpecies)
      real*4  totCoef(1-padxc:nxc+padxc,1-padyc:nyc+padyc,
     $                1-padzc:nzc+padzc,*)
      real*8  byhxc(nxc),byhyc(nyc),byhzc(nzc)

      integer i,j,k,specie

c-----------------------------------------------------------------------
c loop over the concentration mesh

      do 100 specie=1,nSpecies
         if(traceType(specie).ne.0) then
            do 10 k=1,nzc
            do 10 j=1,nyc
            do 10 i=1,nxc
               if(totCoef(i,j,k,traceType(specie)).ne.0) then
                  cbar(i,j,k,specie) = cbar(i,j,k,specie)
     $                 *byhxc(i)*byhyc(j)*byhzc(k)
     $                 / totCoef(i,j,k,traceType(specie))
               else
                  cbar(i,j,k,specie) = 0
               endif
 10         continue
         else
            do 20 k=1,nzc
            do 20 j=1,nyc
            do 20 i=1,nxc
               cbar(i,j,k,specie)
     $              = cbar(i,j,k,specie)*byhxc(i)*byhyc(j)*byhzc(k)
 20         continue
         endif
 100  continue

      return
      end
c=======================================================================
c Define totCoefInt

      subroutine defineTotCoefInt(totCoefInt,tc,
     $     xc,yc,zc,byhxc,byhyc,byhzc,
     $     nxc,nyc,nzc,padxc,padyc,padzc,ntraceTypes,rwk)
      implicit none

      integer nxc,nyc,nzc,padxc,padyc,padzc,ntraceTypes,i,j,k,type
      real*8  totCoefInt(nxc,nyc,nzc,ntraceTypes),tc
      real*8  byhxc(nxc),byhyc(nyc),byhzc(nzc),byvol,rwk(ntraceTypes)
      real*8  xc(1:nxc+1),yc(1:nyc+1),zc(1:nzc+1)

      do 10 k=1,nzc
      do 10 j=1,nyc
      do 10 i=1,nxc
ccc:
c         byvol = byhxc(i)*byhyc(j)*byhzc(k)
c         do well=1,nWells
c            if((i.eq.locwell(1,well)).and.(j.eq.locwell(2,well)).and.
c     $           ((topWell(1,well).le.k).and.(k.le.botWell(1,well)).or.
c     $           (topWell(2,well).le.k).and.(k.le.botWell(2,well))))then
c               do type=1,ntraceTypes
c                  totCoefInt(i,j,k,type) = 1./byvol  !1.
c               enddo
c               goto 320
c            endif
c         enddo
ccc.
         call evalTotCoefInt(xc(i),yc(j),zc(k),tc,rwk)
         do 20 type=1,ntraceTypes
            totCoefInt(i,j,k,type) = rwk(type)
 20      continue
 10   continue

      return
      end
c=======================================================================
c Define totCoefSimple (simplified! i.e., from totCoefInt)

      subroutine defineTotCoefSimple(totCoef,totCoefInt,
     $     byhxc,byhyc,byhzc,
     $     nxc,nyc,nzc,padxc,padyc,padzc,ntraceTypes,mynbr,ierror)
      implicit none
      include 'mpif.h'
      include 'tmsgtypes.hf'

      integer nxc,nyc,nzc,padxc,padyc,padzc,ntraceTypes,
     $        mynbr(-1:1,-1:1,-1:1),ierror
      real*4  totCoef(1-padxc:nxc+padxc,1-padyc:nyc+padyc,
     $                1-padzc:nzc+padzc,ntraceTypes)
      real*8  totCoefInt(nxc,nyc,nzc,ntraceTypes)
      real*8  byhxc(nxc),byhyc(nyc),byhzc(nzc),byvol
      integer i,j,k,type,ierr

      ierror = 0

      do 20 type=1,ntraceTypes
         do 10 k=1,nzc
         do 10 j=1,nyc
         do 10 i=1,nxc
            byvol = byhxc(i)*byhyc(j)*byhzc(k)
            totCoef(i,j,k,type) = totCoefInt(i,j,k,type)*byvol
 10      continue

c        Communicate padded information for totCoef (mobile types only)

cmpi         call gsyncx()
         call MPI_Barrier(MPI_COMM_WORLD,ierror)
         call rpadstencil(totCoef(1-padxc,1-padyc,1-padzc,type),
     $        1,nxc,nyc,nzc,0,0,0,padxc,padyc,padzc,
     $        mynbr,MSGPADCOEF1,ierr)
         ierror = min(ierror,ierr)
         call rpadextface(totCoef(1-padxc,1-padyc,1-padzc,type),
     $        1,nxc,nyc,nzc,padxc,padyc,padzc,mynbr,0,0)
 20   continue

      if(ierror.ne.0) ierror = 2
      return
      end
c=======================================================================
c Time step control: define deltat
c   deltat = min( (input deltat),
c                 cflFactor*(min pad distance)/(max trace velocity) )

      subroutine cfltimestep(cflFactor,deltat,padDist,
     $     tc,ntraceTypes,xc,yc,zc,nxc,nyc,nzc,padxc,padyc,padzc)
      implicit none
      INTRINSIC sqrt
      include 'mpif.h'
      include 'tmsgtypes.hf'

      integer ntraceTypes,nxc,nyc,nzc,padxc,padyc,padzc
      real*8  cflFactor,deltat,tc,padDist
      real*8  xc(1:nxc+1),yc(1:nyc+1),zc(1:nzc+1)

      integer i,j,k,type,ierror
      real*8  vel(3),speedsq

c-----------------------------------------------------------------------

      speedsq = 0.
      do 20 k=1,nzc+1
      do 20 j=1,nyc+1
      do 20 i=1,nxc+1
         if ( (i.gt.1+padxc).and.(i.lt.nxc+1-padxc).and.
     $        (j.gt.1+padyc).and.(j.lt.nyc+1-padyc).and.
     $        (k.gt.1+padzc).and.(k.lt.nzc+1-padzc) ) goto 20
         do 10 type=1,ntraceTypes
            call evalTraceVel(type,xc(i),yc(j),zc(k),tc,vel)
            speedsq = max(speedsq,vel(1)**2 + vel(2)**2 + vel(3)**2)
 10      continue
 20   continue

      if(speedsq.gt.0)
     $     deltat = min(deltat,cflFactor*padDist/sqrt(speedsq))

cmpi      call gdminx(MSGCFLDT,deltat,1)
      call MSG_f_Gdmin1(deltat,MPI_COMM_WORLD)

      return
      end
c=======================================================================
c Write Reaction Header
c
      subroutine reactionHeader(step, time, dt, debugUnit)
      implicit none

      integer step
      real*8  time, dt
      integer debugUnit

      write(debugUnit,2100) step, time, dt
 2100 format('REACTIONS: ',i5,' time:',1p,e19.11,' dt:',e19.11)

      return
      end
