c ...
c ...   Title:  Blas-like routines for objects used in parcel()
c ...
c ...   Description:  
c ...   
c ...   Created:        Thu May 28 11:13:21 1992
c ...   Author:         Lawrence Cowsar
c ...           <cowsar@masc28.rice.edu>
c ...   
c ...   LastEditDate:   "Thu May 28 11:13:21 1992"
C     
C ...  $Author: mclay $
C ...  $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
C ...  $RCSfile: myblas.f,v $
C ...  $Source: /usr/public/SOURCE/pss/Flow/Parcel/myblas.f,v $
C  
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c These routines are a set of BLAS-like routines on the data types 
c used frequenty in: 
c $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: dcopyBdry
c
c ... File:  myblas.f
c
c ... Main function:
c     Boundary Z? <-- X?
c
c ... Include Files: none
c     
c ... Calls: dscalBdry
c
c ... In: 
c     n?  : dimensions 
c     x?  : Boundary type data
c
c ... Out:
c     z?  : a copy of x?
c
      subroutine dcopyBdry(n1,n2,n3,x1,x2,x3,z1,z2,z3)
      implicit none
      integer n1,n2,n3
      real*8 x1(n2,n3,2),x2(n1,n3,2),x3(n1,n2,2)
      real*8 z1(n2,n3,2),z2(n1,n3,2),z3(n1,n2,2)
c
      integer i1,i2,i3
c
c      call dscalBdry(n1,n2,n3,1.0d0,x1,x2,x3,z1,z2,z3)
            do 10 i3=1,n3
               do 11 i2=1,n2
                  z1(i2,i3,1) = x1(i2,i3,1) 
                  z1(i2,i3,2) = x1(i2,i3,2) 
 11            continue
 10         continue
c     
            do 20 i3=1,n3
               do 21 i1=1,n1
                  z2(i1,i3,1) = x2(i1,i3,1) 
                  z2(i1,i3,2) = x2(i1,i3,2) 
 21            continue
 20         continue
c     
            do 30 i2=1,n2
               do 31 i1=1,n1
                  z3(i1,i2,1) = x3(i1,i2,1) 
                  z3(i1,i2,2) = x3(i1,i2,2) 
 31            continue
 30         continue
c     
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: dscalBdry
c
c ... File:  myblas.f
c
c ... Main function:
c     Boundary Z? <-- a*X?
c
c ... Include Files: none
c     
c ... Calls: daxpbyBdry
c
c ... In: 
c     n?  : dimensions 
c     a   : scaling value
c     x?  : Boundary type data
c
c ... Out:
c     z?  :  x? scaled by a
c
      subroutine dscalBdry(n1,n2,n3,a,x1,x2,x3,z1,z2,z3)
      implicit none
      integer n1,n2,n3
      real*8 a,x1(n2,n3,2),x2(n1,n3,2),x3(n1,n2,2)
      real*8 z1(n2,n3,2),z2(n1,n3,2),z3(n1,n2,2)
c
      call daxpbyBdry(n1,n2,n3,a,x1,x2,x3,0.0d0,x1,x2,x3,z1,z2,z3) 
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: daxpbyBdry
c
c ... File:  myblas.f
c
c ... Main function:
c     Boundary Z? <-- a*X? + b*Y?
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     n?  : dimensions 
c     a   : scaling value
c     x?  : Boundary type data
c     b   : scaling value
c     y?  : Boundary type data
c
c ... Out:
c     z?  :  x? scaled by a  plus y? scaled by b
c 
c ... Comments: 
c     Several cases are handled special for efficientcy
c
      subroutine daxpbyBdry(n1,n2,n3,a,x1,x2,x3,b,y1,y2,y3,z1,z2,z3)
      implicit none
      integer n1,n2,n3
      real*8 a,b
      real*8 x1(n2,n3,2),x2(n1,n3,2),x3(n1,n2,2)
      real*8 y1(n2,n3,2),y2(n1,n3,2),y3(n1,n2,2)
      real*8 z1(n2,n3,2),z2(n1,n3,2),z3(n1,n2,2)
c     
      integer i1,i2,i3
c
c$$$      if (b.eq.0.0d0) then
c$$$c     
c$$$         if (a.eq.1.0d0) then
c$$$c     
c$$$            do 10 i3=1,n3
c$$$               do 11 i2=1,n2
c$$$                  z1(i2,i3,1) = x1(i2,i3,1) 
c$$$                  z1(i2,i3,2) = x1(i2,i3,2) 
c$$$ 11            continue
c$$$ 10         continue
c$$$c     
c$$$            do 20 i3=1,n3
c$$$               do 21 i1=1,n1
c$$$                  z2(i1,i3,1) = x2(i1,i3,1) 
c$$$                  z2(i1,i3,2) = x2(i1,i3,2) 
c$$$ 21            continue
c$$$ 20         continue
c$$$c     
c$$$            do 30 i2=1,n2
c$$$               do 31 i1=1,n1
c$$$                  z3(i1,i2,1) = x3(i1,i2,1) 
c$$$                  z3(i1,i2,2) = x3(i1,i2,2) 
c$$$ 31            continue
c$$$ 30         continue
c$$$c     
c$$$         else
c$$$c     
c$$$            do 110 i3=1,n3
c$$$               do 111 i2=1,n2
c$$$                  z1(i2,i3,1) = a*x1(i2,i3,1) 
c$$$                  z1(i2,i3,2) = a*x1(i2,i3,2) 
c$$$ 111           continue
c$$$ 110        continue
c$$$c     
c$$$            do 120 i3=1,n3
c$$$               do 121 i1=1,n1
c$$$                  z2(i1,i3,1) = a*x2(i1,i3,1) 
c$$$                  z2(i1,i3,2) = a*x2(i1,i3,2) 
c$$$ 121           continue
c$$$ 120        continue
c$$$c     
c$$$            do 130 i2=1,n2
c$$$               do 131 i1=1,n1
c$$$                  z3(i1,i2,1) = a*x3(i1,i2,1) 
c$$$                  z3(i1,i2,2) = a*x3(i1,i2,2) 
c$$$ 131           continue
c$$$ 130        continue
c$$$c     
c$$$         endif
c$$$c     
c$$$      else if ((b.eq.1.0d0).and.(a.eq.1.0d0)) then
c$$$c     
c$$$         do 210 i3=1,n3
c$$$            do 211 i2=1,n2
c$$$               z1(i2,i3,1) = x1(i2,i3,1) + y1(i2,i3,1)
c$$$               z1(i2,i3,2) = x1(i2,i3,2) + y1(i2,i3,2)
c$$$ 211        continue
c$$$ 210     continue
c$$$c     
c$$$         do 220 i3=1,n3
c$$$            do 221 i1=1,n1
c$$$               z2(i1,i3,1) = x2(i1,i3,1) + y2(i1,i3,1)
c$$$               z2(i1,i3,2) = x2(i1,i3,2) + y2(i1,i3,2) 
c$$$ 221        continue
c$$$ 220     continue
c$$$c     
c$$$         do 230 i2=1,n2
c$$$            do 231 i1=1,n1
c$$$               z3(i1,i2,1) = x3(i1,i2,1) + y3(i1,i2,1)
c$$$               z3(i1,i2,2) = x3(i1,i2,2) + y3(i1,i2,2)
c$$$ 231        continue
c$$$ 230     continue
c$$$c     
c$$$      else if (b.eq.1.0d0) then
c$$$c     
c$$$         do 310 i3=1,n3
c$$$            do 311 i2=1,n2
c$$$               z1(i2,i3,1) = a*x1(i2,i3,1) + y1(i2,i3,1)
c$$$               z1(i2,i3,2) = a*x1(i2,i3,2) + y1(i2,i3,2)
c$$$ 311        continue
c$$$ 310     continue
c$$$c     
c$$$         do 320 i3=1,n3
c$$$            do 321 i1=1,n1
c$$$               z2(i1,i3,1) = a*x2(i1,i3,1) + y2(i1,i3,1)
c$$$               z2(i1,i3,2) = a*x2(i1,i3,2) + y2(i1,i3,2) 
c$$$ 321        continue
c$$$ 320     continue
c$$$c     
c$$$         do 330 i2=1,n2
c$$$            do 331 i1=1,n1
c$$$               z3(i1,i2,1) = a*x3(i1,i2,1) + y3(i1,i2,1)
c$$$               z3(i1,i2,2) = a*x3(i1,i2,2) + y3(i1,i2,2)
c$$$ 331        continue
c$$$ 330     continue
c$$$c     
c$$$      else if (a.eq.1.0d0) then
c$$$c     
c$$$         do 410 i3=1,n3
c$$$            do 411 i2=1,n2
c$$$               z1(i2,i3,1) = x1(i2,i3,1) + b*y1(i2,i3,1)
c$$$               z1(i2,i3,2) = x1(i2,i3,2) + b*y1(i2,i3,2)
c$$$ 411        continue
c$$$ 410     continue
c$$$c     
c$$$         do 420 i3=1,n3
c$$$            do 421 i1=1,n1
c$$$               z2(i1,i3,1) = x2(i1,i3,1) + b*y2(i1,i3,1)
c$$$               z2(i1,i3,2) = x2(i1,i3,2) + b*y2(i1,i3,2) 
c$$$ 421        continue
c$$$ 420     continue
c$$$c     
c$$$         do 430 i2=1,n2
c$$$            do 431 i1=1,n1
c$$$               z3(i1,i2,1) = x3(i1,i2,1) + b*y3(i1,i2,1)
c$$$               z3(i1,i2,2) = x3(i1,i2,2) + b*y3(i1,i2,2)
c$$$ 431        continue
c$$$ 430     continue
c$$$c     
c$$$      else
c     
         do 910 i3=1,n3
            do 911 i2=1,n2
               z1(i2,i3,1) = a*x1(i2,i3,1) + b*y1(i2,i3,1)
               z1(i2,i3,2) = a*x1(i2,i3,2) + b*y1(i2,i3,2)
 911        continue
 910     continue
c     
         do 920 i3=1,n3
            do 921 i1=1,n1
               z2(i1,i3,1) = a*x2(i1,i3,1) + b*y2(i1,i3,1)
               z2(i1,i3,2) = a*x2(i1,i3,2) + b*y2(i1,i3,2) 
 921        continue
 920     continue
c     
         do 930 i2=1,n2
            do 931 i1=1,n1
               z3(i1,i2,1) = a*x3(i1,i2,1) + b*y3(i1,i2,1)
               z3(i1,i2,2) = a*x3(i1,i2,2) + b*y3(i1,i2,2)
 931        continue
 930     continue
c     
c$$$      endif
c     
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: dnorm2Bdry
c
c ... File:  myblas.f
c
c ... Main function:
c     return square of L2-norm of boundary type data
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     n?  : dimensions 
c     h?  : mesh spacings (weights)
c     f?  : Boundary type data
c
c ... Out:
c     returns square of L2 norm of f?.
c
      real*8 function dnorm2Bdry(n1,n2,n3,h1,h2,h3,f1,f2,f3)
      implicit none
      integer n1,n2,n3
      real*8 h1(n1),h2(n2),h3(n3)
      real*8 f1(n2,n3,2),f2(n1,n3,2),f3(n1,n2,2)
c
      real*8 ddotBdry
c
      dnorm2Bdry = ddotBdry(n1,n2,n3,h1,h2,h3,f1,f2,f3,f1,f2,f3)
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: ddotBdry
c
c ... File:  myblas.f
c
c ... Main function:
c     return L2-inner product of boundary type data
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     n?  : dimensions 
c     h?  : mesh spacings (weights)
c     f?  : Boundary type data
c     d?  : Boundary type data
c
c ... Out:
c     returns L2-inner product of f? and d?.
c
      real*8 function ddotBdry(n1,n2,n3,h1,h2,h3,f1,f2,f3,d1,d2,d3)
      implicit none
      integer n1,n2,n3
      real*8 h1(n1),h2(n2),h3(n3)
      real*8 f1(n2,n3,2),f2(n1,n3,2),f3(n1,n2,2)
      real*8 d1(n2,n3,2),d2(n1,n3,2),d3(n1,n2,2)
c
      integer i1,i2,i3
c
      ddotBdry = 0.0d0
c
      do 10 i3=1,n3
         do 11 i2=1,n2
            ddotBdry = ddotBdry + f1(i2,i3,1)*d1(i2,i3,1)
            ddotBdry = ddotBdry + f1(i2,i3,2)*d1(i2,i3,2)
 11      continue
 10   continue
c
      do 20 i3=1,n3
         do 21 i1=1,n1
            ddotBdry = ddotBdry + f2(i1,i3,1)*d2(i1,i3,1)
            ddotBdry = ddotBdry + f2(i1,i3,2)*d2(i1,i3,2)
 21      continue
 20   continue
c      
      do 30 i2=1,n2
         do 31 i1=1,n1
            ddotBdry = ddotBdry + f3(i1,i2,1)*d3(i1,i2,1)
            ddotBdry = ddotBdry + f3(i1,i2,2)*d3(i1,i2,2)
 31      continue
 30   continue
c$$$      do 10 i3=1,n3
c$$$         do 11 i2=1,n2
c$$$            ddotBdry = ddotBdry + f1(i2,i3,1)*d1(i2,i3,1)*h2(i2)*h3(i3)
c$$$            ddotBdry = ddotBdry + f1(i2,i3,2)*d1(i2,i3,2)*h2(i2)*h3(i3)
c$$$ 11      continue
c$$$ 10   continue
c$$$c
c$$$      do 20 i3=1,n3
c$$$         do 21 i1=1,n1
c$$$            ddotBdry = ddotBdry + f2(i1,i3,1)*d2(i1,i3,1)*h1(i1)*h3(i3)
c$$$            ddotBdry = ddotBdry + f2(i1,i3,2)*d2(i1,i3,2)*h1(i1)*h3(i3)
c$$$ 21      continue
c$$$ 20   continue
c$$$c      
c$$$      do 30 i2=1,n2
c$$$         do 31 i1=1,n1
c$$$            ddotBdry = ddotBdry + f3(i1,i2,1)*d3(i1,i2,1)*h1(i1)*h2(i2)
c$$$            ddotBdry = ddotBdry + f3(i1,i2,2)*d3(i1,i2,2)*h1(i1)*h2(i2)
c$$$ 31      continue
c$$$ 30   continue
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: dsumBdry
c
c ... File:  myblas.f
c
c ... Main function:
c     return surface integral of boundary type data
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     n?  : dimensions 
c     h?  : mesh spacings (weights)
c     f?  : Boundary type data
c
c ... Out:
c     returns surface integral of f?.
c
      real*8 function dsumBdry(n1,n2,n3,h1,h2,h3,f1,f2,f3)
      implicit none
      integer n1,n2,n3
      real*8 h1(n1),h2(n2),h3(n3)
      real*8 f1(n2,n3,2),f2(n1,n3,2),f3(n1,n2,2)
c
      integer i1,i2,i3
c
      dsumBdry = 0.0d0
c
      do 10 i3=1,n3
         do 11 i2=1,n2
            dsumBdry = dsumBdry + f1(i2,i3,1)*h2(i2)*h3(i3)
            dsumBdry = dsumBdry + f1(i2,i3,2)*h2(i2)*h3(i3)
 11      continue
 10   continue
c
      do 20 i3=1,n3
         do 21 i1=1,n1
            dsumBdry = dsumBdry + f2(i1,i3,1)*h1(i1)*h3(i3)
            dsumBdry = dsumBdry + f2(i1,i3,2)*h1(i1)*h3(i3)
 21      continue
 20   continue
c      
      do 30 i2=1,n2
         do 31 i1=1,n1
            dsumBdry = dsumBdry + f3(i1,i2,1)*h1(i1)*h2(i2)
            dsumBdry = dsumBdry + f3(i1,i2,2)*h1(i1)*h2(i2)
 31      continue
 30   continue
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: dsumBdryNoArea
c
c ... File:  myblas.f
c
c ... Main function:
c     return surface integral of boundary type data
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     n?  : dimensions 
c     h?  : mesh spacings (weights)
c     f?  : Boundary type data
c
c ... Out:
c     returns surface integral of f?.
c
      real*8 function dsumBdryNoArea(n1,n2,n3,f1,f2,f3)
      implicit none
      integer n1,n2,n3
      real*8 f1(n2,n3,2),f2(n1,n3,2),f3(n1,n2,2)
c
      integer i1,i2,i3
c
      dsumBdryNoArea = 0.0d0
c
      do 10 i3=1,n3
         do 11 i2=1,n2
            dsumBdryNoArea = dsumBdryNoArea + f1(i2,i3,1) + f1(i2,i3,2)
 11      continue
 10   continue
c
      do 20 i3=1,n3
         do 21 i1=1,n1
            dsumBdryNoArea = dsumBdryNoArea + f2(i1,i3,1) + f2(i1,i3,2)
 21      continue
 20   continue
c      
      do 30 i2=1,n2
         do 31 i1=1,n1
            dsumBdryNoArea = dsumBdryNoArea + f3(i1,i2,1) + f3(i1,i2,2)
 31      continue
 30   continue
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: dsumPres
c
c ... File:  myblas.f
c
c ... Main function:
c     return integral of Pressure data
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     n?  : dimensions 
c     hx?  : mesh spacings (weights)
c     pres : Pressure type data 
c
c ... Out:
c     returns volume integral of Pressure data.
c
      real*8 function dsumPres(n1,n2,n3,hx1,hx2,hx3,pres)
      implicit none
      integer n1,n2,n3
      real*8 hx1(n1),hx2(n2),hx3(n3),pres(n1,n2,n3)
c
      integer i1,i2,i3
c
      dsumPres = 0.0d0
      do 10 i3 = 1,n3
         do 15 i2 = 1,n2
            do 20 i1 = 1,n1
               dsumPres = dsumPres + pres(i1,i2,i3)*
     $              hx1(i1)*hx2(i2)*hx3(i3)
 20         continue
 15      continue
 10   continue
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: dinitFace
c
c ... File:  myblas.f
c
c ... Main function:
c     initialize a boundary face of data
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     n?  : dimensions 
c     val : value to initialize 
c
c ... Out:
c     face : each element of face "face" set to value "val"
c
      subroutine dinitFace(n1,n2,face,val)
      implicit none
      integer n1,n2
      real*8 face(n1,n2),val
c
      integer i1,i2
c
      do 10 i2 = 1,n2
         do 11 i1 = 1,n1
            face(i1,i2) = val
 11      continue
 10   continue
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: dinitBdry
c
c ... File:  myblas.f
c
c ... Main function:
c     initialize all boundary values to "val"
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     n?  : dimensions 
c     val : value to initialize 
c
c ... Out:
c     l? : each element of each face of l? set to value "val"
c
      subroutine dinitBdry(n1,n2,n3,l1,l2,l3,val)
      implicit none
      integer n1,n2,n3
      real*8 l1(n2,n3,2),l2(n1,n3,2),l3(n1,n2,2),val
c
      integer i1,i2,i3
c
      do 10 i3=1,n3
         do 11 i2=1,n2
            l1(i2,i3,1) = val
            l1(i2,i3,2) = val
 11      continue
 10   continue
c
      do 20 i3=1,n3
         do 21 i1=1,n1
            l2(i1,i3,1) = val
            l2(i1,i3,2) = val
 21      continue
 20   continue
c      
      do 30 i2=1,n2
         do 31 i1=1,n1
            l3(i1,i2,1) = val
            l3(i1,i2,2) = val
 31      continue
 30   continue
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: dinitIFBdry
c
c ... File:  myblas.f
c
c ... Main function:
c     initialize all interface boundary values to "val"
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     mynbr: neighbor nodes
c     n?  : dimensions 
c     val : value to initialize 
c
c ... Out:
c     l? : each element of each face of l? set to value "val"
c
      subroutine dinitIFBdry(mynbr,n1,n2,n3,l1,l2,l3,val)
      implicit none
      integer n1,n2,n3,mynbr(3,2)
      real*8 l1(n2,n3,2),l2(n1,n3,2),l3(n1,n2,2),val
c
      integer i1,i2,i3
c
      do 10 i3=1,n3
         do 11 i2=1,n2
            if (mynbr(1,1).ne.-1)  l1(i2,i3,1) = val
            if (mynbr(1,2).ne.-1)  l1(i2,i3,2) = val
 11      continue
 10   continue
c
      do 20 i3=1,n3
         do 21 i1=1,n1
            if (mynbr(2,1).ne.-1)  l2(i1,i3,1) = val
            if (mynbr(2,2).ne.-1)  l2(i1,i3,2) = val
 21      continue
 20   continue
c      
      do 30 i2=1,n2
         do 31 i1=1,n1
            if (mynbr(3,1).ne.-1)  l3(i1,i2,1) = val
            if (mynbr(3,2).ne.-1)  l3(i1,i2,2) = val
 31      continue
 30   continue
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: dinitNIFBdry
c
c ... File:  myblas.f
c
c ... Main function:
c     initialize all non-interface boundary values to "val"
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     mynbr: neighbor nodes
c     n?  : dimensions 
c     val : value to initialize 
c
c ... Out:
c     l? : each element of each face of l? set to value "val"
c
      subroutine dinitNIFBdry(mynbr,n1,n2,n3,l1,l2,l3,val)
      implicit none
      integer n1,n2,n3,mynbr(3,2)
      real*8 l1(n2,n3,2),l2(n1,n3,2),l3(n1,n2,2),val
c
      integer i1,i2,i3
c
      do 10 i3=1,n3
         do 11 i2=1,n2
            if (mynbr(1,1).eq.-1)  l1(i2,i3,1) = val
            if (mynbr(1,2).eq.-1)  l1(i2,i3,2) = val
 11      continue
 10   continue
c
      do 20 i3=1,n3
         do 21 i1=1,n1
            if (mynbr(2,1).eq.-1)  l2(i1,i3,1) = val
            if (mynbr(2,2).eq.-1)  l2(i1,i3,2) = val
 21      continue
 20   continue
c      
      do 30 i2=1,n2
         do 31 i1=1,n1
            if (mynbr(3,1).eq.-1)  l3(i1,i2,1) = val
            if (mynbr(3,2).eq.-1)  l3(i1,i2,2) = val
 31      continue
 30   continue
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: dInvertBdry
c
c ... File:  myblas.f
c
c ... Main function:
c     initialize all interface boundary values to "val"
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     mynbr: neighbor nodes
c     n?  : dimensions 
c     val : value to initialize 
c
c ... Out:
c     l? : each element of each face of l? set to 1/l?
c
      subroutine dInvertBdry(n1,n2,n3,l1,l2,l3)
      implicit none
      integer n1,n2,n3
      real*8 l1(n2,n3,2),l2(n1,n3,2),l3(n1,n2,2)
c
      integer i1,i2,i3
c
      do 10 i3=1,n3
         do 11 i2=1,n2
           l1(i2,i3,1) = 1./l1(i2,i3,1)
           l1(i2,i3,2) = 1./l1(i2,i3,2)
 11      continue
 10   continue
c
      do 20 i3=1,n3
         do 21 i1=1,n1
            l2(i1,i3,1) = 1./l2(i1,i3,1)
            l2(i1,i3,2) = 1./l2(i1,i3,2)
 21      continue
 20   continue
c      
      do 30 i2=1,n2
         do 31 i1=1,n1
            l3(i1,i2,1) = 1./l3(i1,i2,1)
            l3(i1,i2,2) = 1./l3(i1,i2,2)
 31      continue
 30   continue
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: dinitPres
c
c ... File:  myblas.f
c
c ... Main function:
c     initialize all pressure values to "val"
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     n?  : dimensions 
c     val : value to initialize 
c
c ... Out:
c     pres : each element of "pres"  set to value "val"
c
      subroutine dinitPres(n1,n2,n3,pres,val)
      implicit none
      integer n1,n2,n3
      real*8 pres(n1,n2,n3),val
c
      integer i1,i2,i3
c
      do 10 i3 = 1,n3
         do 11 i2 = 1,n2
            do 12 i1 = 1,n1
               pres(i1,i2,i3) = val
 12         continue
 11      continue
 10   continue
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: daxpbyPres
c
c ... File:  myblas.f
c
c ... Main function:
c     Pressure data type:  Z <-- a*X + b*Y
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     n?  : dimensions 
c     a   : scaling value
c     x   : pressure type data
c     b   : scaling value
c     y   : pressure type data
c
c ... Out:
c     z   :  x? scaled by a  plus y? scaled by b
c 
      subroutine daxpbyPres(n1,n2,n3,a,x,b,y,z)
      implicit none
      integer n1,n2,n3
      real*8 x(n1,n2,n3),y(n1,n2,n3),z(n1,n2,n3),a,b
c
      integer i1,i2,i3
c
      do 10 i3 = 1,n3
         do 11 i2 = 1,n2
            do 12 i1 = 1,n1
               z(i1,i2,i3) = a*x(i1,i2,i3) + b*y(i1,i2,i3)
 12         continue
 11      continue
 10   continue
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: copyIface
c
c ... File:  myblas.f
c
c ... Main function:
c     Copy only faces specified by Mask
c
c ... Include Files: none
c     
c ... Calls: copyface,dinitface
c
c ... In: 
c     mask: if mask.gt.0 then copy otherwise initialize to 0
c     n?  : dimensions 
c     x?  : boundary type data
c
c ... Out:
c     z?  :  x? when mask.gt.0, 0 otherwise.
c 
c ... Comment:
c     Used for copying faces which are interfaces
c
      subroutine copyIface(mask,n1,n2,n3,x1,x2,x3,z1,z2,z3)
      implicit none
      integer mask(3,2),n1,n2,n3
      real*8 x1(n2,n3,2),x2(n1,n3,2),x3(n1,n2,2)
      real*8 z1(n2,n3,2),z2(n1,n3,2),z3(n1,n2,2)
c
      if (mask(1,1).ge.0) then
         call copyface(n2,n3,x1(1,1,1),z1(1,1,1))
      else
         call dinitFace(n2,n3,z1(1,1,1),0.0d0)
      endif
c
      if (mask(1,2).ge.0) then
         call copyface(n2,n3,x1(1,1,2),z1(1,1,2))
      else
         call dinitFace(n2,n3,z1(1,1,2),0.0d0)
      endif
c
      if (mask(2,1).ge.0) then
         call copyface(n1,n3,x2(1,1,1),z2(1,1,1))
      else
         call dinitFace(n1,n3,z2(1,1,1),0.0d0)
      endif
c
      if (mask(2,2).ge.0) then
         call copyface(n1,n3,x2(1,1,2),z2(1,1,2))
      else
         call dinitFace(n1,n3,z2(1,1,2),0.0d0)
      endif
c
      if (mask(3,1).ge.0) then
         call copyface(n1,n2,x3(1,1,1),z3(1,1,1))
      else
         call dinitFace(n1,n2,z3(1,1,1),0.0d0)
      endif
c
      if (mask(3,2).ge.0) then
         call copyface(n1,n2,x3(1,1,2),z3(1,1,2))
      else
         call dinitFace(n1,n2,z3(1,1,2),0.0d0)
      endif
c
      return
      end
c
      subroutine copyfaceComp(n1,n2,x,z)
      implicit none
      integer n1,n2
      real*8 x(n1,n2),z(n1,n2)
c
      integer i1,i2
c     
      do 10 i2 = 1,n2
         do 20 i1 = 1,n1
            z(i1,i2) = 1 - x(i1,i2)
 20      continue
 10   continue
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: copyface
c
c ... File:  myblas.f
c
c ... Main function:
c     Copy a single face worth of data
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     n?  : dimensions 
c     x  : face of data
c
c ... Out:
c     z  :  copy of x
c 
      subroutine copyface(n1,n2,x,z)
      implicit none
      integer n1,n2
      real*8 x(n1,n2),z(n1,n2)
c
      integer i1,i2
c     
      do 10 i2 = 1,n2
         do 20 i1 = 1,n1
            z(i1,i2) = x(i1,i2)
 20      continue
 10   continue
c
c      call WCOPY(n1*n2,x,1,z,1)
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: davgBdry
c
c ... File:  myblas.f
c
c ... Main function:
c     Average two boundary edges data sets
c
c ... Include Files: none
c     
c ... Calls: har
c
c ... In: 
c     type : type of averaging (ARITHMETIC=1,GEOMETRIC=2,HARMONIC=3) 
c     n?  : dimensions 
c     x?  : boundary data type
c     y?  : boundary data type
c
c ... Out:
c     z?  :  average of x? and y?
c 

      subroutine davgBdry(type,n1,n2,n3,x1,x2,x3,y1,y2,y3,z1,z2,z3)
      implicit none
      INTRINSIC sqrt
      integer ARITHMETIC,GEOMETRIC,HARMONIC
      parameter(ARITHMETIC=1,GEOMETRIC=2,HARMONIC=3)
      integer n1,n2,n3,type
      real*8 x1(n2,n3,2),x2(n1,n3,2),x3(n1,n2,2)
      real*8 y1(n2,n3,2),y2(n1,n3,2),y3(n1,n2,2)
      real*8 z1(n2,n3,2),z2(n1,n3,2),z3(n1,n2,2)
c
      integer i1,i2,i3
      real*8 har
c
      if (type.eq.ARITHMETIC) then
         call daxpbyBdry(n1,n2,n3,0.5d0,x1,x2,x3,0.5d0,y1,y2,y3,
     $        z1,z2,z3)
      else
         do 10 i3=1,n3
            do 11 i2=1,n2
               if (type.eq.GEOMETRIC) then
                  z1(i2,i3,1) = sqrt(x1(i2,i3,1)*y1(i2,i3,1))
                  z1(i2,i3,2) = sqrt(x1(i2,i3,2)*y1(i2,i3,2))
               endif
               if (type.eq.HARMONIC) then
                  z1(i2,i3,1) = har(x1(i2,i3,1),y1(i2,i3,1))
                  z1(i2,i3,2) = har(x1(i2,i3,2),y1(i2,i3,2))
               endif
 11      continue
 10   continue
c
      do 20 i3=1,n3
         do 21 i1=1,n1
            if (type.eq.GEOMETRIC) then
               z2(i1,i3,1) = sqrt(x2(i1,i3,1)*y2(i1,i3,1))
               z2(i1,i3,2) = sqrt(x2(i1,i3,2)*y2(i1,i3,2)) 
            endif
            if (type.eq.HARMONIC) then
               z2(i1,i3,1) = har(x2(i1,i3,1),y2(i1,i3,1))
               z2(i1,i3,2) = har(x2(i1,i3,2),y2(i1,i3,2)) 
            endif
 21      continue
 20   continue
c      
      do 30 i2=1,n2
         do 31 i1=1,n1
            if (type.eq.GEOMETRIC) then
               z3(i1,i2,1) = sqrt(x3(i1,i2,1)*y3(i1,i2,1))
               z3(i1,i2,2) = sqrt(x3(i1,i2,2)*y3(i1,i2,2))
            endif
            if (type.eq.HARMONIC) then
               z3(i1,i2,1) = har(x3(i1,i2,1),y3(i1,i2,1))
               z3(i1,i2,2) = har(x3(i1,i2,2),y3(i1,i2,2)) 
            endif
 31      continue
 30   continue
c
      endif
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: ddivideBdry
c
c ... File:  myblas.f
c
c ... Main function:
c     Divide two variable of type Boundary
c
c ... Include Files: none
c     
c ... Calls: har
c
c ... In: 
c     n?  : dimensions 
c     x?  : boundary data type
c     y?  : boundary data type
c
c ... Out:
c     z?  :   x? / y?
c 

      subroutine ddivideBdry(n1,n2,n3,x1,x2,x3,y1,y2,y3,z1,z2,z3)
      implicit none
      integer n1,n2,n3
      real*8 x1(n2,n3,2),x2(n1,n3,2),x3(n1,n2,2)
      real*8 y1(n2,n3,2),y2(n1,n3,2),y3(n1,n2,2)
      real*8 z1(n2,n3,2),z2(n1,n3,2),z3(n1,n2,2)
c
      integer i1,i2,i3
c
      do 10 i3=1,n3
         do 11 i2=1,n2
            z1(i2,i3,1) = x1(i2,i3,1)/y1(i2,i3,1)
            z1(i2,i3,2) = x1(i2,i3,2)/y1(i2,i3,2)
 11      continue
 10   continue
c
      do 20 i3=1,n3
         do 21 i1=1,n1
            z2(i1,i3,1) = x2(i1,i3,1)/y2(i1,i3,1)
            z2(i1,i3,2) = x2(i1,i3,2)/y2(i1,i3,2)
 21      continue
 20   continue
c      
      do 30 i2=1,n2
         do 31 i1=1,n1
            z3(i1,i2,1) = x3(i1,i2,1)/y3(i1,i2,1)
            z3(i1,i2,2) = x3(i1,i2,2)/y3(i1,i2,2)
 31      continue
 30   continue
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: dmultBdry
c
c ... File:  myblas.f
c
c ... Main function:
c     Multiply two variable of type Boundary
c
c ... Include Files: none
c     
c ... Calls: har
c
c ... In: 
c     n?  : dimensions 
c     x?  : boundary data type
c     y?  : boundary data type
c
c ... Out:
c     z?  :   x? * y?
c 

      subroutine dmultBdry(n1,n2,n3,x1,x2,x3,y1,y2,y3,z1,z2,z3)
      implicit none
      integer n1,n2,n3
      real*8 x1(n2,n3,2),x2(n1,n3,2),x3(n1,n2,2)
      real*8 y1(n2,n3,2),y2(n1,n3,2),y3(n1,n2,2)
      real*8 z1(n2,n3,2),z2(n1,n3,2),z3(n1,n2,2)
c
      integer i1,i2,i3
c
      do 10 i3=1,n3
         do 11 i2=1,n2
            z1(i2,i3,1) = x1(i2,i3,1)*y1(i2,i3,1)
            z1(i2,i3,2) = x1(i2,i3,2)*y1(i2,i3,2)
 11      continue
 10   continue
c
      do 20 i3=1,n3
         do 21 i1=1,n1
            z2(i1,i3,1) = x2(i1,i3,1)*y2(i1,i3,1)
            z2(i1,i3,2) = x2(i1,i3,2)*y2(i1,i3,2)
 21      continue
 20   continue
c      
      do 30 i2=1,n2
         do 31 i1=1,n1
            z3(i1,i2,1) = x3(i1,i2,1)*y3(i1,i2,1)
            z3(i1,i2,2) = x3(i1,i2,2)*y3(i1,i2,2)
 31      continue
 30   continue
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c ... Version $Id: myblas.f,v 1.2 1997-05-19 09:38:20-05 mclay Exp $
c
c ... Routine: har
c
c ... File:  myblas.f
c
c ... Main function:
c     return harmonic average with error checking
c
c ... Include Files: none
c     
c ... Calls: none
c
c ... In: 
c     x,y : numbers
c
c ... Out:
c     return harmonic average
c
      real*8 function har(x,y) 
      implicit none
      real*8 x,y
c
      har = x+y
      if (har.ne.0.0d0) then
         har = 2.0d0*x*y/har
      endif
      return
      end



      subroutine daxpbyVel(n1,n2,n3,a,v1,v2,v3,b,w1,w2,w3,z1,z2,z3)
      implicit none
      integer n1,n2,n3
      real*8 a,b
      real*8 v1(0:n1,n2,n3),v2(n1,0:n2,n3),v3(n1,n2,0:n3)
      real*8 w1(0:n1,n2,n3),w2(n1,0:n2,n3),w3(n1,n2,0:n3)
      real*8 z1(0:n1,n2,n3),z2(n1,0:n2,n3),z3(n1,n2,0:n3)
c
      integer i1,i2,i3
c
      do i3 = 1,n3
         do i2 = 1,n2
            do i1 = 0,n1
               z1(i1,i2,i3) = a*v1(i1,i2,i3) + b*w1(i1,i2,i3)
            enddo
         enddo
      enddo
      do i3 = 1,n3
         do i2 = 0,n2
            do i1 = 1,n1
               z2(i1,i2,i3) = a*v2(i1,i2,i3) + b*w2(i1,i2,i3)
            enddo
         enddo
      enddo
      do i3 = 0,n3
         do i2 = 1,n2
            do i1 = 1,n1
               z3(i1,i2,i3) = a*v3(i1,i2,i3) + b*w3(i1,i2,i3)
            enddo
         enddo
      enddo
c
      return
      end
